/*
*  this file contains the following error functions:
*  sys_error (msg)
*  i_error (msg)
*  yyerror (msg)
*  i_warning (msg)
*  msg(msg)
*/

#include <stdio.h>
#include "defs.h"
#include <stdlib.h>

void i_error (char *);
void yyerror (char *);
void i_warning (char *);
void msg(char *);
void yyerror (char *msg);

extern  int yylineno;
void sys_error (char *msg);
void i_error (char *msg);
void i_warning (char *msg);
void msg (char *msg);

void
sys_error (char *msg)
{
fprintf (stderr,"FATAL SYSTEM ERROR: %s\n",msg);  
exit (1);
}

void
i_error (char *msg)
{
fprintf (stderr,"FATAL PROGRAM ERROR: %s\n",msg);  
exit (1);
}

void
i_warning (char *msg)
{
fprintf (stderr,"warning from program: %s\n",msg);  
}

void
msg (char *msg)
{
fprintf (stderr,"%s\n",msg);  
exit (1);
}

void
yyerror (char *msg)
{
fprintf (stderr,"near line %d: %s\n",yylineno,msg);  
}
