// add zap, clean, layout features
/* basic mixing program, based on MIX strategy with standard phrase card
   set by setline.  reset sets number of interrupts pr sec for envelope
   updates.  Still have to put exponential curves in setline.
   The only reason to have 4 almost identical routines here is that
   I cant figure out any other way to always load pointers in 
   registers.  but since this program wont be tinkered with much
   I guess it doesnt hurt.
*/
#include <stdio.h>
#include <unistd.h>
#include <bsd_mem.h>
#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "mix.h"

static SFCODE	ampcode = {
	SF_MAXAMP,
	sizeof(SFMAXAMP) + sizeof(SFCODE)
}; 

extern SFHEADER      sfdesc[NFILES];
extern int  pointer[NFILES]; /* to be used as pointer within sound sndbuf */
extern int  bufsize[NFILES]; /* word length of sndbuf */
extern char *sndbuf[NFILES]; /* address of sndbuf */
extern char peakoff[NFILES];
extern float SR;
extern char *peak[NFILES];

extern 	_backup(int);
extern 	_readit(int);
extern tableset(float,int,float *);
extern float tablei(int,float *,float *);
extern _chkpeak(int);
extern _writeit(int);
extern _forward(int);
extern endnote(int);
extern float * floc(int);
extern fsize(int);
extern char * getsfcode(SFHEADER *,int);
extern double m_dur(float *,int, double *);
extern int setnote(double ,double,int);
extern void closesf();

double test_mix(float *,int, double *);
double relamp(float *,int, double *);
double reset(float *,int, double *);
double global_times(float *,int, double *);
double gen_to_setline(float *,int, double *);
int resetline(float *,int, double *);
double m_setline(float *,int, double *);
double m_add(float *,int, double *);
double m_clobber(float *,int, double *);

double mix(float *,int, double *);
void mixii(void);
void mixif(void);
void mixfi(void);
void mixff(void);

int input,output,non,outch[4],inpch[4];
int inbufsize,outbufsize,nsamps,counter,skip;
double amp,dur,enval;
int clobber;
int test_mix_off = 1;

int lineset = 0;
int relampsign = 0;
float array[SIZE],tabs[2];
int RESET = 200;  /* times per sec to reinitialize envelope */

float begin_line = 0;
float end_line = 0;
int  offset = 0;


double relamp(float *p,int n_args, double *pp)
{
	p=p;
	relampsign = n_args ? pp[0] : 1;
	if(relampsign) printf("Specified input amplitudes will be relative, based on peak amp in header.\n");
	else printf("Specified input amplitudes will be absolute.\n");
    return (0.0);
}

double reset(float *p,int n_args, double *pp)
{
	p=p;n_args=n_args;
	if(pp[0]) RESET = (int)pp[0];
	fprintf(stderr,"Envelope calls set to %d times per sec\n",RESET);
    return (0.0);
}

double global_times(float *p,int n_args, double *pp)
{
	p=p;n_args=n_args;
	begin_line = (float)pp[0]; end_line = (float)pp[1];
	printf("Setline will control from file times %f to %f\n",pp[0],pp[1]);
    return (0.0);
}

double test_mix(float *p,int n_args, double *pp)
{
double output;
	test_mix_off = 0;
	output = mix(p, n_args,pp);
	test_mix_off = 1;
	return(output);
}

double mix(float *p,int n_args, double *pp)
{
	int jj;
	char *cp;
	float opeak,*pk;
	SFMAXAMP sfm;

	p=p;
	input = 0; 
	output = 1;
	if(!pp[2]) pp[2] = m_dur(&p[2],1,&pp[2]);
	dur = (pp[2] < 0) ? -pp[2] : (pp[2] - pp[0]);
	if(!lineset) {
		for(jj=0; jj<SIZE; jj++) array[jj] = 1;
		fprintf(stderr,"Set phrase curve to all 1's\n");
		lineset = 1;
		}
	setnote(pp[0],dur,input);
	nsamps = setnote(pp[1],dur,output);
	_backup(output);

	inbufsize = bufsize[input];
	outbufsize = bufsize[output];

	if(end_line) dur = end_line - begin_line;
	tableset((float)dur,SIZE,tabs);
	if(end_line)   /* this will give us global timefor setline */
		offset = (pp[1] - begin_line) * SR;
	else offset = 0;
//printf("dur,offset,end_line,begin_line %f %d %f %f\n",dur,offset,end_line,begin_line);
				
	skip = SR/(float)RESET;  /* number of samples between reinits */
	counter = 0;  /* initialize counter */

	if(!relampsign) amp = pp[3];
	else	{
		cp = getsfcode(&sfdesc[input],SF_MAXAMP);
		bcopy(cp + sizeof(SFCODE), (char *) &sfm, sizeof(SFMAXAMP));
//		memmove((char *) &sfm,cp + sizeof(SFCODE),  sizeof(SFMAXAMP));
		for(jj=0,opeak=0; jj<sfchans(&sfdesc[input]); jj++) 
		if(sfmaxamp(&sfm,jj) > opeak) opeak = sfmaxamp(&sfm,jj);
		printf("Peak amplitude of input file is %e\n",opeak);
		amp = pp[3]/opeak;
	}

	non=0;
	for(jj = 0; jj<sfchans(&sfdesc[input]); jj++) {
		if((jj+4) > (n_args - 1)) break;
		if(pp[4+jj] >= 0) {
			if((outch[non] = pp[4+jj]) >= sfchans(&sfdesc[output])) {
				printf(" Wrong number of channels on output\n");
			closesf(); }
		inpch[non++] = jj;
		}
	}
	pk = (float *)peak[output];

	if(sfclass(&sfdesc[input]) == SHORT) {
		if(sfclass(&sfdesc[output]) == SHORT) {
			mixii();
			return(MAX(pk[0],pk[1]));
		}
		if(sfclass(&sfdesc[output]) == FLOAT) {
			mixif();
			return(MAX(pk[0],pk[1]));
		}
	}
	else {
		if(sfclass(&sfdesc[output]) == SHORT) {
			mixfi();
			return(MAX(pk[0],pk[1]));
		}
		if(sfclass(&sfdesc[output]) == FLOAT) {
			mixff();
			return(MAX(pk[0],pk[1]));
		}
	}
	return(0.0);
}

void
mixii()
{
	short *ibuf,*obuf;
	int loop,jj,ipoint,opoint;
	int inchnl,outchnl;

	ibuf = (short *)sndbuf[input];
	obuf = (short *)sndbuf[output];
	inchnl = sfchans(&sfdesc[input]);
	outchnl = sfchans(&sfdesc[output]);
	opoint=pointer[output];   /* copy to save offset lookups every time*/
	ipoint=pointer[input];
	loop=nsamps;

	if(!clobber) while(loop--) 	{ 
		if(!counter--) {
			enval = (double)tablei(nsamps+1-loop+offset,array,tabs) * amp;
			counter = skip;
			}
		for(jj = 0; jj<non; jj++) 
			    *(obuf + opoint + outch[jj]) += enval * 
			              *(ibuf + ipoint + inpch[jj]); 

		ipoint += inchnl;
		opoint += outchnl;

		if(ipoint >= inbufsize ) {
			ipoint = 0;
			if(_readit(input) == 0) {
			      fprintf(stderr,"reached eof on input\n");
			      goto out;
			}
		}
		if(opoint >= outbufsize ) {
			pointer[output] = opoint;
			if(!peakoff[output]) _chkpeak(output);
			if(test_mix_off) _writeit(output);
			else _forward(output);
			_readit(output);
			_backup(output);
			opoint = 0;
		}
	}
	else while(loop--) 	{ 
		if(!counter--) {
			enval = (double)tablei(nsamps+1-loop+offset,array,tabs) * amp;
			counter = skip;
			}
		for(jj = 0; jj<non; jj++) 
			    *(obuf + opoint + outch[jj]) = enval * 
			              *(ibuf + ipoint + inpch[jj]); 

		ipoint += inchnl;
		opoint += outchnl;

		if(ipoint >= inbufsize ) {
			ipoint = 0;
			if(_readit(input) == 0) {
			      fprintf(stderr,"reached eof on input\n");
			      goto out;
			}
		}
		if(opoint >= outbufsize ) {
			pointer[output] = opoint;
			if(!peakoff[output]) _chkpeak(output);
			if(test_mix_off) _writeit(output); else _forward(output);
			_readit(output);
			_backup(output);
			opoint = 0;
		}
	}
out:    pointer[input] = ipoint;
	pointer[output] = opoint;

	if(test_mix_off){ 
		_writeit(output); 
		endnote(output);
	}	
	else {
		_forward(output);
		endnote(-output);
	}
}
void
mixif()
{
	short *ibuf;
	float *obuf;
	int loop,jj,ipoint,opoint;
	int inchnl,outchnl;

	ibuf = (short *)sndbuf[input];
	obuf = (float *)sndbuf[output];
	inchnl = sfchans(&sfdesc[input]);
	outchnl = sfchans(&sfdesc[output]);
	opoint=pointer[output];   /* copy to save offset lookups every time*/
	ipoint=pointer[input];
	loop=nsamps;

	if(!clobber) while(loop--) 	{ 
		if(!counter--) {
			enval = (double)tablei(nsamps+1-loop+offset,array,tabs) * amp;
			counter = skip;
			}
		for(jj = 0; jj<non; jj++) 
			    *(obuf + opoint + outch[jj]) += enval * 
			              *(ibuf + ipoint + inpch[jj]); 
		ipoint += inchnl;
		opoint += outchnl;

		if(ipoint >= inbufsize ) {
			ipoint = 0;
			if(_readit(input) == 0) {
			      fprintf(stderr,"reached eof on input\n");
			      goto out;
			}
		}
		if(opoint >= outbufsize ) {
			pointer[output] = opoint;
			if(!peakoff[output]) _chkpeak(output);
			if(test_mix_off) _writeit(output); else _forward(output);
			_readit(output);
			_backup(output);
			opoint = 0;
		}
	}
	else while(loop--) 	{ 
		if(!counter--) {
			enval = (double)tablei(nsamps+1-loop+offset,array,tabs) * amp;
			counter = skip;
			}
		for(jj = 0; jj<non; jj++) 
			    *(obuf + opoint + outch[jj]) = enval * 
			              *(ibuf + ipoint + inpch[jj]); 

		ipoint += inchnl;
		opoint += outchnl;

		if(ipoint >= inbufsize ) {
			ipoint = 0;
			if(_readit(input) == 0) {
			      fprintf(stderr,"reached eof on input\n");
			      goto out;
			}
		}
		if(opoint >= outbufsize ) {
			pointer[output] = opoint;
			if(!peakoff[output]) _chkpeak(output);
			if(test_mix_off) _writeit(output); else _forward(output);
			_readit(output);
			_backup(output);
			opoint = 0;
		}
	}
out:    pointer[input] = ipoint;
	pointer[output] = opoint;
	
	if(test_mix_off){ 
		_writeit(output); 
		endnote(output);
	}	
	else {
		_forward(output);
		endnote(-output);
	}
}
void
mixfi()
{
	float *ibuf;
	short *obuf;
	int loop,jj,ipoint,opoint;
	int inchnl,outchnl;

	ibuf = (float *)sndbuf[input];
	obuf = (short *)sndbuf[output];
	inchnl = sfchans(&sfdesc[input]);
	outchnl = sfchans(&sfdesc[output]);
	opoint=pointer[output];   /* copy to save offset lookups every time*/
	ipoint=pointer[input];
	loop=nsamps;

	if(!clobber) while(loop--) 	{ 
		if(!counter--) {
			enval = (double)tablei(nsamps+1-loop+offset,array,tabs) * amp;
			counter = skip;
			}
		for(jj = 0; jj<non; jj++) 
			    *(obuf + opoint + outch[jj]) += enval * 
			              *(ibuf + ipoint + inpch[jj]); 

		ipoint += inchnl;
		opoint += outchnl;

		if(ipoint >= inbufsize ) {
			ipoint = 0;
			if(_readit(input) == 0) {
			      fprintf(stderr,"reached eof on input\n");
			      goto out;
			}
		}
		if(opoint >= outbufsize ) {
			pointer[output] = opoint;
			if(!peakoff[output]) _chkpeak(output);
			if(test_mix_off) _writeit(output); else _forward(output);
			_readit(output);
			_backup(output);
			opoint = 0;
		}
	}
	else while(loop--) 	{ 
		if(!counter--) {
			enval = (double)tablei(nsamps+1-loop+offset,array,tabs) * amp;
			counter = skip;
			}
		for(jj = 0; jj<non; jj++) 
			    *(obuf + opoint + outch[jj]) = enval * 
			              *(ibuf + ipoint + inpch[jj]); 

		ipoint += inchnl;
		opoint += outchnl;

		if(ipoint >= inbufsize ) {
			ipoint = 0;
			if(_readit(input) == 0) {
			      fprintf(stderr,"reached eof on input\n");
			      goto out;
			}
		}
		if(opoint >= outbufsize ) {
			pointer[output] = opoint;
			if(!peakoff[output]) _chkpeak(output);
			if(test_mix_off) _writeit(output); else _forward(output);
			_readit(output);
			_backup(output);
			opoint = 0;
		}
	}
out:    pointer[input] = ipoint;
	pointer[output] = opoint;
	
	if(test_mix_off){ 
		_writeit(output); 
		endnote(output);
	}	
	else {
		_forward(output);
		endnote(-output);
	}
}

void
mixff()
{
	float *ibuf,*obuf;
	int loop,jj,ipoint,opoint;
	int inchnl,outchnl;

	ibuf = (float *)sndbuf[input];
	obuf = (float *)sndbuf[output];
	inchnl = sfchans(&sfdesc[input]);
	outchnl = sfchans(&sfdesc[output]);
	opoint=pointer[output];   /* copy to save offset lookups every time*/
	ipoint=pointer[input];
	loop=nsamps;

	if(!clobber) while(loop--) 	{ 
		if(!counter--) {
			enval = (double)tablei(nsamps+1-loop+offset,array,tabs) * amp;
			counter = skip;
			}
		for(jj = 0; jj<non; jj++) 
			    *(obuf + opoint + outch[jj]) += enval * 
			              *(ibuf + ipoint + inpch[jj]); 

		ipoint += inchnl;
		opoint += outchnl;

		if(ipoint >= inbufsize ) {
			ipoint = 0;
			if(_readit(input) == 0) {
			      fprintf(stderr,"reached eof on input\n");
			      goto out;
			}
		}
		if(opoint >= outbufsize ) {
			pointer[output] = opoint;
			if(!peakoff[output]) _chkpeak(output);
			if(test_mix_off) _writeit(output); else _forward(output);
			_readit(output);
			_backup(output);
			opoint = 0;
		}
	}
	else while(loop--) 	{ 
		if(!counter--) {
			enval = (double)tablei(nsamps+1-loop+offset,array,tabs) * amp;
			counter = skip;
			}
		for(jj = 0; jj<non; jj++) 
			    *(obuf + opoint + outch[jj]) = enval * 
			              *(ibuf + ipoint + inpch[jj]); 

		ipoint += inchnl;
		opoint += outchnl;

		if(ipoint >= inbufsize ) {
			ipoint = 0;
			if(_readit(input) == 0) {
			      fprintf(stderr,"reached eof on input\n");
			      goto out;
			}
		}
		if(opoint >= outbufsize ) {
			pointer[output] = opoint;
			if(!peakoff[output]) _chkpeak(output);
			if(test_mix_off) _writeit(output); else _forward(output);
			_readit(output);
			_backup(output);
			opoint = 0;
		}
	}
out:    pointer[input] = ipoint;
	pointer[output] = opoint;
	
	if(test_mix_off){ 
		_writeit(output); 
		endnote(output);
	}	
	else {
		_forward(output);
		endnote(-output);
	}
}

double
gen_to_setline(float *p,int n_args, double *pp)
{
	float *f;
	int i;
	p=p;n_args=n_args;
	f = floc((int)pp[0]);
	if(fsize((int)pp[0]) != SIZE) {
		printf("Gen function must have size %d.\n", SIZE);
		closesf();
		}
	for(i=0; i<SIZE; i++) array[i] = f[i];
	printf("Copied function %d to setline array\n",(int)pp[0]);
	lineset = 1;
	return(0.0);
}

int
resetline(float *p,int n_args, double *pp)
{
	double increm;
	int i,j,k,points;

	p=p;
	if((n_args % 2) != 0) {
		fprintf(stderr,"Something wrong with phrase, check args in mix\n");
		closesf();
	}

	lineset = 1;   /* initialized array */
	increm = (double)(pp[n_args - 2] - pp[0])/(double)SIZE;
	for(j=0,i=0; j < (n_args-2); j += 2) {
		points = (int)((double)(pp[j+2] - pp[j]) / increm +.5);
		if(pp[j+2] != pp[j]) {
			if(points <= 0) points = 1;
			if((pp[j+2] < pp[j]) || (points > SIZE)) {
				fprintf(stderr," confusion on phrase card\n");
				closesf();
				}
			for(k=0; k < points; k++) {
				array[i++] *= ((float)k/(float)points)
					* (pp[j+3] - pp[j+1]) + pp[j+1];
				if(i == SIZE) return (0);
			}
		}
	}
	i--;
	while(++i < SIZE) array[i] = array[i-1];
	return(0);
}

//NOTE int setline(double *,int,int ,float *); in lib/setline.c
double
m_setline(float *p,int n_args, double *pp)
{
	double increm;
	int i,j,k,points;

	p=p;
	if((n_args % 2) != 0) {
		fprintf(stderr,"Something wrong with phrase, check args for mix setline\n");
		closesf();
	}

	lineset = 1;   /* initialized array */
	increm = (double)(pp[n_args - 2] - pp[0])/(double)SIZE;
	for(j=0,i=0; j < (n_args-2); j += 2) {
		points = (int)((double)(pp[j+2] - pp[j]) / increm +.5);
		if(pp[j+2] != pp[j]) {
			if(points <= 0) points = 1;
			if((pp[j+2] < pp[j]) || (points > SIZE)) {
				fprintf(stderr," confusion on phrase card\n");
				closesf();
				}
			for(k=0; k < points; k++) {
				array[i++] = ((float)k/(float)points)
					* (pp[j+3] - pp[j+1]) + pp[j+1];
				if(i == SIZE) return(0.0);
			}
		}
	}
	i--;
	while(++i < SIZE) array[i] = array[i-1]; 
	return(0.0);
}

double
m_clobber(float *p,int n_args, double *pp)
{
	p=p;n_args=n_args;pp=pp;
 fprintf(stderr,"You will be writing over (erasing) all channels.\n");
 clobber = 1;
	return(0.0);
}

double
m_add(float *p,int n_args, double *pp)
{
	p=p;n_args=n_args;pp=pp;
	fprintf(stderr,"You will be adding (mixing) to all channels.\n");
	clobber = 0;
	return(0.0);
}


