#include "../H/ugens.h"
#include "../H/sfheader.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/fcntl.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <unistd.h>

#define NORM(x,y) ((float) (y) / (float) (x == SF_SHORT ? 32767.0 : 1.0))

//#ifndef LINT
//static char SccsId[] = "@(#)sndpeak.c	1.7	10/29/85	IRCAM";
//#endif

# define CONTINUE error++; continue

/* This program is designed to find the peak absolute value of an existing 
   soundfile and put it in the header */

extern int readHeader(int,SFHEADER *);
extern int putsfcode(SFHEADER *,void *,SFCODE *);
extern int getsfcode(SFHEADER *, int);
extern SFMAXAMP *getmaxamp(int fd, int update,long startsampf,long dursampf);

double maxamp = 0.0;
long totalbytes, maxloc;

main(int argc,char *argv[])
{
	int sfd,error = 0;
	int update,i;
	long sampframes,sampframesby4;
	struct stat st;
	SFHEADER sfh;
	SFMAXAMP *sfm;
//	char *sfname;
	
	if(argc == 1) {
		usage:		printf("usage: inputfile\n");
		exit(0);
	}

	while(--argc) {
		update = 1;
		if((sfd = open(*++argv,O_RDWR)) == -1) {
			if((sfd = open(*argv,O_RDONLY)) == -1) {
				fprintf(stderr,"Can't find soundfile %s\n",*argv);
				CONTINUE;
			}
			fprintf(stderr,"Can't update file %s - reading only!\n",*argv);
			update = 0;
		}

		if(rheader(sfd,&sfh)) {
			fprintf(stderr,"Bad header read for %s\n",*argv);
			CONTINUE;
		}
		
		if(fstat(sfd,&st)) {
			fprintf(stderr,"Bad stat() for %s\n",*argv);
			CONTINUE;
		}

		sampframes = sfbsize(&st) / sfchans(&sfh) / sfclass(&sfh);
		sampframesby4 = sfbsize(&st);
printf("fd,%d sampframes %d chans %d class %d size %d\n",sfd,sampframes,sfchans(&sfh), sfclass(&sfh),sampframesby4);

		if((sfm = getmaxamp(sfd,update,0,sampframes)) == NULL) {
			fprintf(stderr,"Bad return from getmaxamp\n");
			CONTINUE;
		}

		for(i = 0; i < sfchans(&sfh); i++) {
			printf("channel %d = ",i + 1);
			if(sfmaxamp(sfm,i)) 
				printf("%f (absolute %f) at sample location %d\n",
				NORM(sfclass(&sfh),sfmaxamp(sfm,i)),
				sfmaxamp(sfm,i),sfmaxamploc(sfm,i));
			else
				printf("silence\n");
		}
		close(sfd);
	}
	exit(error);
	return 0;
}
