#include "/musr/H/NeXTsfheader.h"
#include "/musr/H/ugens.h"
#import <sound/soundstruct.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <carl/carl.h>
#include <carl/procom.h>
#include <carl/defaults.h>
#include <sys/stat.h>

#define SIZE 131072 

float array[2][SIZE];
float tabs[2][2];                
float warparray[2][SIZE];
float warptabs[2][2];                
float ringarray[2][SIZE];
float ringtabs[2][2];
float rangearray[2][SIZE];
float rangetabs[2][2];                
float dryarray[SIZE];
float drytabs[2]; 
int haswindow = 0;                 

#define NCMAX 16777216
extern SFHEADER sfdesc[NFILES];

int sferror;
int sinbuf;
int tail;
int	input,output;
int	ichan;		/* impulse channels from header */

float *sbuf[2],  		/* array for input and FFT */
  		*tbuf[2],  		/* array for overlap-adding output */
			*filt[2],		/* array for filter transform */
			*dry[2];		/* array for dry signal*/

/*-------------------------------------------------------
			convolve.c

This program performs fast convolution via the FFT.

-------------------------------------------------------*/

double convolve(p,n_args)
float *p;
int n_args;
{
  
float	a,		/* temporary */
			b,		/* temporary */
			temp,		/* temporary */
			fmag,
  		srate,		/* sample rate from header */
			gain = 1.,	/* gain */
			max = 0.;	/* maximum */

long	i,
			j,
			icnt[2],		/* counts input samples */
			ocnt[2], 	/* counts output samples */
			N,		/* FFT size is twice impulse response */
			N2,		/* N / 2 */
			ip,		/* temporary pointer */
			ip1;		/* temporary pointer */

int		invert = 0,	/* flag for deconvolution */
			zeroError = 0;

/* bicsf declarations */
int fd,		/* file descriptor */
		result;		/* readopensf() var */
  	SFHEADER 	sfh;		/* BICSF header struct */
  	struct stat 	sfst;		/* requires /usr/include/sys/stat.h */
  	int 		size;		/* packmode size of reference file */

char	*cbeg = NULL,
			*cend = NULL,
			*cdur = NULL,
  		*file = "test",
			cbuf[72];	/* buffer for strings to write to header */

/* cmix declarations */
int	impulse = p[3],		
		nsamps=0,
		isamps=0,
  	c=0, inchan=0, nchnls_out=0,
  	ringdown[2], ringtotal,
  	infile=1, placeholder=0;

float xin[2], xout[2], dout[2],
  		outpan=0, drymix=0;

/*
  CMIX datafile parameters
  p[0] = output file time
  p[1] = duration 
  p[2] = inputfile skip 
  p[3] = number of file for impulse response
  p[4] = duration to read file for impuse response file
  p[5] = skip into impulse response file  
  p[6] = gain
  p[7] = invert flag, 1 equals invert
  p[8] = dry signal percentage 
  p[9] = outpan
*/

	gain    = p[6];
	invert  = p[7];
	drymix  = p[8];
	outpan  = p[9];
	input   = 0;
	output  = 1;

    	printf("->\tdry signal percentage %3.2f\t<-\n",drymix);

    inchan     = sfchans(&sfdesc[input]);
    if (inchan==2)
    	printf("->\tstereo target file\t<-\n");
    else
	printf("->\tmono target file\t<-\n");

    ichan = sfchans(&sfdesc[impulse]);

    for (c=0;c<ichan;c++){
   	ocnt[c] = 0;
	icnt[c] = 0;
	}

    if (ichan>=2)
    	printf("->\tstereo impulse response file\t<-\n");
    else
	printf("->\tmono impulse response file\t<-\n");
    printf("->\toutpan = %3.2f\t<-\n",outpan);
    nsamps = setnote(p[2],p[1],input);			
    setnote(p[0],p[1],output);				
    nchnls_out = sfchans(&sfdesc[output]);
    if (nchnls_out < 2){
	printf("stereo outfile needed by cmix convolve\n"); 
 	exit(0);
    }	
    isamps = setnote(p[5],p[4],impulse);	

    size = sizeof(short);
    sinbuf = SF_BUFSIZE / size; 

    if ((isamps) > NCMAX){
      isamps = NCMAX;
      fprintf(stderr,"convolve: warning - impulse response too long\n");
    }

/* Set up buffers. */

  for (N2 = 2; N2 < NCMAX; N2 *= 2)
    if (N2 >= (isamps)) break;
  N = 2 * N2;

  for (c = 0;c<ichan;c++){
    if ((sbuf[c] = (float *) calloc(N+2, sizeof(float))) == NULL)
      malerr("convolvesf: insufficient memory", 1);
    if ((tbuf[c] = (float *) calloc(N2, sizeof(float))) == NULL)
      malerr("convolvesf: insufficient memory", 1);
    if ((filt[c] = (float *) calloc(N+2, sizeof(float))) == NULL)
      malerr("convolvesf: insufficient memory", 1);
    if ((dry[c] = (float *) calloc(N+2, sizeof(float))) == NULL)
      malerr("convolvesf: insufficient memory", 1);
  }
    printf("buffers allocated.....\n");

	for (i=0; i<N2; i++){
		if (GETIN(xin,impulse) <= 0)
			break;
		for (c=0;c<ichan;c++){	
			if (haswindow)
				*(filt[c]+i) =  xin[c] * table(i,array[1],tabs[1]); 
			else *(filt[c]+i) =  xin[c];
		}
	}

/* Finish initialization: fill buffers, take FFT of filt, normalize */
  for (c = 0; c < ichan ; c++){
    for (i=isamps; i<N+2; i++){
      *(filt[c]+i) = 0.;
    }
	rfft(filt[c],N2,1);
	for (i=0; i<=N2; i++){
		a = *(filt[c] + 2*i);
		b = *(filt[c] + 2*i + 1);
		temp = a*a + b*b;
		if (temp > max) max = temp;
	}

  if (max != 0.0)
		max = gain/(sqrt(max));
	else {
		zeroError = 1;
	}
    for (i=0; i< N+2; i++)
      *(filt[c] + i) *= max;
}
	if (!zeroError) {
		/* get target file samps */
  for (i=0; i<N2; i++){
     if (cmixgetfloat(xin,inchan) <= 0)
          break;
     if(icnt[c]+i >= nsamps) infile=0;
     for (c=0;c<ichan;c++){	
            if(haswindow){ 
	     *(sbuf[c]+i) =  xin[c] * table(icnt[c],array[0],tabs[0]); 
             *(dry[c]+i)  =  xin[c]; 
	  }
	  else{
             *(sbuf[c]+i) =  xin[c]; 
             *(dry[c]+i)  =  xin[c]; 
          }
      icnt[c]++;
      }
  }
  for (c=0;c<ichan;c++){	
     for (i = icnt[c]; i<N+2; i++){
        *(sbuf[c]+i) = 0.;
        *(dry[c]+i) = 0.;
     }
     if (icnt[c] == 0){
       fprintf(stderr,"convolve: no valid input in source file\n");
       exit(1);
    }
  }

//	Main loop:  Take N-point FFT of next N/2 input samples and multiply
//	by FFT of filter impulse response.  Inverse FFT and add first N/2
//	resulting samples to last N/2 samples of previous FFT.

 ringtotal = N;
 for(c=0;c<ichan;c++){
    ringdown[c] = ringtotal;
    }
  while(ringdown[0] > 0 || ringdown[1] > 0 ){
    for(c=0;c<ichan;c++){
    printf(".");	
      rfft(sbuf[c],N2,1);
      if (!invert) {	/* convolution */
        for (i=0; i<=N2; i++) {
    	  ip = 2*i;
	  ip1 = ip + 1;
	  a = *(sbuf[c]+ip) * *(filt[c]+ip) - *(sbuf[c]+ip1) * *(filt[c]+ip1);
	  b = *(sbuf[c]+ip) * *(filt[c]+ip1) + *(sbuf[c]+ip1) * *(filt[c]+ip);
	  *(sbuf[c]+ip) = a;
	  *(sbuf[c]+ip1) = b;
        }
      }
     else {		/* deconvolution */
      for (i=0; i<=N2; i++) {
	ip = 2*i;
	ip1 = ip + 1;

	if ((fmag =(*(filt[c]+ip)* *(filt[c]+ip)) +
		(*(filt[c]+ip1)* *(filt[c]+ip1))) == 0.) {
	  *(sbuf[c]+ip) = 0.;
	  *(sbuf[c]+ip1) = 0.;
	}
	else {

//a = (*(sbuf[c]+ip) * *(filt[c]+ip) + *(sbuf[c]+ip1) * *(filt[c]+ip1)) /fmag;
//b = (*(sbuf[c]+ip) * *(filt[c]+ip1) - *(sbuf[c]+ip1) * *(filt[c]+ip)) / fmag;
// *(sbuf[c]+ip) = a;
// *(sbuf[c]+ip1) = b;


	  a = (*(sbuf[c]+ip) / *(filt[c]+ip) + *(sbuf[c]+ip1) / *(filt[c]+ip1));
	  b = (*(sbuf[c]+ip) / *(filt[c]+ip1) - *(sbuf[c]+ip1) / *(filt[c]+ip));
	  *(sbuf[c]+ip) = a;
	  *(sbuf[c]+ip1) = b;
	}
      }
    }

    rfft(sbuf[c],N2,0);
    
    for (i=0; i<N2; i++)
      *(tbuf[c]+i) += *(sbuf[c]+i);
  }  /* end chan loop*/  
  if (!invert) {
    for (i=0; i<N2; i++){
      if (++ocnt[0] <= nsamps+N2){
	  for(c=0;c<ichan;c++){ 
	    if(haswindow){
	       xout[c]= *(tbuf[c]+i);
	       dout[c]= *(dry[c]+i) * table(ocnt[0],array[0],tabs[0]);
	    }
	    else{
	       xout[c]=*(tbuf[c]+i);
	       dout[c]=*(dry[c]+i);
	    }
	  }
	  cmixputfloat(xout,dout,drymix,outpan,inchan,ichan);
	}   
      }
      printf(".");
    }
    else {
    printf("after else\n");
      for (i=N2-1; i >= 0; i--){
	if (++ocnt[0] <= nsamps+N2){
	  for(c=0;c<ichan;c++){ 
	    if(haswindow){
	       xout[c]= *(tbuf[c]+i);
	       dout[c]= *(dry[c]+i) * table(ocnt[c],array[0],tabs[0]);
	    }
	    else{
	       xout[c]=*(tbuf[c]+i);
	       dout[c]=*(dry[c]+i);
	    }
	  }
        cmixputfloat(xout,dout,drymix,outpan,inchan,ichan);
        }
      }
    }
    for(c=0; c<ichan;c++)
     for (i=0; i<N2; i++)
     *(tbuf[c]+i) = *(sbuf[c]+N2+i);

/* reset i for second ringdown buffer*/ 
     i=0; 
     if (infile){  
       for (; i<N2; i++) {
         if(cmixgetfloat(xin,inchan) <=0)
	   break;
         if(ocnt[0]+i >= nsamps) infile=0;
	 for (c=0;c<ichan;c++){	
            if(haswindow){ 
	     *(sbuf[c]+i) =  xin[c] * table(icnt[c],array[0],tabs[0]); 
             *(dry[c]+i)  =  xin[c]; 
	    }
	    else{
             *(sbuf[c]+i) =  xin[c]; 
             *(dry[c]+i)  =  xin[c]; 
            }
         icnt[c]++;
         }
     }
    }
     placeholder = i; 
     if (!infile){
       for(c=0; c<ichan;c++){
         for (i=placeholder; i<N2; i++) {
            *(sbuf[c]+i) = 0.;
            *(dry[c]+i) = 0.;
            --ringdown[c];
         }
      }
    printf("\n");
    }
    placeholder = i; 
    for(c=0; c<ichan;c++){
       for (i=placeholder; i<N+2; i++){
         *(sbuf[c]+i) = 0.;
         *(dry[c]+i) = 0.;
       } 
    }
  } /* end of while loop*/

	}
	else {
 	 fprintf(stderr,"skipping convolve process. Impulse response is all 0s.\n");
		setnote(p[0],0.0,output); // correct output to be 0 duration
	}

  endnote(output);
  
  printf("buffers freed\n");
  for(c=0; c<ichan;c++){
     free(sbuf[c]);
     free(tbuf[c]);
     free(filt[c]);
     free(dry[c]);
  }
  return(1);
} /* end convolve */

usage(exitcode)
	int exitcode;
{
	fprintf(stderr,"\nusage: convolve <  convolvescript &junk&\n");
	fprintf(stderr,"NEW ARGUMENT ORDER :\n");
	fprintf(stderr,"p[0]outskip\n");
	fprintf(stderr,"p[1]duration\n");
	fprintf(stderr,"p[2]inskip\n"); 
	fprintf(stderr,"p[3]impulse file #\n");
	fprintf(stderr,"p[4]impulse dur\n");
	fprintf(stderr,"p[5]impulse inskip\n"); 
	fprintf(stderr,"p[6]gain\n");
	fprintf(stderr,"p[7]inverse flag\n");
	fprintf(stderr,"p[8]dry signal%\n");
	fprintf(stderr,"p[9]outpan\n"); 
	exit(exitcode);
}

quit()
{
int c;
  fprintf(stderr, "exiting\n");
//  endnote(output);
  printf(">   freeing memory    <\n");
  for(c=0; c<ichan;c++){
     free(sbuf[c]);
     free(tbuf[c]);
     free(filt[c]);
     free(dry[c]);
  }
}

malerr(str, ex)
char	*str;
int	ex;
{
  fprintf(stderr, "%s\n", str);
  fprintf(stderr,"\nconvolvesf: impulse response too long\n");
  exit(ex);
}

cmixgetfloat(xin,inchan)
float *xin[2];
int inchan;
{

	GETIN(xin,input);
	if (inchan==1) xin[1]=xin[0];
	return(1);
}

cmixputfloat(xout,dout,drymix,outpan,inchan,ichan)
float *xout,*dout,outpan,drymix;
int inchan,ichan;
{
int c;
float out[2],pan[2],wet;
	pan[0]  = sqrt(outpan); 
	pan[1]  = sqrt(1-outpan);
	wet = (1 - drymix); 

	if(ichan==1)
    for(c=0;c<2;c++){
        out[c] = (xout[0]*pan[c])*wet + (dout[0]*pan[c])*drymix;
    }
	else{
     for(c=0;c<2;c++)
        out[c] = (xout[c]*pan[c])*wet + (dout[c]*pan[c])*drymix;
    }
    return(ADDOUT(out,output));
}

double 
setwindow(p,n_args)
float *p;
int n_args;
{

// table for envelope on read of target file
// p[0] number of array:   0 = source, 1 = impulse response
// p[1] duration of window 
// p[2] -> table values	

    int number = p[0];
    printf("creating window %d\n",number);
    tableset(p[1],SIZE,tabs[number]);
    setline(&p[2],n_args-2,SIZE,array[number]);
    haswindow=1;
}

double
setwarp(p,n_args)
float *p;
int n_args;
{

// table for inc. warp 
// p[0] number of array: 0 = source, 1 = impulse response 
// p[1] duration of file
// p[2] -> table values	

	int number = p[0];
    	printf("creating warp table %d\n",number);
	tableset(p[1],SIZE,warptabs[number]);
        setline(&p[2],n_args-2,SIZE,warparray[number]);
}

double
getwarp(p,n_args)
float *p;
int n_args;
{
	int number,insamp;
	float newskip;

// take inskip location and return return  newskip 
// p[0] number of array: 0 = source, 1 = impulse response 
// p[1] current inskip

	number = p[0];
	insamp = (int)(p[1]*44100);
	newskip  = table(insamp,warparray[number],warptabs[number]); 
	return(newskip);
}

double
setrange(p,n_args)
float *p;
int n_args;
{

// table for dynamic random ranges 
// p[0] number of array: 0 = source, 1 = impulse response 
// p[1] duration of file
// p[2] -> table values	

	int number = p[0];
	printf("creating range table %d\n",number);
	tableset(p[1],SIZE,rangetabs[number]);
	setline(&p[2],n_args-2,SIZE,rangearray[number]);
}

double
getrange(p,n_args)
float *p;
int n_args;
{
	int number,insamp;
	float range;

// take inskip location and return range value 
// p[0] number of array: 0 = source, 1 = impulse response 
// p[1] current inskip

	number = p[0];
	insamp = (int)(p[1]*44100);
	range  = table(insamp,rangearray[number],rangetabs[number]); 
	return(range);
}

double
setring(p,n_args)
float *p;
int n_args;
{

// table for ring 
// p[0] number of array: 0 = source, 1 = impulse response 
// p[1] duration of file
// p[2] -> table values	

	int number = p[0];
    	printf("creating ring table %d\n",number);
	tableset(p[1],SIZE,ringtabs[number]);
        setline(&p[2],n_args-2,SIZE,ringarray[number]);
}

double
getring(p,n_args)
float *p;
int n_args;
{
	int number;
	long insamp;
	float newindow;

// get table value i"newinc," and return inskip + newinc 
// p[0] number of array: 0 = source, 1 = impulse response 
// p[1] current inskip

	number = p[0];
	insamp = (long)(p[1]*44100);
	newindow  = table(insamp,ringarray[number],ringtabs[number]); 
	return(newindow);
}

double
setdry(p,n_args)
float *p;
int n_args;
{

// table for dry 
// p[0] duration of file
// p[1] -> table values

 	printf("creating dry table \n");
	tableset(p[0],SIZE,drytabs);
  setline(&p[1],n_args-1,SIZE,dryarray);
}

double
getdry(p,n_args)
float *p;
int n_args;
{
	int number;
	long insamp;
	float dry;

// get table value i"newinc," and return inskip + newinc 
// p[0] current inskip

	insamp = (long)(p[0]*44100);
	dry  = table(insamp,dryarray,drytabs); 
	return(dry);
}

double
print(p,n_args)
float *p;
int n_args;
{
}#include "fft.h"

float PI;
float TWOPI;

/*
 * If forward is true, rfft replaces 2*N real data points in x with
 * N complex values representing the positive frequency half of their
 * Fourier spectrum, with x[1] replaced with the real part of the Nyquist
 * frequency value.  If forward is false, rfft expects x to contain a
 * positive frequency spectrum arranged as before, and replaces it with
 * 2*N real values.  N MUST be a power of 2.
 */
rfft( x, N, forward ) float x[] ; int N, forward ; {
 float c1, c2, h1r, h1i, h2r, h2i, wr, wi, wpr, wpi, temp, theta ;
 float xr, xi ;
 int i, i1, i2, i3, i4, N2p1 ;
 static int first = 1 ;
    if ( first ) {
	PI = 4.*atan( 1. ) ;
	TWOPI = 8.*atan( 1. ) ;
printf ("in rfft\n");
	first = 0 ;
    }
    theta = PI/N ;
    wr = 1. ;
    wi = 0. ;
    c1 = 0.5 ;
    if ( forward ) {
	c2 = -0.5 ;
	cfft( x, N, forward ) ;
	xr = x[0] ;
	xi = x[1] ;
    } else {
	c2 = 0.5 ;
	theta = -theta ;
	xr = x[1] ;
	xi = 0. ;
	x[1] = 0. ;
    }
    wpr = -2.*pow( sin( 0.5*theta ), 2. ) ;
    wpi = sin( theta ) ;
    N2p1 = (N<<1) + 1 ;
    for ( i = 0 ; i <= N>>1 ; i++ ) {
	i1 = i<<1 ;
	i2 = i1 + 1 ;
	i3 = N2p1 - i2 ;
	i4 = i3 + 1 ;
	if ( i == 0 ) {
	    h1r =  c1*(x[i1] + xr ) ;
	    h1i =  c1*(x[i2] - xi ) ;
	    h2r = -c2*(x[i2] + xi ) ;
	    h2i =  c2*(x[i1] - xr ) ;
	    x[i1] =  h1r + wr*h2r - wi*h2i ;
	    x[i2] =  h1i + wr*h2i + wi*h2r ;
	    xr =  h1r - wr*h2r + wi*h2i ;
	    xi = -h1i + wr*h2i + wi*h2r ;
	} else {
	    h1r =  c1*(x[i1] + x[i3] ) ;
	    h1i =  c1*(x[i2] - x[i4] ) ;
	    h2r = -c2*(x[i2] + x[i4] ) ;
	    h2i =  c2*(x[i1] - x[i3] ) ;
	    x[i1] =  h1r + wr*h2r - wi*h2i ;
	    x[i2] =  h1i + wr*h2i + wi*h2r ;
	    x[i3] =  h1r - wr*h2r + wi*h2i ;
	    x[i4] = -h1i + wr*h2i + wi*h2r ;
	}
	wr = (temp = wr)*wpr - wi*wpi + wr ;
	wi = wi*wpr + temp*wpi + wi ;
    }
    if ( forward )
	x[1] = xr ;
    else
	cfft( x, N, forward ) ;
}
/*
 * cfft replaces float array x containing NC complex values
 * (2*NC float values alternating real, imagininary, etc.)
 * by its Fourier transform if forward is true, or by its
 * inverse Fourier transform if forward is false, using a
 * recursive Fast Fourier transform method due to Danielson
 * and Lanczos.  NC MUST be a power of 2.
 */
cfft( x, NC, forward ) float x[] ; int NC, forward ; {
 float wr, wi, wpr, wpi, theta, scale ;
 int mmax, ND, m, i, j, delta ;
    ND = NC<<1 ;
    bitreverse( x, ND ) ;
    for ( mmax = 2 ; mmax < ND ; mmax = delta ) {
	delta = mmax<<1 ;
	theta = TWOPI/( forward? mmax : -mmax ) ;
	wpr = -2.*pow( sin( 0.5*theta ), 2. ) ;
	wpi = sin( theta ) ;
	wr = 1. ;
	wi = 0. ;
	for ( m = 0 ; m < mmax ; m += 2 ) {
	 register float rtemp, itemp ;
	    for ( i = m ; i < ND ; i += delta ) {
		j = i + mmax ;
		rtemp = wr*x[j] - wi*x[j+1] ;
		itemp = wr*x[j+1] + wi*x[j] ;
		x[j] = x[i] - rtemp ;
		x[j+1] = x[i+1] - itemp ;
		x[i] += rtemp ;
		x[i+1] += itemp ;
	    }
	    wr = (rtemp = wr)*wpr - wi*wpi + wr ;
	    wi = wi*wpr + rtemp*wpi + wi ;
	}
    }
/*
 * scale output
 */
    scale = forward ? 1./ND : 2. ;
    { register float *xi=x, *xe=x+ND ;
	while ( xi < xe )
	    *xi++ *= scale ;
    }
}
/*
 * bitreverse places float array x containing N/2 complex values
 * into bit-reversed order
 */
bitreverse( x, N ) float x[] ; int N ; {
 float rtemp, itemp ;
 int i, j, m ;
    for ( i = j = 0 ; i < N ; i += 2, j += m ) {
	if ( j > i ) {
	    rtemp = x[j] ; itemp = x[j+1] ; /* complex exchange */
	    x[j] = x[i] ; x[j+1] = x[i+1] ;
	    x[i] = rtemp ; x[i+1] = itemp ;
	}
	for ( m = N>>1 ; m >= 2 && j >= m ; m >>= 1 )
	    j -= m ;
    }
}
