#include "../H/sfheader.h"
#include "../H/ugens.h"
//#include "/boot/home/musr/becmix/H/soundstruct.h"
#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <sys/stat.h>
	
#define SIZE 131072 
	
float array[2][SIZE];
float tabs[2][2];                
float warparray[2][SIZE];
float warptabs[2][2];                
float ringarray[2][SIZE];
float ringtabs[2][2];
float rangearray[2][SIZE];
float rangetabs[2][2];                
float dryarray[SIZE];
float drytabs[2]; 
int haswindow = 0;                 
	
#define NCMAX 16777216
extern SFHEADER sfdesc[NFILES];
	
int sferror;
int sinbuf;
int tail;
int	input,output;
int	ichan;		/* impulse channels from header */
	
float *sbuf[2],  		/* array for input and FFT */
	 		*tbuf[2],  		/* array for overlap-adding output */
			*filt[2],		/* array for filter transform */
			*dry[2];		/* array for dry signal*/
	
/*-------------------------------------------------------
		convolve.c
	
This program performs fast convolution via the FFT.
	
-------------------------------------------------------*/

extern setnote(double ,double,int);
double convolve(float *p,int n_args, double *pp);
void malerr(char *str, int ex);
void usage(int exitcode);
void quit();
int cmixgetfloat(float *xin,int inchan);
double setwindow(float *p,int n_args,double *pp);
double setwarp(float *p,int n_args,double *pp);
double getwarp(float *p,int n_args,double *pp);
double setrange(float *p,int n_args,double *pp);
double getrange(float *p,int n_args,double *pp);
double setdry(float *p,int n_args,double *pp);
double getdry(float *p,int n_args,double *pp);
double setring(float *p,int n_args,double *pp);
double getring(float *p,int n_args,double *pp);
	
double
convolve(float *p,int n_args, double *pp)
{
float	a,		/* temporary */
			b,		/* temporary */
			temp,		/* temporary */
			fmag,
	 		srate,		/* sample rate from header */
			gain = 1.,	/* gain */
			max = 0.;	/* maximum */
	
long	i,
			icnt[2],		/* counts input samples */
			ocnt[2], 	/* counts output samples */
			N,		/* FFT size is twice impulse response */
			N2,		/* N / 2 */
			ip,		/* temporary pointer */
			ip1;		/* temporary pointer */
	
int		invert = 0,	/* flag for deconvolution */
			zeroError = 0;
	
/* bicsf declarations */
int fd;		/* file descriptor */
//		result;		/* readopensf() var */
SFHEADER 	sfh;		/* BICSF header struct */
//  	struct stat 	sfst;		/* requires /usr/include/sys/stat.h */
int 		size;		/* packmode size of reference file */
	
char	*cbeg = NULL,
			*cend = NULL,
			*cdur = NULL,
	 		*file = "test";
//			cbuf[72];	/* buffer for strings to write to header */
	
/* cmix declarations */
int	impulse = (int)pp[3],		
		nsamps=0,
		isamps=0,
	 	c=0, inchan=0, nchnls_out=0,
	 	ringdown[2], ringtotal,
	 	infile=1, placeholder=0;
	
float xin[2], xout[2], dout[2],
	 		outpan=0, drymix=0;
	
/*
	 CMIX datafile parameters
	 pp[0] = output file time
	 pp[1] = duration 
	 pp[2] = inputfile skip 
	 pp[3] = number of file for impulse response
	 pp[4] = duration to read file for impuse response file
	 pp[5] = skip into impulse response file  
	 pp[6] = gain
	 pp[7] = invert flag, 1 equals invert
	 pp[8] = dry signal percentage 
	 pp[9] = outpan
*/
	
	gain    = pp[6];
	invert  = pp[7];
	drymix  = pp[8];
	outpan  = pp[9];
	input   = 0;
	output  = 1;
	
	printf("->\tdry signal percentage %3.2f\t<-\n",drymix);
	
	inchan     = sfchans(&sfdesc[input]);
	if (inchan==2)
		printf("->\tstereo target file\t<-\n");
	else
	printf("->\tmono target file\t<-\n");
	
	ichan = sfchans(&sfdesc[impulse]);
	
	for (c=0;c<ichan;c++){
		ocnt[c] = 0;
		icnt[c] = 0;
	}

	if (ichan>=2)
		printf("->\tstereo impulse response file\t<-\n");
	else
		printf("->\tmono impulse response file\t<-\n");
		
	printf("->\toutpan = %3.2f\t<-\n",outpan);
	nsamps = setnote(pp[2],pp[1],input);			
	setnote(pp[0],pp[1],output);				
	nchnls_out = sfchans(&sfdesc[output]);
	if (nchnls_out < 2){
		printf("stereo outfile needed by cmix convolve\n"); 
		exit(0);
	}	
	isamps = setnote(pp[5],pp[4],impulse);	
	
	size = sizeof(short);
	sinbuf = SF_BUFSIZE / size; 
	
	if ((isamps) > NCMAX){
		isamps = NCMAX;
		fprintf(stderr,"convolve: warning - impulse response too long\n");
	}
	
/* Set up buffers. */
	
	for (N2 = 2; N2 < NCMAX; N2 *= 2)
		if (N2 >= (isamps)) break;
		N = 2 * N2;
	
	for (c = 0;c<ichan;c++){
		if ((sbuf[c] = (float *) calloc(N+2, sizeof(float))) == NULL)
			malerr("convolvesf: insufficient memory", 1);
		if ((tbuf[c] = (float *) calloc(N2, sizeof(float))) == NULL)
			malerr("convolvesf: insufficient memory", 1);
		if ((filt[c] = (float *) calloc(N+2, sizeof(float))) == NULL)
			malerr("convolvesf: insufficient memory", 1);
		if ((dry[c] = (float *) calloc(N+2, sizeof(float))) == NULL)
			malerr("convolvesf: insufficient memory", 1);
	}
	printf("buffers allocated.....\n");
	
	for (i=0; i<N2; i++){
		if (GETIN(xin,impulse) <= 0)
			break;
		for (c=0;c<ichan;c++){	
			if (haswindow)
				*(filt[c]+i) =  xin[c] * table(i,array[1],tabs[1]); 
			else *(filt[c]+i) =  xin[c];
		}
	}
	
	/* Finish initialization: fill buffers, take FFT of filt, normalize */
	for (c = 0; c < ichan ; c++){
		for (i=isamps; i<N+2; i++){
			*(filt[c]+i) = 0.;
		}
		rfft(filt[c],N2,1);
		for (i=0; i<=N2; i++){
			a = *(filt[c] + 2*i);
			b = *(filt[c] + 2*i + 1);
			temp = a*a + b*b;
			if (temp > max) max = temp;
		}
	
		if (max != 0.0)
			max = gain/(sqrt(max));
		else {
			zeroError = 1;
		}
		for (i=0; i< N+2; i++)
	     *(filt[c] + i) *= max;
	}

	if (!zeroError) {
		/* get target file samps */
	 for (i=0; i<N2; i++){
	    if (cmixgetfloat(xin,inchan) <= 0) break;
	    if(icnt[c]+i >= nsamps) infile=0;
	    for (c=0;c<ichan;c++){	
				if(haswindow){ 
	     			*(sbuf[c]+i) =  xin[c] * table(icnt[c],array[0],tabs[0]); 
						*(dry[c]+i)  =  xin[c]; 
	  		}
	  		else{
					*(sbuf[c]+i) =  xin[c]; 
					*(dry[c]+i)  =  xin[c]; 
				}
	     	icnt[c]++;
	     }
	 }
	 for (c=0;c<ichan;c++){	
		for (i = icnt[c]; i<N+2; i++){
			*(sbuf[c]+i) = 0.;
			*(dry[c]+i) = 0.;
		}
		if (icnt[c] == 0){
			fprintf(stderr,"convolve: no valid input in source file\n");
			exit(1);
		}
	 }
	
//	Main loop:  Take N-point FFT of next N/2 input samples and multiply
//	by FFT of filter impulse response.  Inverse FFT and add first N/2
//	resulting samples to last N/2 samples of previous FFT.
	
	ringtotal = N;
	for(c=0;c<ichan;c++){
	   ringdown[c] = ringtotal;
	}
	while(ringdown[0] > 0 || ringdown[1] > 0 ){
	  for(c=0;c<ichan;c++){
			printf(".");	
			rfft(sbuf[c],N2,1);
			if (!invert) {	/* convolution */
				for (i=0; i<=N2; i++) {
					ip = 2*i;
					ip1 = ip + 1;
					a = *(sbuf[c]+ip) * *(filt[c]+ip) - *(sbuf[c]+ip1) * *(filt[c]+ip1);
					b = *(sbuf[c]+ip) * *(filt[c]+ip1) + *(sbuf[c]+ip1) * *(filt[c]+ip);
					*(sbuf[c]+ip) = a;
					*(sbuf[c]+ip1) = b;
	       }
	    }
	    else {		/* deconvolution */
				for (i=0; i<=N2; i++) {
					ip = 2*i;
					ip1 = ip + 1;
					if ((fmag =(*(filt[c]+ip)* *(filt[c]+ip)) +
						(*(filt[c]+ip1)* *(filt[c]+ip1))) == 0.) {
					  *(sbuf[c]+ip) = 0.;
					  *(sbuf[c]+ip1) = 0.;
					}
					else {
					//a = (*(sbuf[c]+ip) * *(filt[c]+ip) + *(sbuf[c]+ip1) * *(filt[c]+ip1)) /fmag;
					//b = (*(sbuf[c]+ip) * *(filt[c]+ip1) - *(sbuf[c]+ip1) * *(filt[c]+ip)) / fmag;
					// *(sbuf[c]+ip) = a;
					// *(sbuf[c]+ip1) = b;

					  a = (*(sbuf[c]+ip) / *(filt[c]+ip) + *(sbuf[c]+ip1) / *(filt[c]+ip1));
					  b = (*(sbuf[c]+ip) / *(filt[c]+ip1) - *(sbuf[c]+ip1) / *(filt[c]+ip));
					  *(sbuf[c]+ip) = a;
					  *(sbuf[c]+ip1) = b;
					}
				}
	   }

			rfft(sbuf[c],N2,0);

			for (i=0; i<N2; i++) *(tbuf[c]+i) += *(sbuf[c]+i);
	 	}  /* end chan loop*/  
		if (!invert) {
			for (i=0; i<N2; i++){
				if (++ocnt[0] <= nsamps+N2){
					for(c=0;c<ichan;c++){ 
						if(haswindow){
							xout[c]= *(tbuf[c]+i);
							dout[c]= *(dry[c]+i) * table(ocnt[0],array[0],tabs[0]);
						}
						else{
							xout[c]=*(tbuf[c]+i);
							dout[c]=*(dry[c]+i);
						}
					}	
	  			cmixputfloat(xout,dout,drymix,outpan,inchan,ichan);
				}
			}
			printf(".");
		}
		else {
			printf("after else\n");
			for (i=N2-1; i >= 0; i--){
				if (++ocnt[0] <= nsamps+N2){
					for(c=0;c<ichan;c++){ 
						if(haswindow){
							xout[c]= *(tbuf[c]+i);
							dout[c]= *(dry[c]+i) * table(ocnt[c],array[0],tabs[0]);
						}
						else{
							xout[c]=*(tbuf[c]+i);
							dout[c]=*(dry[c]+i);
						}
	  			}
					cmixputfloat(xout,dout,drymix,outpan,inchan,ichan);
				}
			}
		}
		for(c=0; c<ichan;c++)
			for (i=0; i<N2; i++) *(tbuf[c]+i) = *(sbuf[c]+N2+i);

/* reset i for second ringdown buffer*/ 
		i=0; 
		if (infile){  
			for (; i<N2; i++) {
				if(cmixgetfloat(xin,inchan) <=0)
					break;
				if(ocnt[0]+i >= nsamps) infile=0;
				for (c=0;c<ichan;c++){
					if(haswindow){ 
						*(sbuf[c]+i) =  xin[c] * table(icnt[c],array[0],tabs[0]); 
						*(dry[c]+i)  =  xin[c]; 
					}
					else{
						*(sbuf[c]+i) =  xin[c]; 
						*(dry[c]+i)  =  xin[c]; 
					}
	        icnt[c]++;
				}
			}
		}
		placeholder = i; 
		if (!infile){
			for(c=0; c<ichan;c++){
				for (i=placeholder; i<N2; i++) {
					*(sbuf[c]+i) = 0.;
					*(dry[c]+i) = 0.;
					--ringdown[c];
				}
			}
			printf("\n");
		}
		placeholder = i; 
			for(c=0; c<ichan;c++){
				for (i=placeholder; i<N+2; i++){
					*(sbuf[c]+i) = 0.;
	        *(dry[c]+i) = 0.;
	      } 
			}
		} /* end of while loop*/
	}
	else {
		fprintf(stderr,"skipping convolve process. Impulse response is all 0s.\n");
		setnote(pp[0],0.0,output); // correct output to be 0 duration
	}

	endnote(output);
	 
	printf("buffers freed\n");
	for(c=0; c<ichan;c++){
		free(sbuf[c]);
		free(tbuf[c]);
		free(filt[c]);
		free(dry[c]);
	}
	return(1);
} /* end convolve */
	
void
usage(int exitcode)
{
	fprintf(stderr,"\nusage: convolve <  convolvescript &junk&\n");
	fprintf(stderr,"NEW ARGUMENT ORDER :\n");
	fprintf(stderr,"pp[0]outskip\n");
	fprintf(stderr,"pp[1]duration\n");
	fprintf(stderr,"pp[2]inskip\n"); 
	fprintf(stderr,"pp[3]impulse file #\n");
	fprintf(stderr,"pp[4]impulse dur\n");
	fprintf(stderr,"pp[5]impulse inskip\n"); 
	fprintf(stderr,"pp[6]gain\n");
	fprintf(stderr,"pp[7]inverse flag\n");
	fprintf(stderr,"pp[8]dry signal%\n");
	fprintf(stderr,"pp[9]outpan\n"); 
	exit(exitcode);
}
	
void
quit()
{
int c;
	fprintf(stderr, "exiting\n");
//  endnote(output);
	printf(">   freeing memory    <\n");
	for(c=0; c<ichan;c++){
		free(sbuf[c]);
		free(tbuf[c]);
		free(filt[c]);
		free(dry[c]);
	}
}
	
void
malerr(char *str, int ex)
{
	fprintf(stderr, "%s\n", str);
	fprintf(stderr,"\nconvolvesf: impulse response too long\n");
	exit(ex);
}
	
cmixgetfloat(float *xin,int inchan)
{
	GETIN(xin,input);
	if (inchan==1) xin[1]=xin[0];
		return(1);
}
	
cmixputfloat(float *xout,float *dout,float drymix,float outpan,int inchan, int ichan)
{
int c;
float out[2],pan[2],wet;
pan[0]  = sqrt(outpan); 
pan[1]  = sqrt(1-outpan);
wet = (1 - drymix); 
	
	if(ichan==1)
		for(c=0;c<2;c++){
			out[c] = (xout[0]*pan[c])*wet + (dout[0]*pan[c])*drymix;
		}
	else{
		for(c=0;c<2;c++)
			out[c] = (xout[c]*pan[c])*wet + (dout[c]*pan[c])*drymix;
		}
	return(ADDOUT(out,output));
}
	
double 
setwindow(float *p,int n_args,double *pp)
{

// table for envelope on read of target file
// pp[0] number of array:   0 = source, 1 = impulse response
// pp[1] duration of window 
// pp[2] -> table values	
	
int number = pp[0];
	printf("creating window %d\n",number);
	tableset(pp[1],SIZE,tabs[number]);
	setline(&pp[2],n_args-2,SIZE,array[number]);
	haswindow=1;
	return 0;
}
	
double
setwarp(float *p,int n_args,double *pp)
{
	
// table for inc. warp 
// pp[0] number of array: 0 = source, 1 = impulse response 
// pp[1] duration of file
// pp[2] -> table values	
	
int number = pp[0];
	printf("creating warp table %d\n",number);
	tableset(pp[1],SIZE,warptabs[number]);
	setline(&pp[2],n_args-2,SIZE,warparray[number]);
	return 0;
}
	
double
getwarp(float *p,int n_args,double *pp)
{
int number,insamp;
float newskip;
	
// take inskip location and return return  newskip 
// pp[0] number of array: 0 = source, 1 = impulse response 
// pp[1] current inskip
	
	number = pp[0];
	insamp = (int)(pp[1]*44100);
	newskip  = table(insamp,warparray[number],warptabs[number]); 
	return(newskip);
}
	
double
setrange(float *p,int n_args,double *pp)
{

// table for dynamic random ranges 
// pp[0] number of array: 0 = source, 1 = impulse response 
// pp[1] duration of file
// pp[2] -> table values	
	
int number = pp[0];
	printf("creating range table %d\n",number);
	tableset(pp[1],SIZE,rangetabs[number]);
	setline(&pp[2],n_args-2,SIZE,rangearray[number]);
	return 0;
}
	
double
getrange(float *p,int n_args,double *pp)
{
int number,insamp;
float range;
	
// take inskip location and return range value 
// pp[0] number of array: 0 = source, 1 = impulse response 
// pp[1] current inskip
	
	number = pp[0];
	insamp = (int)(pp[1]*44100);
	range  = table(insamp,rangearray[number],rangetabs[number]); 
	return(range);
}
	
double
setring(float *p,int n_args,double *pp)
{
	
// table for ring 
// pp[0] number of array: 0 = source, 1 = impulse response 
// pp[1] duration of file
// pp[2] -> table values	
	
int number = pp[0];
	printf("creating ring table %d\n",number);
	tableset(pp[1],SIZE,ringtabs[number]);
	setline(&pp[2],n_args-2,SIZE,ringarray[number]);
	return 0;
}
	
double
getring(float *p,int n_args,double *pp)
{
int number;
long insamp;
float newindow;
	
// get table value i"newinc," and return inskip + newinc 
// pp[0] number of array: 0 = source, 1 = impulse response 
// pp[1] current inskip
	
	number = pp[0];
	insamp = (long)(pp[1]*44100);
	newindow  = table(insamp,ringarray[number],ringtabs[number]); 
	return(newindow);
}
	
double
setdry(float *p,int n_args,double *pp)
{
// table for dry 
// pp[0] duration of file
// pp[1] -> table values
	
	printf("creating dry table \n");
	tableset(pp[0],SIZE,drytabs);
	setline(&pp[1],n_args-1,SIZE,dryarray);
	return 0;
}
	
double
getdry(float *p,int n_args,double *pp)
{
int number;
long insamp;
float dry;
	
// get table value i"newinc," and return inskip + newinc 
// pp[0] current inskip
	
	insamp = (long)(pp[0]*44100);
	dry  = table(insamp,dryarray,drytabs); 
	return(dry);
}
	
	//double
	//print(float *p,int n_args,double *pp)
	//{
	//}