#include <stdlib.h>
#include <stdio.h>
#include "sfheader.h"
#include "crack.h"
#include "pv.h"

#define Max_Files 24
#define Max_Path_Len 1024

complex zero = {0., 0.};
complex one = {1., 0.};
float PI;
float TWOPI;
float synt = 0.;

main(argc, argv)
    int argc; char *argv[];
{

    int 	R = 44100,
		N = 1024,
		N2,
		Nw = 0,
		Nw2, 
		D = 0, 
		I = 0,
		files,
		in,
		on,
		grab,
		eof = 0,
		invert = 0,
		aflag = 0;
    register
    int		i, ind;

    float	keep,
		*Hwin,
		*Wanal,
		*Wsyn,
		**inputs,
		**buffers,
		**chans,
		*output;
    char	ch,
		file[1024],
		**filelist,
		*dbuf;
    FILE	**fp;


    malloc_debug(32);

    if (argc < 3)
      usage(1);

    while( (ch = crack( argc, argv, "R|N|M|D|I|f|ih", 0  )) != 0 ) {
	switch(ch) {
	    case 'R':	R = atoi(arg_option);
			break;
	    case 'N':	N = atoi(arg_option);
			break;
	    case 'M':	Nw = atoi(arg_option);
			break;
	    case 'D':	D = atoi(arg_option);
			break;
	    case 'I':	I = atoi(arg_option);
			break;
	    case 'f':	strcpy(file, arg_option);
			break;
	    case 'i':	invert = 1;
			break;
	    case 'h':	usage(1);
	}
    }

    if (Nw == 0)
	Nw = N;

    if (D == 0)
      D = N / 8;

    if (aflag)
      I = 0;
    else
      if (I == 0)
	I = D;
    
    PI = 4. * atan(1.);
    TWOPI = 8. * atan(1.);
    N2 = N>>1;
    Nw2 = Nw>>1;


    filelist = (char **) space( Max_Files, sizeof(char *) );
    fp = (FILE **) space( Max_Files, sizeof(FILE *) );

    for ( i=0; i < Max_Files; i++ )
      *(filelist+i) = (char *) space( Max_Path_Len, sizeof(char) );
    
    if (( *fp = fopen( file, "r" ) ) == NULL) {
      fprintf(stderr,"What is %s?\n", file);
      exit(-1);
    }
    i = 0;
    while ( (grab = fscanf( *fp, "%s\n", *(filelist+i) )) != EOF && 
	   			i < Max_Files ) {
      if ( grab != 0 )
	++i;
    }
    files = i;
    fclose(*fp);

    for ( i=0; i < files; i++ ) {

      if ( ( *(fp+i) = fopen( *(filelist+i), "r" )) == NULL ) {
	fprintf(stderr,"Where is %s?\n", *(filelist+i));
	exit(-1);
      }

/* improve the soundfile support */
      stripheader(*(fp+i));
    }

/* edit allocation calls */

    Wanal = (float *) space( Nw, sizeof(float) );
    Wsyn = (float *) space( Nw, sizeof(float) );
    Hwin = (float *) space( Nw, sizeof(float) );
    output = (float *) space( Nw, sizeof(float) );

    inputs = (float **) space( files, sizeof(float *) );
    buffers = (float **) space( files, sizeof(float *) );
    chans = (float **) space( files, sizeof(float *) );

    for ( i=0; i < files; i++ ) {
      *(inputs+i) = (float *) space( Nw, sizeof(float) );
      *(buffers+i) = (float *) space( N, sizeof(float) );
      *(chans+i) = (float *) space( N+2, sizeof(float) );
    }

    makewindows( Hwin, Wanal, Wsyn, Nw, N, I, 0 );

    in = -Nw;
    if ( D )
	on = (in*I)/D;
    else
	on = in;

    grab = 0;
    eof = 0;


    while ( !eof ) {

      in += D;
      on += I;

/* develop a more sophisticated eof mechanism */

      for ( ind=0; ind < files; ind++ ) {
	
	if (eof)
	  (void) turnin( *(inputs+ind), Nw, D, *(fp+ind) );
	else
	  grab = turnin( *(inputs+ind), Nw, D, *(fp+ind) );

	fold( *(inputs+ind), Wanal, Nw, *(buffers+ind), N, in );
	rfft( *(buffers+ind), N2, FORWARD );
	leanconvert( *(buffers+ind), *(chans+ind), N2 );

      }

      /* process spectra */

      if (invert) {
	for ( i=0; i < N2; i+=2 ) {
	  keep = *(*chans+i);
	  for ( ind=1; ind < files; ind++ ) {
	    if ( *(*(chans+ind)+i)  < keep )
	      keep = *(*(chans+ind)+i);
	  }
	  *(*chans+i) = keep;
	}
      }
      else {
	for ( i=0; i < N2; i+=2 ) {
	  keep = *(*chans+i);
	  for ( ind=1; ind < files; ind++ ) {
	    if ( *(*(chans+ind)+i) > keep )
	      keep = *(*(chans+ind)+i);
	  }
	  *(*chans+i) = keep;
	}
      }

      if ( I == 0 ) {
	fwrite( *chans, sizeof(float), N+2, stdout );
	fflush( stdout );
	continue;
      }

      leanunconvert( *chans, *buffers, N2 );
      rfft( *buffers, N2, INVERSE );
      overlapadd( *buffers, N, Wsyn, output, Nw, on );
      shiftout( output, Nw, I, on );

/* fix eof treatment */
	eof = grab;
    }

    exit(0);
}

stripheader(fp)
FILE *fp;
{
  register int i;

  for ( i=0; i < SIZEOF_HEADER; i++ )
    fgetc(fp);
}

usage(woof)
{
    fprintf(stderr, "%s%s%s%s%s%s%s%s%s%s",
	"astral:  multiple file spectral compositing\n",
	"astral   [flags] > floatsams\n",
	"	N:	fft length [2^n]\n",
	"	R:	sampling rate\n",
	"	M:	window size in samples\n",
	"	D:	decimation factor in samples\n",
	"	I:	interpolation factor in samples\n",
	"	f:	soundfile list\n",
	"	i:	invert evaluation\n",
	"	h:	this wise guide\n");
    exit(woof);
}

