#include <stdlib.h>
#include <stdio.h>
#include "crack.h"
#include "pv.h"

#define Max_Table_Size 65537

float PI;
float TWOPI;
float synt = 0.;
int scatter = 0;


main(argc, argv)
    int argc; char *argv[];
{
    int 	R,
		N,
		Nw = 0,
		Nw2, 
		D = 0, 
		I = 0,
		i,
		hoop,			/* looping variable */
		in,
		on,
		eof = 0;
    float 	freqmult = 1.,
		len,
		tincr,
		tpos,
		*freqtable,
		*channel,
		*output;
    char	ch,
		freqfile[1024],
		*dbuf;
    FILE	*fp;

    if (isatty(0))
      usage(1);

    while( (ch= crack( argc, argv, "R|N|M|D|I|F|t|p|g|ash", 0  )) != 0 ) {
	switch(ch) {
	    case 'R':	R = atoi(arg_option);
			break;
	    case 'N':	N = atoi(arg_option);
			break;
	    case 'M':	Nw = atoi(arg_option);
			break;
	    case 'D':	D = atoi(arg_option);
			break;
	    case 'I':	I = atoi(arg_option);
			break;
	    case 'F':	freqmult = atof(arg_option);
			break;
	    case 't':	strcpy(freqfile, arg_option);
			break;
	    case 'g':	synt = atof(arg_option);
			break;
	    case 's':	scatter = 1;
			break;
	    case 'h':	usage(1);
	}
    }

    if (Nw == 0)
	Nw = N;

    if (I == 0) {
      fprintf(stderr,"please specify interpolation size in samples (I)\n");
      exit(1);
    }
      
    PI = 4.*atan(1.);
    TWOPI = 8.*atan(1.);
    Nw2 = Nw>>1;

/* rewrite with NX malloc() routines */

    freqtable = (float *) space( Max_Table_Size, sizeof(float) );
    channel = (float *) space( (N<<1)+2, sizeof(float) );
    output = (float *) space( Nw, sizeof(float) );
    
    if ( (fp = fopen( freqfile, "r" )) == NULL ) {
      fprintf(stderr,"What is %s?\n", freqfile);
      exit(-1);
    }

    if (fread( freqtable, sizeof(float), N, fp) == 0) {
	fprintf(stderr,"where is the rest?\n");
 	exit(-1);
    }


/* initialize input and output time values (in samples) */
    on = -Nw;

/* main loop--perform phase vocoder analysis-resynthesis */

    while ( !eof ) {

/* increment times */
	on += I;

	for ( hoop=0; hoop < N; hoop++ ) {
	  if ( fread(channel+(hoop<<1),sizeof(float),1,stdin) <= 0 )
	    eof = 1;
	  *(channel+(hoop<<1)+1) = *(freqtable+hoop);
	}
	  
/* oscillator bank resynthesis */

	oscarbank( channel, N, R, Nw, I, freqmult, output );
	shiftout( output, Nw, I, on+Nw-I );
    }
    exit(0);
}

usage(woof)
{
    fprintf(stderr, "%s%s%s%s%s%s%s%s%s%s%s",
	"oscar:  oscillator bank resynthesis\n",
	"oscar   [flags] < floatsam_data > floatsams\n",
	"	R:	sampling rate\n",
	"	N:	number of oscillators\n",
	"	M:	window size in samples\n",
	"	I:	interpolation factor in samples\n",
	"	F:	oscillator bank pitch factor\n",
	"	t:	frequency distribution table\n",
	"	g:	oscillator resynthesis gate threshold\n",
	"	s:	scatter phases of resynthesis\n",
	"	h:	this delightful tutor\n");
    exit(woof);
}
