/*
	A cmix hack of the CARL pv
	Seems to want the old cmix libs run! See makefile
	May be change the headers
*/
#include "../H/sfheader.h"
#include "../H/ugens.h"
#include "cpv.h"

int shiftin2( float *A, int N, int D );
void shiftout2( float *A, int N, int I, int n );
float  maxof( float *a, int n);
float maxamp(float *in, int n, int per, int ix, int sz);
void vvmult (float *out, float *a,float  *b, int n);
void usage(int);
void pv(float *,int ,double *);

extern int setnote(double,double,int);
extern makewindows( float *Hwin, float *Wanal, float *Wsyn, int Nw,int N, int I, int obank );
extern void oscbank( float *, int , float *, int, int, int, int, float, float *);
extern unconvert( float *channel, float *buffer, int N2, int I, int R );
extern	 overlapadd( float *buffer, int N, float *Wsyn, float *outputb, int Nw, int on );
extern endnote(int);
extern fold( float *inputb, float *Wanal, int Nw, float *buffer, int N, int in );
extern void rfft( float *, int , int  );
extern convert( float *, float *, int, int, int);
extern float lpa( float *, int, float *, int);
extern void  profile(void);

complex zero = { 0., 0. };
complex one = { 1., 0. };
float TWOPI;
float synt = 0.;
float xin[2],xout[2];
double dur;
float array[SIZE],tabs[2],amp, anamp,shamp;	/* for lineset */

int	input,output,chan, sdsamps=0;
int	valid = -1;
int nsamps=0, eof=0,insamps=0,inchan,outchan,shr,count;

extern SFHEADER sfdesc[NFILES];
int lineset=0;

void
pv(float *p, int n_args, double *pp)
{
int	 R,
	dsamps=0,
	andsamps=0,
	N,
	N2,
	Nw = 0,
	Nw2, 
	D = 0, 
	I = 0,
	i,
	hoop,			/* looping variable */
	in,
	on,
	obank = 0,
	aflag = 0,
	sflag = 0,
	Np = 0;
		
float 	P = 0.0,
		*Hwin,
		*Wanal,
		*Wsyn,
		*inputb,
		*winput,
		*lpcoef,
		*buffer,
		*channel,
		*outputb;

/* bicsf declarations */

//SFHEADER 	sfh;		/* BICSF header struct */
//struct stat 	sfst;		/* requires /usr/include/sys/stat.h */
//int 		size;		/* packmode size of reference file */

/* cmix declarations */
int	c=0,infile=1;

int maxargs = 13; /* maximum # of args */
		p=p;
if (n_args > maxargs){
	fprintf(stderr,"\nToo many args - %d\n",n_args); // Whoa, We're out a here
	usage(1);
	}
if (n_args < maxargs-1){
	fprintf(stderr,"\nToo few args - %d\n",n_args); // Whoa, We're out a here
	usage(1);
	}

/*
  CMIX datafile parameters
	pp[0] = inskip
	pp[1] = outskip
	pp[2] = duration
	pp[3] = fft length [2^n] (N)
	pp[4] = window size in samples (M or Nw)
	pp[5] = decimation factor in samples (D)
	pp[6] = interpolation factor in samples (I)
	pp[7] = oscillator bank pitch factor (P or F)
	pp[8] = linear prediction order (p)
	pp[9] = oscillator resynthesis gate threshold (g)
	pp[10] = analysis data output
	pp[11] = synthesize analysis input
	pp[12] = chan in - 0 or 1. Default 0. chan out is 1 if 12th arg.
*/

	chan = sfchans(&sfdesc[input]);
	if (chan==2) printf("->\tstereo target file\t<- ");
	else printf("->\tmono target file\t<- ");
	
	R = sfsrate(&sfdesc[input]);
//printf("\nR %d\n",R);
	N = (int)pp[3];	// fft length [2^n]
//printf("N %d - pp[3] %f\n",N, pp[3]);
	Nw = (int)pp[4];			// window size in samples
//printf("Nw %d - pp[4] %f\n",Nw, pp[4]);
	D = (int)pp[5];				// decimation factor in samples
//printf("D %d - pp[5] %f\n",D, pp[5]);
	I = (int)pp[6];				// interpolation factor in samples
//printf("I %d - pp[6] %f\n",I, pp[6]);
	P = (float)pp[7];				// oscillator bank pitch factor
//printf("P %d - pp[7] %f\n",P, pp[7]);
	Np = (int)pp[8];			// linear prediction order
//printf("Np %d - pp[8] %f\n",Np, pp[8]);
	synt = (float)pp[9];		// oscillator resynthesis gate threshold
//printf("synt %d - pp[9] %f\n",synt,pp[9]);
	aflag = (int)pp[10];	// pp[10] analysis data output
//printf("aflag %d - pp[10] %f\n",aflag,pp[10]);
	sflag = (int)pp[11];	// pp[11] synthesize analysis input
//printf("sflag %d - pp[11] %f\n",sflag, pp[11]);

	if (n_args == maxargs){
		inchan = (int)pp[12];	// pp[12] input channel to process
		outchan = 1;
	}
	if (n_args == maxargs-1){
		inchan = 0;	// default input channel to process
		outchan = 0;
	}
//printf("inchan %d to outchan %d\n",inchan, outchan);
	if ((N = pp[3]) == 0.0) N = 2048;
	if ((Nw = pp[4]) == 0.0) Nw = N;
	if ((D= pp[5]) == 0.0) D = 256;
	if ((I = pp[6]) == 0.0) I = 256;
	if ((Np = pp[8]) == 0.0) Np = 0;

	if (Nw == 0) Nw = N;

	if (aflag && sflag) {
		fprintf(stderr,"specify either -a or -s not both\n");
		exit(1);
	}

	if (aflag) I = 0;
	else if (I == 0) I = D;

	if (sflag) D = 0;

	TWOPI = PI2;
	obank = P != 0.;
	N2 = N>>1;
	Nw2 = Nw>>1;
printf("R-%d N-%d Nw-%d D-%d I-%d P-%f Np-%d synt-%f inchan %d\n", R, N, Nw, D, I, P, Np, synt, inchan);
	input=0; output=1;

	dur = pp[2];
	setnote(pp[1],dur,output);
  nsamps=setnote(pp[0],dur,input);
/*
	Wanal = (float *) NX_MALLOC((float *)Wanal, float, Nw); //	analysis window
	Wsyn = (float *) NX_MALLOC((float *)Wsyn, float, Nw);	// synthesis window
	inputb = (float *) NX_MALLOC((float *)inputb, float, Nw); //	input buffer
	Hwin = (float *) NX_MALLOC((float *)Hwin, float, Nw);	// plain Hamming window
	winput = (float *) NX_MALLOC((float *)winput,float,Nw ); //windowed input buffer
	buffer = (float *) NX_MALLOC((float *)buffer, float,N );	 // FFT buffer
	channel = (float *) NX_MALLOC((float *)channel, float,N+2 ); // analysis channels
	outputb = (float *) NX_MALLOC((float *)outputb, float,Nw );	// output buffer
*/

	Wanal = (float *) calloc(Nw, sizeof(float)); //	analysis window
	Wsyn = (float *) calloc(Nw, sizeof(float));	// synthesis window
	inputb = (float *) calloc(Nw, sizeof(float)); //	input buffer
	Hwin = (float *) calloc(Nw, sizeof(float));	// plain Hamming window
	winput = (float *) calloc(Nw, sizeof(float)); //windowed input buffer
	buffer = (float *) calloc(N, sizeof(float));	 // FFT buffer
	channel = (float *) calloc(N+2, sizeof(float)); // analysis channels
	outputb = (float *) calloc(Nw, sizeof(float));	// output buffer

printf ("buffers created\n");

/* create windows */

	makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank );

/* initialize input and output time values (in samples) */
	in = -Nw;
	if ( D )
		on = (in*I)/D;
	else
		on = in;
// got to reset these otherwise can't call funct within the same script
	insamps = 0;
	eof = 0;

/* main loop--perform phase vocoder analysis-resynthesis */

	while ( !eof ) {
/* increment times */
		in += D;
		on += I;

/* analysis: input D samples; window, fold and rotate input
   samples into FFT buffer; take FFT; and convert to
   amplitude-frequency (phase vocoder) form
*/

		if ( D == 0 ) {
			if (Np) {
				for ( hoop=0; hoop < Np+1; hoop++ ) {
					if (GETIN(xin, input) <= 0) { eof = 1; break; }
					lpcoef[hoop] = xin[inchan];
	    	}
	  	}
	  	for ( hoop=0; hoop < N+2;  hoop++ ) {
				if (GETIN(xin, input) <= 0) { eof = 1; break; }
				channel[hoop] = xin[inchan];
	  	}
		} 
		else {
		  eof = shiftin2( inputb, Nw, D );
		  if ( Np ) {
	  	  	vvmult( winput, Hwin, inputb, Nw );
			lpcoef[0] = lpa( winput, Nw, lpcoef, Np );
			}
//printf("before fold ");
			fold( inputb, Wanal, Nw, buffer, N, in );
//printf("before rfft ");
			rfft( buffer, N2, FORWARD );
//printf("before convert ");
			convert( buffer, channel, N2, D, R );
//printf("after funcs\n");
		}

		if ( aflag ) { /* analysis output */
			if ( Np ){
				for(i=0;i<Np+1;i++) {
					xout[outchan]= lpcoef[i];
					ADDOUT(xout,output);
				}
			}

			for(i=0;i<N+2;i++) {
				xout[outchan]= channel[i];
				ADDOUT(xout,output);
			}
		}

/* at this point channel[2*i] contains amplitude data and
   channel[2*i+1] contains frequency data (in Hz) for phase
   vocoder channels i = 0, 1, ... N/2; the center frequency
   associated with each channel is i*f, where f is the
   fundamental frequency of analysis R/N; any desired spectral
   modifications can be made at this point: pitch modifications
   are generally well suited to oscillator bank resynthesis,
   while time modifications are generally well (and more
   efficiently) suited to overlap-add resynthesis */

/* oscillator bank resynthesis */

		if ( obank ) {
//printf("before  oscbank ");
			oscbank( channel, N2, lpcoef, Np, R, Nw, I, P, outputb );
//printf("after oscbank ");
			shiftout2( outputb, Nw, I, on+Nw-I );
//printf("after shiftout2\n");
		} 

/* overlap-add resynthesis */

		else {
			unconvert( channel, buffer, N2, I, R );
			rfft( buffer, N2, INVERSE );
			overlapadd( buffer, N, Wsyn, outputb, Nw, on );
			shiftout2( outputb, Nw, I, on );
//printf("after shiftout2-2\n");
		}
	}

  endnote(output);

//	free(lpcoef);
	free(Wanal);
	free(Wsyn);
	free(inputb);
	free(Hwin);
	free(winput);
	free(buffer);
	free(channel);
	free(outputb);
printf("buffers freed\n");

//	return 0.0;
} /* end pv */

void
vvmult (float *out, float *a,float  *b, int n) {
float *lim = out + n;
    while ( out < lim )
	*out++ = *a++ * *b++;
}

float maxamp(float *in, int n, int per, int ix, int sz)
{
 float *lim = in + n;
 int i, found;
 static float **buf, *mx;
 static int *ptr;
 static int first = 1;
 int *p;
 float *b, *m;
    if ( first ) {
	first = 0;
	buf = (float **) malloc( sz*sizeof(float *) );
	for ( i = 0; i < sz; i++ )
	    buf[i] = (float *) calloc( per, sizeof(float) );
	ptr = (int *) calloc( sz, sizeof(int) );
	mx = (float *) calloc( sz, sizeof(float) );
    }
    --ix;
    for (
	b = buf[ix] , p = &ptr[ix] , m = &mx[ix], found = 0;
	in < lim;
	in++
    ) {
	if ( ( *(b+*p) = *in >= 0. ? *in : -*in ) >= *m )
	    found = *m = *(b+*p);
	if ( ++(*p) > per )
	    *p = 0;
    }
    if ( found )
	return( *m );
    else
	return( *m = maxof( b, per ) );
}

float maxof( float *a, int n)
{
 float *lim = a + n, m;
    for ( m = *a++; a < lim; a++ )
	if ( *a > m )
	    m = *a;
    return( m );
}

/*
   shift next D samples into righthand end of array A of
   length N, padding with zeros after last sample (A is
   assumed to be initially 0); return 0 when more input
   remains, otherwise return 1 after N-2*D zeros have been
   padded onto end of input
*/

shiftin2( float *A, int N, int D )
{
	int	i;

//printf("before getin ");
    if ( valid < 0 )		/* first time only */
	valid = N;

    for ( i = 0 ; i < N - D ; i++ ) A[i] = A[i+D];

	if ( valid == N ) {
		for (i=(N-D); i < N; i++,insamps++) {
			if (GETIN(xin, input) <= 0) {
				valid = i;
				break;
			}
			A[i]= xin[inchan]; // left or right chan
		}
	}
		if (insamps >= nsamps) eof=1;
    if ( valid < N ) {		/* pad with zeros after EOF */
	for (i=valid; i < N; i++)
	    A[i] = 0.;
	valid -= D;
    }
//printf("exiting getin\n");
    return(eof);
}

/*
   if output time n >= 0, output first I samples in
   array A of length N, then shift A left by I samples,
   padding with zeros after last sample
*/

void
shiftout2( float *A, int N, int I, int n )
{
 int i ;
	if ( n >= 0 ) {
		for (i=0; i < I; i++) {
			xout[outchan]= A[i];
			ADDOUT(xout,output);
		}
	}
		for ( i = 0 ; i < N - I ; i++ ) A[i] = A[i+I];
		for ( i = N - I ; i < N ; i++ ) A[i] = 0. ;
}

void
usage(woof)
{
	fprintf(stderr, "%s%s%s%s%s%s%s%s%s%s%s%s%s",
	"pp[0] = inskip\n",
	"pp[1] = outskip\n",
	"pp[2] = duration\n",
	"pp[3] = fft length [2^n]\n",
	"pp[4] = window size in samples\n",
	"pp[5] = decimation factor in samples\n",
	"pp[6] = interpolation factor in samples\n",
	"pp[7] = oscillator bank pitch factor\n",
	"pp[8] = linear prediction order\n",
	"pp[9] = oscillator resynthesis gate threshold\n",
	"pp[10] = analysis data output\n",
	"pp[11] = synthesize analysis input\n",
	"pp[12] = chan in - 0 or 1. Default 0. chan out is 1 if 12th arg\n");
   exit(woof);
}

