#include "../H/ugens.h"
#include "../macros/macros.h"

float rsnetc[64][5],amp[64];
int nresons;
#define SIZE 1024
float array[SIZE];
//int NBYTES = 32768;

extern float *floc(int);
extern	double makegen(float *,int , double *);
extern 	float setline(float *,int, double *);
extern void rsnset(float ,float ,float ,float ,float *);
extern float tablei(int ,float *,float *);
extern void tableset(float,int,float *);
extern int setnote(double ,double ,int);
extern void evset(float ,float ,float ,int ,float *);
extern double srrand(double);
extern double cpspch(float pch);

double inputsig(float *p,int n_args, double *pp);
double noise(float *p,int n_args, double *pp);
double buzzit(float *p,int n_args, double *pp);
double setup(float *p,int n_args, double *pp);
double pulseit(float *p,int n_args, double *pp);
float pulse(float amp,float si,float *phase);
double sl(float *p,int n_args, double *pp);
void profile(void);

double inputsig(float *p,int n_args, double *pp)
{
	int nsamps,input,output,inchan,outchan,i,j,jj,kontrol;
	float xin[4],out[4],val,q[9],ovamp,*evenv,tabs[3];
	/*start,dur,inskip */
	input=0; output=1;
	nsamps=setnote(pp[0],pp[1],output);
	setnote(pp[2],pp[1],input);
	inchan = 0;  outchan = 0;
	evset((float)pp[1],.01,.1,2,q);
	evenv = floc(2);
	tableset((float)pp[1],SIZE,tabs);
	p=p;n_args=n_args;
	kontrol = SR/500; jj=0;
	for(i=0; i<nresons; i++) rsnetc[i][3] = rsnetc[i][4] = 0;

	for(i=0; i<nsamps; i++) {
		if(!jj--) {
			jj=kontrol;
			ovamp = tablei(i,array,tabs);
			
		}
		if(!GETIN(xin,input)) break;
		for(out[outchan]=0,j=0; j<nresons; j++) {
			RESON(val,xin[inchan],rsnetc[j]);
			out[outchan] += val * amp[j];
		}
		out[outchan] *= ovamp;
		ADDOUT(out,output);
	}
	endnote(output);
	return 0.0;
}

double noise(float *p,int n_args, double *pp)
{
	int nsamps,input,output,outchan,i,j;
	float ramp,sig,out[4],val;
	float tabs[3],ovamp;
	int jj,kontrol;
	/* start,dur,amp */
	input=0; output=1;
	nsamps=setnote(pp[0],pp[1],output);
	outchan = 0;
	ramp=(float)pp[2];  if(!ramp) ramp=1.0;
	srrand(.1);
	kontrol = SR/500; jj=0;
	tableset((float)pp[1],SIZE,tabs);
	p=p;n_args=n_args;

	for(i=0; i<nresons; i++) rsnetc[i][3] = rsnetc[i][4] = 0;

	for(i=0; i<nsamps; i++) {
		if(!jj--) {
			jj=kontrol;
			ovamp = tablei(i,array,tabs);
			
		}

		sig = rrand();
		for(out[outchan]=0,j=0; j<nresons; j++) {
			RESON(val,sig,rsnetc[j]);
			out[outchan] += val * amp[j];
		}
		out[outchan] *= ovamp;
		ADDOUT(out,output);
	}
	endnote(output);
	return 0.0;
}

double buzzit(float *p,int n_args, double *pp)
{
	int nsamps,input,output,outchan,i,j;
	float hn,bamp,phase,si,*f1,sig,out[4],val;
	float tabs[3],ovamp;
	int jj,kontrol;
	/* start,dur,amp,pitch (<15 8ve.pc) */ 
	input=0; output=1;
	nsamps=setnote(pp[0],pp[1],output);
	outchan = 0;
	bamp=pp[2]; 
	si = pp[3] < 15 ? cpspch((float)pp[3])*512./SR : (float)pp[3] * 512./SR;
	hn = (int)(.5 / (si/512.));
	f1 = floc(1);
	phase = 0;
	kontrol = SR/500; jj=0;
	tableset((float)pp[1],SIZE,tabs);
	p=p;n_args=n_args;

	srrand(.1);
	for(i=0; i<nresons; i++) rsnetc[i][3] = rsnetc[i][4] = 0;

	for(i=0; i<nsamps; i++) {
		if(!jj--) {
			jj=kontrol;
			ovamp = tablei(i,array,tabs);
			
		}

		BUZZ(sig,bamp,si,hn,f1,phase);
		for(out[outchan]=0,j=0; j<nresons; j++) {
			RESON(val,sig,rsnetc[j]);
			out[outchan] += val * amp[j];
		}
		out[outchan] *= ovamp;
		ADDOUT(out,output);
	}
	endnote(output);
	return 0.0;
}

double pulseit(float *p,int n_args, double *pp)
{
	int nsamps,input,output,outchan,i,j;
	float phase,pamp,si,sig,out[4],val;
	float tabs[3],ovamp;
	int jj,kontrol;
	/* start,dur,pulseamp,pitch (<15 8ve.pc) */
	input=0; output=1;
	phase = 512;
	nsamps=setnote(pp[0],pp[1],output);
	outchan = 0;
	pamp = pp[2];
	kontrol = SR/500; jj=0;
	tableset((float)pp[1],SIZE,tabs);
	p=p;n_args=n_args;

	si = pp[3] < 15 ? cpspch((float)pp[3])*512./SR : (float)pp[3] * 512./SR;
	for(i=0; i<nresons; i++) rsnetc[i][3] = rsnetc[i][4] = 0;

	for(i=0; i<nsamps; i++) {
		if(!jj--) {
			jj=kontrol;
			ovamp = tablei(i,array,tabs);
			
		}

		sig = pulse(pamp,si,&phase);
		for(out[outchan]=0,j=0; j<nresons; j++) {
			RESON(val,sig,rsnetc[j]);
			out[outchan] += val * amp[j];
		}
		out[outchan] *= ovamp;
		ADDOUT(out,output);
	}
	endnote(output);
	return 0.0;
}

double setup(float *p,int n_args, double *pp)
{
	int i,j;
	float first,bw,cf;
	
	first = (pp[0] < 15) ? cpspch((float)pp[0]) : (float)pp[0];
	bw = pp[1] < 0 ? (float)-pp[1] * first : (float)pp[1];
	rsnset(first,bw,1.,0.,rsnetc[0]);
	printf("centerfreq    bandwidth  relative amp\n");
	amp[0] = (float)pp[2];
	p=p;n_args=n_args;

	printf("%10.4f %10.4f %10.4f\n",first,bw,amp[0]);
	for(i=3,j=1; i<n_args; i += 3)  {
		if(pp[i] < 0.) cf = (float)-pp[i] * first;
		else  cf = (pp[i] < 15) ? (float)cpspch((float)pp[i]) : (float)pp[i];
		bw = pp[i+1] < 0 ? (float)-pp[i+1] * cf : (float)pp[i+1];
		amp[j] = (float)pp[i+2]; 
		rsnset(cf ,bw ,1.,0.,rsnetc[j]);
		printf("%10.4f %10.4f %10.4f\n",cf,bw,amp[j]); 
		j++;
	}
	nresons = j;
	return 0.0;
}

float pulse(float amp,float si,float *phase)
{

	*phase += si;
	if(*phase > 512.) {
		*phase -= 512.;
		return(amp);
	}
	else return(0.);
}

void profile(void)
{
	double pp[9];
	float *p;
	int i;
	p=0;
	for(i=0; i<SIZE; i++) array[i] = 1.;
	UG_INTRO("setup",setup);
	UG_INTRO("resons",setup);
	UG_INTRO("inputsig",inputsig);
	UG_INTRO("noise",noise);
	UG_INTRO("buzz",buzzit);
	UG_INTRO("pulse",pulseit);
//	UG_INTRO("envelope",sl);
	
	pp[0]=1; pp[1]=10; pp[2]=1024; pp[3]=1;
	makegen(p,4,pp);  /* store sinewave in array 1 */
	pp[0]=2; pp[1]=7; pp[2]=512; pp[3]=0; pp[4]=512; pp[5]=1; 
	makegen(p,6,pp);
}
