#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "setell.h"
#include <fcntl.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>

extern SFHEADER sfdesc[2];
extern struct stat sfst[2];
extern int headersize[2];
extern SFMAXAMP sfm[2];

// prototypes

double ell(float *p,int n_args,double *pp);

float ellipse(float x, float C[4][10],float PS[4][10]);

void ellpset(float *list, float C[4][10], float PS[4][10]);

double ellset(float *p,int n_args,double *pp);

void profile(void);
//------------------------------
float psarr[4][4][10],carr[4][4][10],xnorm;
float retarr[461];
/* global array for coeffeicients */
int nsects,		/* number of sections */
input   = 0;

double ellset(float *p,int n_args,double *pp)
{
float sampr,f1,f2,f3,ripple,atten;
/* p0=passband cutoff;
 p1=stopband cutoff;
 p2=0 or bandpass stopband;

p3=ripple;
 p4=attenuation(db);
 p5=verbose*/
 f1 = pp[0];

f2 = pp[1];

f3 = pp[2];

sampr = SR;

ripple = pp[3];

atten = pp[4];

setell(sampr,f1,f2,f3,ripple,atten,retarr,&nsects,pp[5]);

return(0);

}

double ell(float *p,int n_args, double *pp)
{

/* p0 = inskip, p1=outskip, p2=duration */

	long i,j,nsamps;
float x[4],y[4];
int nchans; //= sfd[input].chans;
nsamps=setnote(pp[0],pp[2],0);

      setnote(pp[1],pp[2],1);
nchans = sfchans(&sfdesc[input]);

	for(j=0;j<nchans;j++) ellpset(retarr, carr[j], psarr[j]);

	for(i=0;i<4;i++) x[i] = y[i] = 0.;

	for(i=0;i<nsamps;i++) {
		GETIN(y,0);

		for(j=0;j<nchans;j++)

			x[j] = ellipse(y[j], carr[j], psarr[j]);
 
		ADDOUT(x,1);
 
		}
 	endnote(1);

	return(0);

}

float ellipse(float x, float C[4][10],float PS[4][10])
{
	register int m;

	float op;


	for(m=0;m<nsects;m++) {

		op = x + C[0][m] * PS[0][m] + C[2][m] * PS[1][m]-C[1][m] * PS[2][m] - C[3][m] * PS[3][m];

		PS[1][m] = PS[0][m];

		PS[0][m] = x;

		PS[3][m] = PS[2][m];

		PS[2][m] = op;

		x = op;

		}

	return(x*xnorm);

}

void ellpset(float *list, float C[4][10], float PS[4][10])
{

/* the first argument in the list is the number of sections */
/* this is no longer true -- nsects contains number of sections -- BGG */
	int m,i,j;


i=0;

	for(m=0;m<nsects;m++) {

		for(j=0;j<4;j++)  {
    
	C[j][m] = list[i++];

			 PS[j][m] = 0;
	}
		
 }
	xnorm = list[i];

	printf("number of sections in this filter: %d\n",nsects);

	printf("normalization factor: %f 	number of terms: %d\n",xnorm,i);
}
