
#include "../H/ugens.h"
#include "../H/sfheader.h"

float psarr[4][4][10],carr[4][4][10],xnorm;

float retarr[461];	/* global array for coeffeicients */
int nsects;		/* number of sections */

extern SFHEADER      pp[esc[NFILES];

ellset(p,n_args)
float *p;
int n_args;
{

	float sampr,f1,f2,f3,ripple,atten;

/* p0=passband cutoff; p1=stopband cutoff; p2=0 or bandpass stopband;
   p3=ripple; p4=attenuation(db) 	*/

	f1 = p[0];
	f2 = p[1];
	f3 = p[2];
	sampr = SR;
	ripple = p[3];
	atten = p[4];

      	setell_(&sampr,&f1,&f2,&f3,&ripple,&atten,retarr,&nsects);

}

ell(p,n_args)
float *p;
int n_args;
{

/* p0 = inskip, p1=outskip, p2=duration */

	long i,j,nsamps;
	float ellipse(),x[4],y[4];
	int nchans = sfchans(&sfdesc[0]);

	nsamps=setnote(p[0],p[2],0);
        setnote(p[1],p[2],1);
	for(j=0;j<nchans;j++)
		ellpset(retarr, carr[j], psarr[j]);
	for(i=0; i<4; i++) x[i] = y[i] = 0.;
	for(i=0;i<nsamps;i++) {
		GETIN(y,0);
		for(j=0;j<nchans;j++)
			x[j] = ellipse(y[j], carr[j], psarr[j]); 
		ADDOUT(x,1); 
		}
	endnote(1);
}

float ellipse(x, C, PS)
float x;
float C[4][10],PS[4][10];
{
	register int m;
	float op;

	for(m=0;m<nsects;m++) {
		op = x + C[0][m] * PS[0][m] + C[2][m] * PS[1][m]
		       - C[1][m] * PS[2][m] - C[3][m] * PS[3][m];
		PS[1][m] = PS[0][m];
		PS[0][m] = x;
		PS[3][m] = PS[2][m];
		PS[2][m] = op;
		x = op;
		}
	return(x*xnorm);
}

ellpset(list, C, PS)
float *list;
float C[4][10],PS[4][10];
{
/* the first argument in the list is the number of sections */
/* this is no longer true -- nsects contains number of sections -- BGG */
	int m,i,j;

	i=0;
	for(m=0;m<nsects;m++) {
		for(j=0;j<4;j++)  {    
	        	 C[j][m] = list[i++];
			 PS[j][m] = 0; }
		}
	xnorm = list[i];
	printf("number of sections in this filter: %d\n",nsects);
	printf("normalization factor: %f 	number of terms: %d\n",xnorm,i);

}
