/*  -- translated by f2c (version 19941210).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    doublereal pi2, ad[66], dev, x[66], y[66];
    real grid[1045], des[1045], wt[1045], alpha[66];
    integer iext[66], nfcns, ngrid;
} _BLNK__;

#define _BLNK__1 _BLNK__

struct {
    integer niter, iout;
} oops_;

#define oops_1 oops_

/* Table of constant values */

static integer c__3 = 3;
static integer c__1 = 1;
static integer c__4 = 4;


/* ----------------------------------------------------------------------- */
/* main program: fir linear phase filter design program */

/* authors: james h. mcclellan */
/* 	   schlumberger well services */
/*          12125 technology blvd. */
/*          austin, texas 78759 */

/*          thomas w. parks */
/*          department of electrical and computer engineering */
/*          rice university */
/*          houston, texas 77251-1892 */

/*          lawrence r. rabiner */
/*          bell laboratories */
/*          murray hill, new jersey 07974 */

/* modified for terminal input by t.w. parks-9/85 */
/* the filter specifications are written to the file "pmfil.lst" */
/* the impulse response is written to the file "response.dat" */

/* input: */
/*  nfilt-- filter length */
/*  jtype-- type of filter */
/*          1 = multiple passband/stopband filter */
/*          2 = differentiator */
/*          3 = hilbert transform filter */
/*  nbands-- number of bands */
/*  lgrid-- grid density, will be set to 16 unless */
/*          specified otherwise by a positive constant. */

/*  edge(2*nbands)-- bandedge array, lower and upper edges for each band */
/*                   with a maximum of 10 bands. */

/*  fx(nbands)-- desired function array (or desired slope if a */
/*               differentiator) for each band. */

/*  wtx(nbands)-- weight function array in each band.  for a */
/*                differentiator, the weight function is inversely */
/*                proportional to f. */

/*  sample input data setup: */
/*       32,1,3,0 */
/*       0.0,0.1,0.2,0.35,0.425,0.5 */
/*       0.0,1.0,0.0 */
/*       10.0,1.0,10.0 */
/*     this data specifies a length 32 bandpass filter with */
/*     stopbands 0 to 0.1 and 0.425 to 0.5, and passband from */
/*     0.2 to 0.35 with weighting of 10 in the stopbands and 1 */
/*     in the passband.  the grid density defaults to 16. */

/*     the following input data specifies a length 32 fullband */
/*     differentiator with slope 1 and weighting of 1/f. */
/*     the grid density will be set to 20. */
/*       32,2,1,20 */
/*       0,0.5 */
/*       1.0 */
/*       1.0 */

/* ----------------------------------------------------------------------- */

/* Main program */ MAIN__()
{
    /* Initialized data */

    static struct {
	char e_1[4];
	integer e_2;
	} equiv_71 = { {'b', ' ', ' ', ' '}, 0 };

#define bd1 (*(integer *)&equiv_71)

    static struct {
	char e_1[4];
	integer e_2;
	} equiv_72 = { {'a', ' ', ' ', ' '}, 0 };

#define bd2 (*(integer *)&equiv_72)

    static struct {
	char e_1[4];
	integer e_2;
	} equiv_73 = { {'n', ' ', ' ', ' '}, 0 };

#define bd3 (*(integer *)&equiv_73)

    static struct {
	char e_1[4];
	integer e_2;
	} equiv_74 = { {'d', ' ', ' ', ' '}, 0 };

#define bd4 (*(integer *)&equiv_74)


    /* Format strings */
    static char fmt_104[] = "(3x,\002Enter filter length, type, no. of band\
s\002)";
    static char fmt_120[] = "(3x,\002Enter band edges\002)";
    static char fmt_121[] = "(3x,\002Enter desired value in each band\002)";
    static char fmt_122[] = "(3x,\002Enter weight in each band\002)";
    static char fmt_360[] = "(\0021\002,70(\002*\002)/15x,\002finite impulse\
 response (fir)\002/13x,\002linear phase digital filter design\002/17x,\002r\
emes exchange algorithm\002)";
    static char fmt_365[] = "(22x,\002bandpass filter\002/)";
    static char fmt_370[] = "(22x,\002differentiator\002/)";
    static char fmt_375[] = "(20x,\002hilbert transformer\002/)";
    static char fmt_378[] = "(20x,\002filter length = \002,i3/)";
    static char fmt_380[] = "(15x,\002***** impulse response *****\002)";
    static char fmt_382[] = "(13x,\002h(\002,i2,\002) = \002,e15.8,\002 = h\
(\002,i3,\002)\002)";
    static char fmt_383[] = "(13x,\002h(\002,i2,\002) = \002,e15.8,\002 = \
-h(\002,i3,\002)\002)";
    static char fmt_7865[] = "(i5)";
    static char fmt_783[] = "(g20.5)";
    static char fmt_384[] = "(13x,\002h(\002,i2,\002) =  0.0\002)";
    static char fmt_385[] = "(24x,4(4a1,i3,7x))";
    static char fmt_390[] = "(2x,\002lower band edge\002,5f14.7)";
    static char fmt_395[] = "(2x,\002upper band edge\002,5f14.7)";
    static char fmt_400[] = "(2x,\002desired value\002,2x,5f14.7)";
    static char fmt_405[] = "(2x,\002desired slope\002,2x,5f14.7)";
    static char fmt_410[] = "(2x,\002weighting\002,6x,5f14.7)";
    static char fmt_425[] = "(2x,\002deviation\002,6x,5f14.7)";
    static char fmt_435[] = "(2x,\002deviation in db\002,5f14.7)";
    static char fmt_460[] = "(1x,70(\002*\002)/)";
    static char fmt_462[] = "(10x,\002*****filter specs are in the file pmfi\
l.lst*****\002/)";
    static char fmt_459[] = "(10x,\002****impulse response is in file respon\
se.dat****\002/)";
    static char fmt_463[] = "(10x,\002***cmix data is in file cmixpm****\002)"
	    ;

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;
    olist o__1;

    /* Builtin functions */
    double atan();
    integer f_open(), s_wsfe(), e_wsfe(), s_rsle(), do_lio(), e_rsle();
    /* Subroutine */ int s_stop();
    double cos(), sin();
    integer do_fio();
    double r_lg10();

    /* Local variables */
    static real edge[20], delf;
    static integer nodd;
    extern doublereal wate_();
    extern /* Subroutine */ int cmix_();
    static real temp;
    static integer nzmj;
    static real h[66];
    static integer i, j, k, l, n, lband, lgrid, nfmax;
    extern /* Subroutine */ int remes_();
    static integer nfilt;
    extern /* Subroutine */ int error_();
    static integer jtype, input, jb;
    static real hh[132], change;
    static doublereal pi;
    static real fx[10];
    static integer ix, nbands, nz;
    static real deviat[10], xt;
    static integer nm1;
    extern doublereal eff_();
    static integer neg;
    static real fup;
    static integer kup;
    static real wtx[10];
    static integer nf2j, nf3j;

    /* Fortran I/O blocks */
    static cilist io___9 = { 0, 6, 0, fmt_104, 0 };
    static cilist io___10 = { 0, 5, 0, 0, 0 };
    static cilist io___15 = { 0, 6, 0, fmt_120, 0 };
    static cilist io___16 = { 0, 5, 0, 0, 0 };
    static cilist io___19 = { 0, 6, 0, fmt_121, 0 };
    static cilist io___20 = { 0, 5, 0, 0, 0 };
    static cilist io___22 = { 0, 6, 0, fmt_122, 0 };
    static cilist io___23 = { 0, 5, 0, 0, 0 };
    static cilist io___40 = { 0, 0, 0, fmt_360, 0 };
    static cilist io___41 = { 0, 0, 0, fmt_365, 0 };
    static cilist io___42 = { 0, 0, 0, fmt_370, 0 };
    static cilist io___43 = { 0, 0, 0, fmt_375, 0 };
    static cilist io___44 = { 0, 0, 0, fmt_378, 0 };
    static cilist io___45 = { 0, 0, 0, fmt_380, 0 };
    static cilist io___47 = { 0, 0, 0, fmt_382, 0 };
    static cilist io___48 = { 0, 0, 0, fmt_383, 0 };
    static cilist io___49 = { 0, 4, 0, fmt_7865, 0 };
    static cilist io___53 = { 0, 4, 0, fmt_783, 0 };
    static cilist io___54 = { 0, 4, 0, fmt_783, 0 };
    static cilist io___55 = { 0, 0, 0, fmt_384, 0 };
    static cilist io___57 = { 0, 0, 0, fmt_385, 0 };
    static cilist io___58 = { 0, 0, 0, fmt_390, 0 };
    static cilist io___59 = { 0, 0, 0, fmt_395, 0 };
    static cilist io___60 = { 0, 0, 0, fmt_400, 0 };
    static cilist io___61 = { 0, 0, 0, fmt_405, 0 };
    static cilist io___62 = { 0, 0, 0, fmt_410, 0 };
    static cilist io___64 = { 0, 0, 0, fmt_425, 0 };
    static cilist io___65 = { 0, 0, 0, fmt_435, 0 };
    static cilist io___67 = { 0, 6, 0, fmt_460, 0 };
    static cilist io___68 = { 0, 6, 0, fmt_462, 0 };
    static cilist io___69 = { 0, 6, 0, fmt_459, 0 };
    static cilist io___70 = { 0, 6, 0, fmt_463, 0 };


    input = 5;
    oops_1.iout = 3;
    pi = atan(1.) * (float)4.;
    _BLNK__1.pi2 = pi * 2.;

/*  the program is set up for a maximum length of 128, but */
/*  this upper limit can be changed by redimensioning the */
/*  arrays iext, ad, alpha, x, y, h to be nfmax/2 + 2. */
/*  the arrays des, grid, and wt must dimensioned */
/*  16(nfmax/2 + 2). */

    nfmax = 128;
/* L100: */
    o__1.oerr = 0;
    o__1.ounit = 3;
    o__1.ofnmlen = 9;
    o__1.ofnm = "pmfil.lst";
    o__1.orl = 0;
    o__1.osta = 0;
    o__1.oacc = 0;
    o__1.ofm = 0;
    o__1.oblnk = 0;
    f_open(&o__1);
    o__1.oerr = 0;
    o__1.ounit = 4;
    o__1.ofnmlen = 12;
    o__1.ofnm = "response.dat";
    o__1.orl = 0;
    o__1.osta = 0;
    o__1.oacc = 0;
    o__1.ofm = 0;
    o__1.oblnk = 0;
    f_open(&o__1);
    o__1.oerr = 0;
    o__1.ounit = 18;
    o__1.ofnmlen = 6;
    o__1.ofnm = "cmixpm";
    o__1.orl = 0;
    o__1.osta = 0;
    o__1.oacc = 0;
    o__1.ofm = 0;
    o__1.oblnk = 0;
    f_open(&o__1);
    jtype = 0;

/*  program input section */

    s_wsfe(&io___9);
    e_wsfe();
    s_rsle(&io___10);
    do_lio(&c__3, &c__1, (char *)&nfilt, (ftnlen)sizeof(integer));
    do_lio(&c__3, &c__1, (char *)&jtype, (ftnlen)sizeof(integer));
    do_lio(&c__3, &c__1, (char *)&nbands, (ftnlen)sizeof(integer));
    e_rsle();
    if (nfilt == 0) {
	s_stop("", 0L);
    }
    if (nfilt <= nfmax || nfilt >= 3) {
	goto L115;
    }
    error_();
    s_stop("", 0L);
L115:
    if (nbands <= 0) {
	nbands = 1;
    }

/*  grid density is assumed to be 16 unless specified */
/*  otherwise */

    if (lgrid <= 0) {
	lgrid = 16;
    }
    jb = nbands << 1;
    s_wsfe(&io___15);
    e_wsfe();
    s_rsle(&io___16);
    i__1 = jb;
    for (j = 1; j <= i__1; ++j) {
	do_lio(&c__4, &c__1, (char *)&edge[j - 1], (ftnlen)sizeof(real));
    }
    e_rsle();
    s_wsfe(&io___19);
    e_wsfe();
    s_rsle(&io___20);
    i__1 = nbands;
    for (j = 1; j <= i__1; ++j) {
	do_lio(&c__4, &c__1, (char *)&fx[j - 1], (ftnlen)sizeof(real));
    }
    e_rsle();
    s_wsfe(&io___22);
    e_wsfe();
    s_rsle(&io___23);
    i__1 = nbands;
    for (j = 1; j <= i__1; ++j) {
	do_lio(&c__4, &c__1, (char *)&wtx[j - 1], (ftnlen)sizeof(real));
    }
    e_rsle();
    if (jtype > 0 && jtype <= 3) {
	goto L125;
    }
    error_();
    s_stop("", 0L);
L125:
    neg = 1;
    if (jtype == 1) {
	neg = 0;
    }
    nodd = nfilt / 2;
    nodd = nfilt - (nodd << 1);
    _BLNK__1.nfcns = nfilt / 2;
    if (nodd == 1 && neg == 0) {
	++_BLNK__1.nfcns;
    }

/*  set up the dense grid.  the number of points in the grid */
/*  is (filter length + 1)*grid density/2 */

    _BLNK__1.grid[0] = edge[0];
    delf = (real) (lgrid * _BLNK__1.nfcns);
    delf = (float).5 / delf;
    if (neg == 0) {
	goto L135;
    }
    if (edge[0] < delf) {
	_BLNK__1.grid[0] = delf;
    }
L135:
    j = 1;
    l = 1;
    lband = 1;
L140:
    fup = edge[l];
L145:
    temp = _BLNK__1.grid[j - 1];

/*  calculate the desired magnitude response and the weight */
/*  function on the grid */

    _BLNK__1.des[j - 1] = eff_(&temp, fx, wtx, &lband, &jtype);
    _BLNK__1.wt[j - 1] = wate_(&temp, fx, wtx, &lband, &jtype);
    ++j;
    _BLNK__1.grid[j - 1] = temp + delf;
    if (_BLNK__1.grid[j - 1] > fup) {
	goto L150;
    }
    goto L145;
L150:
    _BLNK__1.grid[j - 2] = fup;
    _BLNK__1.des[j - 2] = eff_(&fup, fx, wtx, &lband, &jtype);
    _BLNK__1.wt[j - 2] = wate_(&fup, fx, wtx, &lband, &jtype);
    ++lband;
    l += 2;
    if (lband > nbands) {
	goto L160;
    }
    _BLNK__1.grid[j - 1] = edge[l - 1];
    goto L140;
L160:
    _BLNK__1.ngrid = j - 1;
    if (neg != nodd) {
	goto L165;
    }
    if (_BLNK__1.grid[_BLNK__1.ngrid - 1] > (float).5 - delf) {
	--_BLNK__1.ngrid;
    }
L165:

/*  set up a new approximation problem which is equivalent */
/*  to the original problem */

    if (neg <= 0) {
	goto L170;
    } else {
	goto L180;
    }
L170:
    if (nodd == 1) {
	goto L200;
    }
    i__1 = _BLNK__1.ngrid;
    for (j = 1; j <= i__1; ++j) {
	change = cos(pi * _BLNK__1.grid[j - 1]);
	_BLNK__1.des[j - 1] /= change;
/* L175: */
	_BLNK__1.wt[j - 1] *= change;
    }
    goto L200;
L180:
    if (nodd == 1) {
	goto L190;
    }
    i__1 = _BLNK__1.ngrid;
    for (j = 1; j <= i__1; ++j) {
	change = sin(pi * _BLNK__1.grid[j - 1]);
	_BLNK__1.des[j - 1] /= change;
/* L185: */
	_BLNK__1.wt[j - 1] *= change;
    }
    goto L200;
L190:
    i__1 = _BLNK__1.ngrid;
    for (j = 1; j <= i__1; ++j) {
	change = sin(_BLNK__1.pi2 * _BLNK__1.grid[j - 1]);
	_BLNK__1.des[j - 1] /= change;
/* L195: */
	_BLNK__1.wt[j - 1] *= change;
    }

/*  initial guess for the extremal frequencies--equally */
/*  spaced along the grid */

L200:
    temp = (real) (_BLNK__1.ngrid - 1) / (real) _BLNK__1.nfcns;
    i__1 = _BLNK__1.nfcns;
    for (j = 1; j <= i__1; ++j) {
	xt = (real) (j - 1);
/* L210: */
	_BLNK__1.iext[j - 1] = xt * temp + (float)1.;
    }
    _BLNK__1.iext[_BLNK__1.nfcns] = _BLNK__1.ngrid;
    nm1 = _BLNK__1.nfcns - 1;
    nz = _BLNK__1.nfcns + 1;

/*  call the remes exchange algorithm to do the approximation */
/*  problem */

    remes_();

/*  calculate the impulse response. */

    if (neg <= 0) {
	goto L300;
    } else {
	goto L320;
    }
L300:
    if (nodd == 0) {
	goto L310;
    }
    i__1 = nm1;
    for (j = 1; j <= i__1; ++j) {
	nzmj = nz - j;
/* L305: */
	h[j - 1] = _BLNK__1.alpha[nzmj - 1] * (float).5;
    }
    h[_BLNK__1.nfcns - 1] = _BLNK__1.alpha[0];
    goto L350;
L310:
    h[0] = _BLNK__1.alpha[_BLNK__1.nfcns - 1] * (float).25;
    i__1 = nm1;
    for (j = 2; j <= i__1; ++j) {
	nzmj = nz - j;
	nf2j = _BLNK__1.nfcns + 2 - j;
/* L315: */
	h[j - 1] = (_BLNK__1.alpha[nzmj - 1] + _BLNK__1.alpha[nf2j - 1]) * (
		float).25;
    }
    h[_BLNK__1.nfcns - 1] = _BLNK__1.alpha[0] * (float).5 + _BLNK__1.alpha[1] 
	    * (float).25;
    goto L350;
L320:
    if (nodd == 0) {
	goto L330;
    }
    h[0] = _BLNK__1.alpha[_BLNK__1.nfcns - 1] * (float).25;
    h[1] = _BLNK__1.alpha[nm1 - 1] * (float).25;
    i__1 = nm1;
    for (j = 3; j <= i__1; ++j) {
	nzmj = nz - j;
	nf3j = _BLNK__1.nfcns + 3 - j;
/* L325: */
	h[j - 1] = (_BLNK__1.alpha[nzmj - 1] - _BLNK__1.alpha[nf3j - 1]) * (
		float).25;
    }
    h[_BLNK__1.nfcns - 1] = _BLNK__1.alpha[0] * (float).5 - _BLNK__1.alpha[2] 
	    * (float).25;
    h[nz - 1] = (float)0.;
    goto L350;
L330:
    h[0] = _BLNK__1.alpha[_BLNK__1.nfcns - 1] * (float).25;
    i__1 = nm1;
    for (j = 2; j <= i__1; ++j) {
	nzmj = nz - j;
	nf2j = _BLNK__1.nfcns + 2 - j;
/* L335: */
	h[j - 1] = (_BLNK__1.alpha[nzmj - 1] - _BLNK__1.alpha[nf2j - 1]) * (
		float).25;
    }
    h[_BLNK__1.nfcns - 1] = _BLNK__1.alpha[0] * (float).5 - _BLNK__1.alpha[1] 
	    * (float).25;

/*  program output section. */

/* since iout=3, the output is written to file 'pmfil.lst' */
L350:
    io___40.ciunit = oops_1.iout;
    s_wsfe(&io___40);
    e_wsfe();
    if (jtype == 1) {
	io___41.ciunit = oops_1.iout;
	s_wsfe(&io___41);
	e_wsfe();
    }
    if (jtype == 2) {
	io___42.ciunit = oops_1.iout;
	s_wsfe(&io___42);
	e_wsfe();
    }
    if (jtype == 3) {
	io___43.ciunit = oops_1.iout;
	s_wsfe(&io___43);
	e_wsfe();
    }
    io___44.ciunit = oops_1.iout;
    s_wsfe(&io___44);
    do_fio(&c__1, (char *)&nfilt, (ftnlen)sizeof(integer));
    e_wsfe();
/* for screen output, the impulse response is not written */
    if (oops_1.iout == 6) {
	goto L457;
    }
    io___45.ciunit = oops_1.iout;
    s_wsfe(&io___45);
    e_wsfe();
    i__1 = _BLNK__1.nfcns;
    for (j = 1; j <= i__1; ++j) {
	k = nfilt + 1 - j;
	if (neg == 0) {
	    io___47.ciunit = oops_1.iout;
	    s_wsfe(&io___47);
	    do_fio(&c__1, (char *)&j, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&h[j - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&k, (ftnlen)sizeof(integer));
	    e_wsfe();
	}
	if (neg == 1) {
	    io___48.ciunit = oops_1.iout;
	    s_wsfe(&io___48);
	    do_fio(&c__1, (char *)&j, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&h[j - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&k, (ftnlen)sizeof(integer));
	    e_wsfe();
	}
/* L381: */
    }
/* now to write impulse response to file 'response.dat' */
/* write the first half of the response */
/* ********************* write no. of coeffs. for convenience ******* */
    s_wsfe(&io___49);
    do_fio(&c__1, (char *)&nfilt, (ftnlen)sizeof(integer));
    e_wsfe();
    i__1 = _BLNK__1.nfcns;
    for (i = 1; i <= i__1; ++i) {
	hh[i - 1] = h[i - 1];
/* L785: */
    }
    if (nodd < 1) {
	i__1 = _BLNK__1.nfcns;
	for (n = 1; n <= i__1; ++n) {
	    hh[_BLNK__1.nfcns + n - 1] = h[_BLNK__1.nfcns - n];
/* L786: */
	}
	i__1 = _BLNK__1.nfcns << 1;
	for (i = 1; i <= i__1; ++i) {
	    s_wsfe(&io___53);
	    do_fio(&c__1, (char *)&hh[i - 1], (ftnlen)sizeof(real));
	    e_wsfe();
/* L787: */
	}
	i__1 = _BLNK__1.nfcns << 1;
	cmix_(hh, &i__1);
    } else {
	i__1 = _BLNK__1.nfcns - 1;
	for (n = 1; n <= i__1; ++n) {
	    hh[_BLNK__1.nfcns + n - 1] = h[_BLNK__1.nfcns - n - 1];
/* L788: */
	}
	i__1 = (_BLNK__1.nfcns << 1) - 1;
	for (i = 1; i <= i__1; ++i) {
	    s_wsfe(&io___54);
	    do_fio(&c__1, (char *)&hh[i - 1], (ftnlen)sizeof(real));
	    e_wsfe();
/* L789: */
	}
	i__1 = (_BLNK__1.nfcns << 1) - 1;
	cmix_(hh, &i__1);
    }
    if (neg == 1 && nodd == 1) {
	io___55.ciunit = oops_1.iout;
	s_wsfe(&io___55);
	do_fio(&c__1, (char *)&nz, (ftnlen)sizeof(integer));
	e_wsfe();
    }
L457:
    i__1 = nbands;
    for (k = 1; k <= i__1; k += 4) {
	kup = k + 3;
	if (kup > nbands) {
	    kup = nbands;
	}
	io___57.ciunit = oops_1.iout;
	s_wsfe(&io___57);
	i__2 = kup;
	for (j = k; j <= i__2; ++j) {
	    do_fio(&c__1, (char *)&bd1, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&bd2, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&bd3, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&bd4, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&j, (ftnlen)sizeof(integer));
	}
	e_wsfe();
	io___58.ciunit = oops_1.iout;
	s_wsfe(&io___58);
	i__2 = kup;
	for (j = k; j <= i__2; ++j) {
	    do_fio(&c__1, (char *)&edge[(j << 1) - 2], (ftnlen)sizeof(real));
	}
	e_wsfe();
	io___59.ciunit = oops_1.iout;
	s_wsfe(&io___59);
	i__2 = kup;
	for (j = k; j <= i__2; ++j) {
	    do_fio(&c__1, (char *)&edge[(j << 1) - 1], (ftnlen)sizeof(real));
	}
	e_wsfe();
	if (jtype != 2) {
	    io___60.ciunit = oops_1.iout;
	    s_wsfe(&io___60);
	    i__2 = kup;
	    for (j = k; j <= i__2; ++j) {
		do_fio(&c__1, (char *)&fx[j - 1], (ftnlen)sizeof(real));
	    }
	    e_wsfe();
	}
	if (jtype == 2) {
	    io___61.ciunit = oops_1.iout;
	    s_wsfe(&io___61);
	    i__2 = kup;
	    for (j = k; j <= i__2; ++j) {
		do_fio(&c__1, (char *)&fx[j - 1], (ftnlen)sizeof(real));
	    }
	    e_wsfe();
	}
	io___62.ciunit = oops_1.iout;
	s_wsfe(&io___62);
	i__2 = kup;
	for (j = k; j <= i__2; ++j) {
	    do_fio(&c__1, (char *)&wtx[j - 1], (ftnlen)sizeof(real));
	}
	e_wsfe();
	i__2 = kup;
	for (j = k; j <= i__2; ++j) {
/* L420: */
	    deviat[j - 1] = _BLNK__1.dev / wtx[j - 1];
	}
	io___64.ciunit = oops_1.iout;
	s_wsfe(&io___64);
	i__2 = kup;
	for (j = k; j <= i__2; ++j) {
	    do_fio(&c__1, (char *)&deviat[j - 1], (ftnlen)sizeof(real));
	}
	e_wsfe();
	if (jtype != 1) {
	    goto L450;
	}
	i__2 = kup;
	for (j = k; j <= i__2; ++j) {
/* L430: */
	    r__2 = (r__1 = deviat[j - 1] + fx[j - 1], dabs(r__1));
	    deviat[j - 1] = r_lg10(&r__2) * (float)20.;
	}
	io___65.ciunit = oops_1.iout;
	s_wsfe(&io___65);
	i__2 = kup;
	for (j = k; j <= i__2; ++j) {
	    do_fio(&c__1, (char *)&deviat[j - 1], (ftnlen)sizeof(real));
	}
	e_wsfe();
L450:
	;
    }
    i__1 = nz;
    for (j = 1; j <= i__1; ++j) {
	ix = _BLNK__1.iext[j - 1];
/* L452: */
	_BLNK__1.grid[j - 1] = _BLNK__1.grid[ix - 1];
    }
/* extremal frequencies not written out in this version */
/*      write(iout,455) (grid(j),j=1,nz) */
/* L455: */
/*      write(iout,460) */
/* L460: */
    if (oops_1.iout == 6) {
	goto L461;
    }
    oops_1.iout = 6;
    goto L350;
L461:
    s_wsfe(&io___67);
    e_wsfe();
    s_wsfe(&io___68);
    e_wsfe();
/* L458: */
    s_wsfe(&io___69);
    e_wsfe();
    s_wsfe(&io___70);
    e_wsfe();
    s_stop("", 0L);
} /* MAIN__ */

#undef bd4
#undef bd3
#undef bd2
#undef bd1



/* ----------------------------------------------------------------------- */
/* function: eff */
/*   function to calculate the desired magnitude response */
/*   as a function of frequency. */
/*   an arbitrary function of frequency can be */
/*   approximated if the user replaces this function */
/*   with the appropriate code to evaluate the ideal */
/*   magnitude.  note that the parameter freq is the */
/*   value of normalized frequency needed for evaluation. */
/* ----------------------------------------------------------------------- */

doublereal eff_(freq, fx, wtx, lband, jtype)
real *freq, *fx, *wtx;
integer *lband, *jtype;
{
    /* System generated locals */
    real ret_val;

    /* Parameter adjustments */
    --wtx;
    --fx;

    /* Function Body */
    if (*jtype == 2) {
	goto L1;
    }
    ret_val = fx[*lband];
    return ret_val;
L1:
    ret_val = fx[*lband] * *freq;
    return ret_val;
} /* eff_ */


/* ----------------------------------------------------------------------- */
/* function: wate */
/*   function to calculate the weight function as a function */
/*   of frequency.  similar to the function eff, this function can */
/*   be replaced by a user-written routine to calculate any */
/*   desired weighting function. */
/* ----------------------------------------------------------------------- */

doublereal wate_(freq, fx, wtx, lband, jtype)
real *freq, *fx, *wtx;
integer *lband, *jtype;
{
    /* System generated locals */
    real ret_val;

    /* Parameter adjustments */
    --wtx;
    --fx;

    /* Function Body */
    if (*jtype == 2) {
	goto L1;
    }
    ret_val = wtx[*lband];
    return ret_val;
L1:
    if (fx[*lband] < (float)1e-4) {
	goto L2;
    }
    ret_val = wtx[*lband] / *freq;
    return ret_val;
L2:
    ret_val = wtx[*lband];
    return ret_val;
} /* wate_ */


/* ----------------------------------------------------------------------- */
/* subroutine: error */
/*   this routine writes an error message if an */
/*   error has been detected in the input data. */
/* ----------------------------------------------------------------------- */

/* Subroutine */ int error_()
{
    /* Format strings */
    static char fmt_1[] = "(\002 ************ error in input data *********\
*\002)";

    /* Builtin functions */
    integer s_wsfe(), e_wsfe();

    /* Fortran I/O blocks */
    static cilist io___75 = { 0, 0, 0, fmt_1, 0 };


    io___75.ciunit = oops_1.iout;
    s_wsfe(&io___75);
    e_wsfe();
    return 0;
} /* error_ */


/* ----------------------------------------------------------------------- */
/* subroutine: remes */
/*   this subroutine implements the remes exchange algorithm */
/*   for the weighted chebyshev approximation of a continuous */
/*   function with a sum of cosines.  inputs to the subroutine */
/*   are a dense grid which replaces the frequency axis, the */
/*   desired function on this grid, the weight function on the */
/*   grid, the number of cosines, and an initial guess of the */
/*   extremal frequencies.  the program minimizes the chebyshev */
/*   error by determining the best location of the extremal */
/*   frequencies (points of maximum error) and then calculates */
/*   the coefficients of the best approximation. */
/* ----------------------------------------------------------------------- */

/* Subroutine */ int remes_()
{
    /* System generated locals */
    integer i__1, i__2;

    /* Builtin functions */
    double cos(), sqrt(), atan2();

    /* Local variables */
    static doublereal dden;
    static real delf, devl;
    extern /* Subroutine */ int ouch_();
    static real comp;
    static integer luck;
    static doublereal dnum;
    static integer klow, nzmj;
    static doublereal a[66];
    extern doublereal d_();
    static integer j, k, l;
    static doublereal p[65], q[65], dtemp;
    static real gtemp;
    static integer k1, nzzmj;
    static real y1, aa, bb;
    static doublereal dk;
    static real cn;
    static integer kn;
    static real ft, xe;
    static integer jchnge, nu, nz;
    static real xt;
    static integer itrmax, jm1, nm1, jp1;
    static real xt1;
    static doublereal dak;
    extern doublereal gee_();
    static real fsh;
    static integer kkk, jet;
    static real err;
    static integer kup, knz, jxt, nut;
    static real ynz;
    static integer nzz, nf1j, nut1;


/*  the program allows a maximum number of iterations of 25 */

    itrmax = 25;
    devl = (float)-1.;
    nz = _BLNK__1.nfcns + 1;
    nzz = _BLNK__1.nfcns + 2;
    oops_1.niter = 0;
L100:
    _BLNK__1.iext[nzz - 1] = _BLNK__1.ngrid + 1;
    ++oops_1.niter;
    if (oops_1.niter > itrmax) {
	goto L400;
    }
    i__1 = nz;
    for (j = 1; j <= i__1; ++j) {
	jxt = _BLNK__1.iext[j - 1];
	dtemp = _BLNK__1.grid[jxt - 1];
	dtemp = cos(dtemp * _BLNK__1.pi2);
/* L110: */
	_BLNK__1.x[j - 1] = dtemp;
    }
    jet = (_BLNK__1.nfcns - 1) / 15 + 1;
    i__1 = nz;
    for (j = 1; j <= i__1; ++j) {
/* L120: */
	_BLNK__1.ad[j - 1] = d_(&j, &nz, &jet);
    }
    dnum = (float)0.;
    dden = (float)0.;
    k = 1;
    i__1 = nz;
    for (j = 1; j <= i__1; ++j) {
	l = _BLNK__1.iext[j - 1];
	dtemp = _BLNK__1.ad[j - 1] * _BLNK__1.des[l - 1];
	dnum += dtemp;
	dtemp = (real) k * _BLNK__1.ad[j - 1] / _BLNK__1.wt[l - 1];
	dden += dtemp;
/* L130: */
	k = -k;
    }
    _BLNK__1.dev = dnum / dden;
/*      write(iout,131) dev */
/* intermeditate deviations not written in this version */
/* L131: */
    nu = 1;
    if (_BLNK__1.dev > (float)0.) {
	nu = -1;
    }
    _BLNK__1.dev = -(doublereal)((real) nu) * _BLNK__1.dev;
    k = nu;
    i__1 = nz;
    for (j = 1; j <= i__1; ++j) {
	l = _BLNK__1.iext[j - 1];
	dtemp = (real) k * _BLNK__1.dev / _BLNK__1.wt[l - 1];
	_BLNK__1.y[j - 1] = _BLNK__1.des[l - 1] + dtemp;
/* L140: */
	k = -k;
    }
    if (_BLNK__1.dev > devl) {
	goto L150;
    }
    ouch_();
    goto L400;
L150:
    devl = _BLNK__1.dev;
    jchnge = 0;
    k1 = _BLNK__1.iext[0];
    knz = _BLNK__1.iext[nz - 1];
    klow = 0;
    nut = -nu;
    j = 1;

/*  search for the extremal frequencies of the best */
/*  approximation */

L200:
    if (j == nzz) {
	ynz = comp;
    }
    if (j >= nzz) {
	goto L300;
    }
    kup = _BLNK__1.iext[j];
    l = _BLNK__1.iext[j - 1] + 1;
    nut = -nut;
    if (j == 2) {
	y1 = comp;
    }
    comp = _BLNK__1.dev;
    if (l >= kup) {
	goto L220;
    }
    err = gee_(&l, &nz);
    err = (err - _BLNK__1.des[l - 1]) * _BLNK__1.wt[l - 1];
    dtemp = (real) nut * err - comp;
    if (dtemp <= (float)0.) {
	goto L220;
    }
    comp = (real) nut * err;
L210:
    ++l;
    if (l >= kup) {
	goto L215;
    }
    err = gee_(&l, &nz);
    err = (err - _BLNK__1.des[l - 1]) * _BLNK__1.wt[l - 1];
    dtemp = (real) nut * err - comp;
    if (dtemp <= (float)0.) {
	goto L215;
    }
    comp = (real) nut * err;
    goto L210;
L215:
    _BLNK__1.iext[j - 1] = l - 1;
    ++j;
    klow = l - 1;
    ++jchnge;
    goto L200;
L220:
    --l;
L225:
    --l;
    if (l <= klow) {
	goto L250;
    }
    err = gee_(&l, &nz);
    err = (err - _BLNK__1.des[l - 1]) * _BLNK__1.wt[l - 1];
    dtemp = (real) nut * err - comp;
    if (dtemp > (float)0.) {
	goto L230;
    }
    if (jchnge <= 0) {
	goto L225;
    }
    goto L260;
L230:
    comp = (real) nut * err;
L235:
    --l;
    if (l <= klow) {
	goto L240;
    }
    err = gee_(&l, &nz);
    err = (err - _BLNK__1.des[l - 1]) * _BLNK__1.wt[l - 1];
    dtemp = (real) nut * err - comp;
    if (dtemp <= (float)0.) {
	goto L240;
    }
    comp = (real) nut * err;
    goto L235;
L240:
    klow = _BLNK__1.iext[j - 1];
    _BLNK__1.iext[j - 1] = l + 1;
    ++j;
    ++jchnge;
    goto L200;
L250:
    l = _BLNK__1.iext[j - 1] + 1;
    if (jchnge > 0) {
	goto L215;
    }
L255:
    ++l;
    if (l >= kup) {
	goto L260;
    }
    err = gee_(&l, &nz);
    err = (err - _BLNK__1.des[l - 1]) * _BLNK__1.wt[l - 1];
    dtemp = (real) nut * err - comp;
    if (dtemp <= (float)0.) {
	goto L255;
    }
    comp = (real) nut * err;
    goto L210;
L260:
    klow = _BLNK__1.iext[j - 1];
    ++j;
    goto L200;
L300:
    if (j > nzz) {
	goto L320;
    }
    if (k1 > _BLNK__1.iext[0]) {
	k1 = _BLNK__1.iext[0];
    }
    if (knz < _BLNK__1.iext[nz - 1]) {
	knz = _BLNK__1.iext[nz - 1];
    }
    nut1 = nut;
    nut = -nu;
    l = 0;
    kup = k1;
    comp = ynz * (float)1.00001;
    luck = 1;
L310:
    ++l;
    if (l >= kup) {
	goto L315;
    }
    err = gee_(&l, &nz);
    err = (err - _BLNK__1.des[l - 1]) * _BLNK__1.wt[l - 1];
    dtemp = (real) nut * err - comp;
    if (dtemp <= (float)0.) {
	goto L310;
    }
    comp = (real) nut * err;
    j = nzz;
    goto L210;
L315:
    luck = 6;
    goto L325;
L320:
    if (luck > 9) {
	goto L350;
    }
    if (comp > y1) {
	y1 = comp;
    }
    k1 = _BLNK__1.iext[nzz - 1];
L325:
    l = _BLNK__1.ngrid + 1;
    klow = knz;
    nut = -nut1;
    comp = y1 * (float)1.00001;
L330:
    --l;
    if (l <= klow) {
	goto L340;
    }
    err = gee_(&l, &nz);
    err = (err - _BLNK__1.des[l - 1]) * _BLNK__1.wt[l - 1];
    dtemp = (real) nut * err - comp;
    if (dtemp <= (float)0.) {
	goto L330;
    }
    j = nzz;
    comp = (real) nut * err;
    luck += 10;
    goto L235;
L340:
    if (luck == 6) {
	goto L370;
    }
    i__1 = _BLNK__1.nfcns;
    for (j = 1; j <= i__1; ++j) {
	nzzmj = nzz - j;
	nzmj = nz - j;
/* L345: */
	_BLNK__1.iext[nzzmj - 1] = _BLNK__1.iext[nzmj - 1];
    }
    _BLNK__1.iext[0] = k1;
    goto L100;
L350:
    kn = _BLNK__1.iext[nzz - 1];
    i__1 = _BLNK__1.nfcns;
    for (j = 1; j <= i__1; ++j) {
/* L360: */
	_BLNK__1.iext[j - 1] = _BLNK__1.iext[j];
    }
    _BLNK__1.iext[nz - 1] = kn;
    goto L100;
L370:
    if (jchnge > 0) {
	goto L100;
    }

/*  calculation of the coefficients of the best approximation */
/*  using the inverse discrete fourier transform */

L400:
    nm1 = _BLNK__1.nfcns - 1;
    fsh = (float)1e-6;
    gtemp = _BLNK__1.grid[0];
    _BLNK__1.x[nzz - 1] = (float)-2.;
    cn = (real) ((_BLNK__1.nfcns << 1) - 1);
    delf = (float)1. / cn;
    l = 1;
    kkk = 0;
    if (_BLNK__1.grid[0] < (float).01 && _BLNK__1.grid[_BLNK__1.ngrid - 1] > (
	    float).49) {
	kkk = 1;
    }
    if (_BLNK__1.nfcns <= 3) {
	kkk = 1;
    }
    if (kkk == 1) {
	goto L405;
    }
    dtemp = cos(_BLNK__1.pi2 * _BLNK__1.grid[0]);
    dnum = cos(_BLNK__1.pi2 * _BLNK__1.grid[_BLNK__1.ngrid - 1]);
    aa = (float)2. / (dtemp - dnum);
    bb = -(dtemp + dnum) / (dtemp - dnum);
L405:
    i__1 = _BLNK__1.nfcns;
    for (j = 1; j <= i__1; ++j) {
	ft = (real) (j - 1);
	ft *= delf;
	xt = cos(_BLNK__1.pi2 * ft);
	if (kkk == 1) {
	    goto L410;
	}
	xt = (xt - bb) / aa;
	xt1 = sqrt((float)1. - xt * xt);
	ft = atan2(xt1, xt) / _BLNK__1.pi2;
L410:
	xe = _BLNK__1.x[l - 1];
	if (xt > xe) {
	    goto L420;
	}
	if (xe - xt < fsh) {
	    goto L415;
	}
	++l;
	goto L410;
L415:
	a[j - 1] = _BLNK__1.y[l - 1];
	goto L425;
L420:
	if (xt - xe < fsh) {
	    goto L415;
	}
	_BLNK__1.grid[0] = ft;
	a[j - 1] = gee_(&c__1, &nz);
L425:
	if (l > 1) {
	    --l;
	}
/* L430: */
    }
    _BLNK__1.grid[0] = gtemp;
    dden = _BLNK__1.pi2 / cn;
    i__1 = _BLNK__1.nfcns;
    for (j = 1; j <= i__1; ++j) {
	dtemp = (float)0.;
	dnum = (doublereal) (j - 1);
	dnum *= dden;
	if (nm1 < 1) {
	    goto L505;
	}
	i__2 = nm1;
	for (k = 1; k <= i__2; ++k) {
	    dak = a[k];
	    dk = (doublereal) k;
/* L500: */
	    dtemp += dak * cos(dnum * dk);
	}
L505:
	dtemp = dtemp * (float)2. + a[0];
/* L510: */
	_BLNK__1.alpha[j - 1] = dtemp;
    }
    i__1 = _BLNK__1.nfcns;
    for (j = 2; j <= i__1; ++j) {
/* L550: */
	_BLNK__1.alpha[j - 1] = _BLNK__1.alpha[j - 1] * (float)2. / cn;
    }
    _BLNK__1.alpha[0] /= cn;
    if (kkk == 1) {
	goto L545;
    }
    p[0] = _BLNK__1.alpha[_BLNK__1.nfcns - 1] * (float)2. * bb + 
	    _BLNK__1.alpha[nm1 - 1];
    p[1] = aa * (float)2. * _BLNK__1.alpha[_BLNK__1.nfcns - 1];
    q[0] = _BLNK__1.alpha[_BLNK__1.nfcns - 3] - _BLNK__1.alpha[_BLNK__1.nfcns 
	    - 1];
    i__1 = nm1;
    for (j = 2; j <= i__1; ++j) {
	if (j < nm1) {
	    goto L515;
	}
	aa *= (float).5;
	bb *= (float).5;
L515:
	p[j] = (float)0.;
	i__2 = j;
	for (k = 1; k <= i__2; ++k) {
	    a[k - 1] = p[k - 1];
/* L520: */
	    p[k - 1] = bb * (float)2. * a[k - 1];
	}
	p[1] += a[0] * (float)2. * aa;
	jm1 = j - 1;
	i__2 = jm1;
	for (k = 1; k <= i__2; ++k) {
/* L525: */
	    p[k - 1] = p[k - 1] + q[k - 1] + aa * a[k];
	}
	jp1 = j + 1;
	i__2 = jp1;
	for (k = 3; k <= i__2; ++k) {
/* L530: */
	    p[k - 1] += aa * a[k - 2];
	}
	if (j == nm1) {
	    goto L540;
	}
	i__2 = j;
	for (k = 1; k <= i__2; ++k) {
/* L535: */
	    q[k - 1] = -a[k - 1];
	}
	nf1j = _BLNK__1.nfcns - 1 - j;
	q[0] += _BLNK__1.alpha[nf1j - 1];
L540:
	;
    }
    i__1 = _BLNK__1.nfcns;
    for (j = 1; j <= i__1; ++j) {
/* L543: */
	_BLNK__1.alpha[j - 1] = p[j - 1];
    }
L545:
    if (_BLNK__1.nfcns > 3) {
	return 0;
    }
    _BLNK__1.alpha[_BLNK__1.nfcns] = (float)0.;
    _BLNK__1.alpha[_BLNK__1.nfcns + 1] = (float)0.;
    return 0;
} /* remes_ */


/* ----------------------------------------------------------------------- */
/* function: d */
/*   function to calculate the lagrange interpolation */
/*   coefficients for use in the function gee. */
/* ----------------------------------------------------------------------- */

doublereal d_(k, n, m)
integer *k, *n, *m;
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    doublereal ret_val;

    /* Local variables */
    static integer j, l;
    static doublereal q;

    ret_val = (float)1.;
    q = _BLNK__1.x[*k - 1];
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	i__2 = *n;
	i__3 = *m;
	for (j = l; i__3 < 0 ? j >= i__2 : j <= i__2; j += i__3) {
	    if (j - *k != 0) {
		goto L1;
	    } else {
		goto L2;
	    }
L1:
	    ret_val = ret_val * (float)2. * (q - _BLNK__1.x[j - 1]);
L2:
	    ;
	}
/* L3: */
    }
    ret_val = (float)1. / ret_val;
    return ret_val;
} /* d_ */


/* ----------------------------------------------------------------------- */
/* function: gee */
/*   function to evaluate the frequency response using the */
/*   lagrange interpolation formula in the barycentric form */
/* ----------------------------------------------------------------------- */

doublereal gee_(k, n)
integer *k, *n;
{
    /* System generated locals */
    integer i__1;
    doublereal ret_val;

    /* Builtin functions */
    double cos();

    /* Local variables */
    static doublereal c, d;
    static integer j;
    static doublereal p, xf;

    p = (float)0.;
    xf = _BLNK__1.grid[*k - 1];
    xf = cos(_BLNK__1.pi2 * xf);
    d = (float)0.;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	c = xf - _BLNK__1.x[j - 1];
	c = _BLNK__1.ad[j - 1] / c;
	d += c;
/* L1: */
	p += c * _BLNK__1.y[j - 1];
    }
    ret_val = p / d;
    return ret_val;
} /* gee_ */


/* ----------------------------------------------------------------------- */
/* subroutine: ouch */
/*   writes an error message when the algorithm fails to */
/*   converge.  there seem to be two conditions under which */
/*   the algorithm fails to converge: (1) the initial */
/*   guess for the extremal frequencies is so poor that */
/*   the exchange iteration cannot get started, or */
/*   (2) near the termination of a correct design, */
/*   the deviation decreases due to rounding errors */
/*   and the program stops.  in this latter case the */
/*   filter design is probably acceptable, but should */
/*   be checked by computing a frequency response. */
/* ----------------------------------------------------------------------- */

/* Subroutine */ int ouch_()
{
    /* Format strings */
    static char fmt_1[] = "(\002 ************ failure to converge *********\
*\002/\0020probable cause is machine rounding error\002/\0020number of itera\
tions =\002,i4/\0020if the number of iterations exceeds 3,\002/\0020the desi\
gn may be correct, but should be verified with an fft\002)";

    /* Builtin functions */
    integer s_wsfe(), do_fio(), e_wsfe();

    /* Fortran I/O blocks */
    static cilist io___132 = { 0, 0, 0, fmt_1, 0 };


    io___132.ciunit = oops_1.iout;
    s_wsfe(&io___132);
    do_fio(&c__1, (char *)&oops_1.niter, (ftnlen)sizeof(integer));
    e_wsfe();
    return 0;
} /* ouch_ */

