#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "../macros/delmacros.h"
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>

#define ARRSIZE 16384
#define SIZE 512

extern SFHEADER      sfdesc[NFILES];

        float xin[2*ARRSIZE],out[2*ARRSIZE],del[44100],xmax,*f1;
 
double
flange(p,n_args)

float *p;

{
        long i,nsamps,n,count,smps = 0;
        float amp,val,phase,si,wait,samprate;
        int lenfl,flangef,lll[5],j,jj,z,chans,xinchan;
        extern struct stat sfst[NFILES];
        extern int lineset;
        extern float array[SIZE],tabs[2]; /* for setline */
	static int is_scaled = 0;
        
/*  p0=insk, p1=outsk, p2=dur, p3=amp, p4=flange freq, 
    p5=regen, p6=flangedelay, p7=inchan, p8=pctlft */
/*  assumes function 1 is flange cycle                                  */

        if (p[2] == 0)
                p[2] = ((float)(sfst[0].st_size - SIZEOF_BSD_HEADER)
                         /(float)sfclass(&sfdesc[0])/(float)sfchans(&sfdesc[0])
                         /sfsrate(&sfdesc[0])) - p[0];
        setnote(p[0],p[2],0);
        nsamps = setnote(p[1],p[2],1);

	if (sfchans(&sfdesc[1]) != 2) {
		fprintf(stderr,"output file must be stereo!!!!!!!\n");
		return(-1);
		}
	
        xmax=.25;
        flangef = 1;
        lenfl = fsize(flangef);
        f1 = (float *) floc(flangef);
	if (!is_scaled) {
        	for (j = 0; j < lenfl; j++) {
       	        	f1[j] = (f1[j] + 1.)/2. * p[6];
                	}
		is_scaled = 1;
		}
        
        for (j = 0; j < 44100; j++)
                del[j] = 0.0;
        samprate = sfsrate(&sfdesc[0]);
        si = p[4] * (float)lenfl/samprate;
        if(!lineset) {
                for(j = 0; j < SIZE; j++) array[j] = 1;
                fprintf(stderr,"Set phrase curve to all 1's\n");
                lineset = 1;
                }
        tableset(p[2], SIZE, tabs);
        delset(del,lll,xmax);
        z = samprate/100;
        jj = 0;
        amp = p[3];
        phase = 0.;
        val = p[3];
        chans = sfchans(&sfdesc[0]);
        xinchan = p[7];
        for (i = nsamps; i > 0; i -= ARRSIZE) {
                count = (i < ARRSIZE) ? i : ARRSIZE;
                count *= chans;
                bgetin(xin,0,count);
                for (n = 0,j = 0; n < count; n += chans,j += 2) {
                        while (!jj--) {
                                val = tablei(smps,array,tabs) * amp;
                                jj = z;
                                smps += z;
                                }
                        wait = oscili(1.0,si,f1,lenfl,&phase);
                        out[j] = xin[n+xinchan] + dliget(del,wait,lll) * p[5];
                        delput(out[j],del,lll);
                        out[j] *= val;
                        out[j+1] = out[j] * p[8];
                        out[j] -= out[j+1];
                        }

                if (chans == 1) count *= 2;
                baddout(out,1,count);
                }
       endnote(1);
}

profile()
{
	UG_INTRO("flange", flange);
	UG_INTRO("setline", setline);
}
