#include "../../H/ugens.h"
#include "../../H/sfheader.h"
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>


extern SFHEADER      sfdesc[NFILES];

double
gran(p,n_args)
 
float *p; /* array of p-fields */
int n_args; /* number of p-fields */

{
        int i,n,nsamps,ngrains,grainsamps,graindist,grainslide;
        float si,phase,val,amp,out[2],tt[2],*wave,*envel;
        int len,j,z,chans,randflag=0;
	int outrepos();
	float rrand();
	void srrand();

/* p0=start, p1=dur, p2=amp, p3=grainsize, p4=grainrate,
   p5=grainfreq (negative means noise), [p6=stereo placement] */
/* gen 1 is wavform (overwritten if p5 is neg.); gen 2 is grain envelope */

        nsamps = setnote(p[0],p[1],0); /* set file position */

        wave = (float *) floc(1); /* finds starting loc. of waveform */
        len = fsize(1); /* length of playing waveform function */
	envel = (float *) floc(2);

	if (p[5] < 0) {  /* negative means use noise */
		randflag = 1;
		srrand(.414);
		}
        else if (p[5] < 15.0) {
                p[5] = cpspch(p[5]);
		}
	si = p[5] * (float)len/SR;

	grainsamps = p[3] * SR;
	graindist = p[4] * SR;
	grainslide = graindist - grainsamps;
	ngrains = nsamps / graindist;

	tableset(p[3],fsize(2),tt);

        z =  2;
        j = 0; /* "branch once a cycle" loop for amp envelope */

        chans = sfchans(&sfdesc[0]); /* get file number of channels */
        amp = p[2];

        for(i = 0; i < ngrains; i++) {
        	phase = 0;
		for (n = 0; n < grainsamps; n++) {
	                while (!j--) {   /* branch in here when j reaches 0 */
	                        val = amp * tablei(n,envel,tt);
                        	j = ((grainsamps-n) > z) ? z : (grainsamps-n);
                        	}

			if (!randflag) {
                		out[0] =  oscili(val,si,wave,len,&phase);
				}
			else {
				out[0] = rrand() * val;
				}

                	if (chans > 1) { /* stereo */
                        	out[1] = (1.0 - p[6]) * out[0];
                        	out[0] *= p[6];
                        	}

                	ADDOUT(out,0);
                	}

		outrepos(grainslide,0);
		}

        endnote(0);
}

profile()
{
	UG_INTRO("gran",gran); 
}
