#include "../../H/ugens.h"
#include "../../H/sfheader.h"
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>


extern SFHEADER      sfdesc[NFILES];

double
mgran(p,n_args)
 
float *p; /* array of p-fields */
int n_args; /* number of p-fields */

{
        int i,n,nsamps,bgrainsamps,bgraindist,bgrainslide;
        int egrainsamps,egraindist,egrainslide;
        int grainsamps,grainslide;
        float si,phase,val,amp,out[2],tt[2],*wave,*envel;
	float gsainc,gslinc;
        int len,j,z,chans,randflag=0;
	int outrepos();
	float rrand();
	void srrand();

/* p0=start, p1=dur, p2=amp, p3=beg. grainsize, p4=beg. grainrate,
   p5=grainfreq (negative means noise), p6=end grainsize,
   p7=end grainrate, [p9=beg. stereo, p10=end stereo] */
/* gen 1 is wavform (unused if p5 is neg.); gen 2 is grain envelope */

        nsamps = setnote(p[0],p[1],0); /* set file position */

        wave = (float *) floc(1); /* finds starting loc. of waveform */
        len = fsize(1); /* length of playing waveform function */
	envel = (float *) floc(2);

	if (p[5] < 0) {  /* negative means use noise */
		randflag = 1;
		srrand(.414);
		}
        else if (p[5] < 15.0) {
                p[5] = cpspch(p[5]);
		}
	si = p[5] * (float)len/SR;

	bgrainsamps = grainsamps = p[3] * SR;
	bgraindist = p[4] * SR;
	bgrainslide = grainslide = bgraindist - bgrainsamps;

	egrainsamps = p[6] * SR;
	egraindist = p[7] * SR;
	egrainslide = egraindist - egrainsamps;

	gsainc = (float)(egrainsamps - bgrainsamps)/(float)nsamps;
	gslinc = (float)(egrainslide - bgrainslide)/(float)nsamps;

        z =  2;
        j = 0; /* "branch once a cycle" loop for amp envelope */

        chans = sfchans(&sfdesc[0]); /* get file number of channels */
        amp = p[2];

        for(i = 0; i < nsamps; i++) {
        	phase = 0;
		tableset(grainsamps/SR,fsize(2),tt);
		for (n = 0; n < grainsamps; n++) {
	                while (!j--) {   /* branch in here when j reaches 0 */
	                        val = amp * tablei(n,envel,tt);
                        	j = ((grainsamps-n) > z) ? z : (grainsamps-n);
                        	}

			if (!randflag) {
                		out[0] =  oscili(val,si,wave,len,&phase);
				}
			else {
				out[0] = rrand() * val;
				}

                	if (chans > 1) { /* stereo */
                        	out[1] = (1.0 - p[6]) * out[0];
                        	out[0] *= p[6];
                        	}

                	ADDOUT(out,0);
                	}

		outrepos(grainslide,0);
		i += grainsamps;
		i += grainslide;
		grainsamps = (float)bgrainsamps + (float)i * gsainc;
		grainslide = (float)bgrainslide + (float)i * gslinc;
		}

        endnote(0);
}

profile()
{
	UG_INTRO("mgran",mgran);
}
