#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <ugens.h>
#include <sfheader.h>
#include "nobug.h"

extern SFHEADER      sfdesc[NFILES];
 
gravy(p,n_args)
float *p;

{
	int insize,insamps,outsize,outsamps,bevsamps,realsamps,j;
	int inshift,outshift;
	float *inarr,*outarr,*bevfunc,q[9],z,val;
	double vold,old,new,frac,count, finshift;
	char *malloc();
	float transpose();
	long i,k,intt,lgc,nsamps,n,ncuts;
	double interp();

/*  p0=insk; p1=outsk; p2=outdur; p3=frame size; p4=bevel time;		*/
/*  p5=length mult (of orig); p6=transp interval (oct.pc)		*/
/*  assumes function 1 is the bevel function				*/
/*  also assume mono input and output (for now)				*/

	p[6] = transpose(p[6]);
	p[5] = p[5]/p[6];

	insamps = p[3] * SR * p[6] + 1;	/* one larger for interp guard */
	insize = insamps;
	if ( (inarr = (float *)malloc(insize*FLOAT)) == NULL ) {
		fprintf(stderr,"error in allocating input array... sorry!\n");
		exit(-2);
		}
	
	outsamps = p[3] * SR;		/* size of output buffer */
	outsize = outsamps;
	if ( (outarr = (float *)malloc(outsize*FLOAT)) == NULL ) {
		fprintf(stderr,"error allocating output array... sorry!\n");
		exit(-2);
		}

	bevsamps = p[4] * SR;
	bevfunc = floc(1);
	evset(p[3],p[4],p[4],1,q);
	ncuts = p[2]/(p[3]-p[4]);	/* outdur/(frametime-beveltime) */
	realsamps = insamps - bevsamps * p[6]; /* # of new samps per frame */

	/* inshift= (incrmnt-1) * new_samps_per_frame - bevel_samps_per_frame */

	inshift = (p[5] - 1.0) * (float)realsamps - (float)bevsamps * p[6];
	outshift = -bevsamps;

	nsamps = setnote(p[0],p[3],0);
	setnote(p[1],p[2],1);
	z = SR/10000;

	for (n = 0; n <= ncuts; n++) {
		bgetin(inarr,0,insize);
		j = k = 0;
		vold = inarr[k++];
		old = inarr[k++];
		new = inarr[k++];
		intt = lgc = 0;
		frac = count = 0;

		for (i = 0; i < nsamps; i++) {
			while(!j--) {
				val = evp(i,bevfunc,bevfunc,q);
				j = z;
				}
			while (intt > lgc) {
				vold = old;
				old = new;
				new = inarr[k++];
				lgc++;
				}
			outarr[i] = (float) interp(vold, old, new, frac) * val;
			count += p[6];
			intt = count;
			frac = count - (float) intt;
			}

		baddout(outarr,1,outsize);
		inrepos(inshift,0);
		outrepos(outshift,1);
		}
	endnote(1);
}


float transpose(num)
float num;

{
	int octave;
	float fract,mult;
	double pow();

	octave = num;
	fract = (num - (float)octave)/.12;
	mult = (float)pow(2.0, (double)(fract + (float)octave));
	return(mult);
}

double interp(y0,y1,y2,t)
    register double t, y0, y1, y2;
{
    register double hy2, hy0, a, b, c;
    
    a = y0;
    hy0 = y0/2.0;
    hy2 =  y2/2.0;
    b = (-3.0 * hy0) + (2.0 * y1) - hy2;
    c = hy0 - y1 + hy2;

    return(a + b*t + c*t*t);
}
