#include "../H/ugens.h"
#include "../H/sfheader.h"
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>

#define SIZE 1024
#define ARRAYSIZE 16384

extern SFHEADER	sfdesc[NFILES];
float parray[SIZE];
float sarray[SIZE];
float *array;
int RESET = 200;  /* times per sec to reinitialize envel */

double pan(float *p,int n_args,double *pp);
double sl(float *p,int n_args,double *pp);
double reset(float *p,int n_args,double *pp);
//double pl(float *p,int n_args,double *pp);
double panline(float *,int, double *);
void profile(void);

extern double setline(float *p,int n_args,double *pp);
extern int setnote(double,double,int);
extern void tableset(float, int, float *);
extern float tablei(int, float *, float *);

extern struct stat sfst[NFILES];
int lineset=0;
int setflag = 0;
int NBYTES = 32768;
	
double
pan(float *p,int n_args,double *pp)
{
	int i,nsamps,n,m,count,smps = 0,x;
	float val, sval,sr;
//	float xin[2*SIZE],out[2*SIZE];
	float *xin,*xout,dur;
	int ch,j,z=0,chin;
	float tabs[2]; /* for panline */
	float stabs[2]; /* for setline */

/*  p0=insk, p1=outsk, p2=dur, p3=ch to treat	*/

/*	if (p[2] == 0)
		p[2] = ((float)(sfst[0].st_size - SIZEOF_BSD_HEADER)
			 /(float)sfclass(&sfdesc[0])/(float)sfchans(&sfdesc[0])
			 /sfsrate(&sfdesc[0])) - p[0]; */
	p=p;n_args=n_args;

	setnote(pp[0],pp[2],0); // setnote for input file
	nsamps = setnote(pp[1],pp[2],1); // setnote for output file

	if ( sfchans(&sfdesc[1]) < 2 ) {
		fprintf(stderr,"output must be 2 channels!\n");
		exit(-1);
		}

	if(!lineset) {
		fprintf(stderr,"you big dummy... panline!!!\n");
		exit(-1);
		}
	dur = (float)pp[2];
  tableset(dur, SIZE, tabs);
  if(setflag) tableset(dur, SIZE, stabs);
	else sval=1.0;
	chin = sfchans(&sfdesc[0]);

	j = 0;
	ch = (int)pp[3];
	sr = sfsrate(&sfdesc[0]);
	z = sr/RESET;
	
	xin =(float*)malloc(ARRAYSIZE*2);
	xout =(float*)malloc(ARRAYSIZE*2);

  for (i = nsamps,x=0; i > 0; i -= SIZE,x+=SIZE) {
		count = (i < SIZE) ? i : SIZE;
		BGETIN(xin,0,count*chin);
		count *= 2; /* output is 2 chan */

		for (n = 0, m=0;n < count; n+=2, m += chin) {
			while (!j--) {
				val = tablei(x+m,parray,tabs); // pan array vals
				if(setflag) sval = tablei(x+m,sarray,stabs);
				j = z;
				smps += z;
			}
//printf ("val %f sval %f\n",val,sval);
			xout[n] = (xin[m+ch] * (1.0 - val)) * sval;
			xout[n+1] = (xin[m+ch] * val) * sval;
			}
		BADDOUT(xout,1,count);
		}
   endnote(1);
   	return 0;
}

double sl(float *p,int n_args,double *pp)
{
	p=p;
//	setline(pp,n_args,SIZE,array);
	array=sarray;
	setline(p,n_args,pp);
	lineset=1;
	setflag=1;
	return 0.0;
}
/*
double pl(float *p,int n_args,double *pp)
{
	p=p;
	array=parray;
//	setline(pp,n_args,SIZE,parray);
	setline(p,n_args,pp);
	lineset=1;
	setflag=1;
	return 0.0;
}
*/

double
panline(float *p,int n_args, double *pp)
{
	double increm;
	int i,j,k,points;

	p=p;
	if((n_args % 2) != 0) {
		fprintf(stderr,"Something wrong with phrase, check args for mix setline\n");
		closesf();
	}

	lineset = 1;   /* initialized array */
	increm = (pp[n_args - 2] - pp[0])/(double)SIZE;
	for(j=0,i=0; j < (n_args-2); j += 2) {
		points = (int)((pp[j+2] - pp[j]) / increm +.5);
		if(pp[j+2] != pp[j]) {
			if(points <= 0) points = 1;
			if((pp[j+2] < pp[j]) || (points > SIZE)) {
				fprintf(stderr," confusion on phrase card\n");
				closesf();
				}
			for(k=0; k < points; k++) {
				parray[i++] = ((float)k/(float)points)
					* (pp[j+3] - pp[j+1]) + pp[j+1];
				if(i == SIZE) return(0.0);
			}
		}
	}
	i--;
	while(++i < SIZE) parray[i] = parray[i-1]; 
	return(0.0);
}

double
reset(float *p,int n_args,double *pp)
{
	p=p; n_args=n_args;
	if(pp[0]) RESET = pp[0];
	fprintf(stderr,"envel calls set to %d times per sec\n",RESET);
  return 0;
}

void
profile(void)
{
	UG_INTRO("pan", pan);
//	UG_INTRO("setline", setline);
	UG_INTRO("panline", panline);
	UG_INTRO("setline", sl);
	UG_INTRO("reset", reset);
}
