#include "ugens.h"
#include "sfheader.h"
#include <stdio.h>
#include <unistd.h>

#define ARRSIZE 16384
#define SIZE 512

int NBYTES = 32768; /* byte size of buffers to use for disk i/o, the larger the
                   * better, usually, since there will be less i/o */

extern SFHEADER      sfdesc[NFILES];
extern void delput(float,float *,int  *);
extern void delset(float *,int *,float);
extern float delget(float *,double,int *);
extern int setnote(double,double ,int);
extern int tableset(double, int, float *);

float amp,val,del1[100000],del2[100000],xmax,tail,tester;
float xin[ARRSIZE],out[ARRSIZE*2],cutoff,test=1;

double
panecho(float *p,int n_args, double *pp)
{
long i,nsamps,nend,n,m,count,smps=0;
int j,z,l1[2],l2[2];
int lineset=1;
float array[SIZE],tabs[2];
struct stat sfst[NFILES];
        
/*  p0=insk, p1=outsk, p2=indur, p3=amp, p4=wait1, p5=wait2
    p6=regen, p7=maxlengthout                           */
			p=p;n_args=n_args;
        if (pp[2] == 0)
                pp[2] = ((float)(sfst[0].st_size - SIZEOF_BSD_HEADER)
                         /(float)sfclass(&sfdesc[0])/(float)sfchans(&sfdesc[0])
                         /sfsrate(&sfdesc[0])) - pp[0];
        nsamps = setnote(pp[0],pp[2],0);
        setnote(pp[1],pp[2],1);
        xmax=2;
        delset(del1,l1,xmax);
        delset(del2,l2,xmax);
	
/*	if (sfchans(&sfdesc[0]) != 1) {
		fprintf(stderr,"input file must be mono!!!!!!!\n");
		return(-1);
		}
*/

	if (sfchans(&sfdesc[1]) != 2) {
		fprintf(stderr,"output file must be stereo!!!!!!!\n");
		return(-1);
		}
	
	if ( (pp[4] * SR) > 100000 ) {
		fprintf(stderr,"delay time is too long!!!!!!!\n");
		return(-1);
		}

	if ( (pp[5] * SR) > 100000 ) {
		fprintf(stderr,"delay time is too long!!!!!!!\n");
		return(-1);
		}

        if(!lineset) {
                for(j = 0; j < SIZE; j++) array[j] = 1;
                fprintf(stderr,"Set phrase curve to all 1's\n");
                lineset = 1;
                }
        tableset(pp[2], SIZE, tabs);

	tester = ( pp[4] > pp[5] ? pp[4] : pp[5] );
        cutoff = .001;
        for (tail = 0; tail < pp[7]; tail += tester) {
                test *= pp[6];
                if (test < cutoff)
                        break;
                }
        nend = tail * SR;

        for (i = 0; i < 100000; i++) {
                del1[i] = 0;
                del2[i] = 0;
                }

        amp = pp[3];
        z = SR/100;
        j = 0;
        for (i = nsamps; i > 0; i -= ARRSIZE) {
                count = (i < ARRSIZE) ? i : ARRSIZE;
                BGETIN(xin,0,count);
                count *= 2; /* output file is 2-channel */
                for (n = 0,m = 0; n < count; n += 2) {
                        while (!j--) {
                                val = tablei(smps,array,tabs) * amp;
                                j = z;
                                smps += z;
                                }
                        out[n] = (xin[m] * val) + delget(del2,pp[4],l2) * pp[6];
                        out[n+1] = delget(del1,pp[5],l1);
                        delput(out[n+1],del2,l2);
                        delput(out[n],del1,l1);
			m++;
                        }
                BADDOUT(out,1,count);
                }

        for (i = nend; i > 0; i -= ARRSIZE) {
                count = (i < ARRSIZE) ? i : ARRSIZE;
                count *= 2;
                for (n = 0; n < count; n += 2) {
                        out[n] = delget(del2,pp[4],l2) * pp[6];
                        out[n+1] = delget(del1,pp[5],l1);
                        delput(out[n+1],del2,l2);
                        delput(out[n],del1,l1);
                        }
                BADDOUT(out,1,count);
                }
       endnote(1);
	return(0);
}

void
profile()
{

	UG_INTRO("panecho", panecho);
	UG_INTRO("setline", setline);
}
