#include <ugens.h>
#include <sfheader.h>
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>

#define SIZE	512

extern SFHEADER      sfdesc[NFILES];
float array[SIZE],tabs[2];		/* for setline */
float inarr[85000],outarr[50000];
extern int lineset;
 
samgran(p,n_args)
float *p;
{

/*  p0=insk; p1=outsk; p2=indur; p3=outdur; p4=framesize(sec.)		*/
/*  p5=bevelsize(sec.); p6=maxperiodlen(sec,Hz,8v.pc)  			*/
/*  assumes function 1 is the bevel function				*/
/*  also assume mono input and output (for now)				*/
/*  Based on Jones and Parks article in CMJ v12, n2			*/

/* see if malloc works */

	double maxCorr;  	/* maximum correlation value 	*/
	long Ncorr;		/* correlation interval 	*/
	long A;			/* point at which overlap begins*/
	long Ns;		/* search interval		*/
	long L;			/* nominal next starting point	*/
	long k;			/* correlation point - sliding	*/
	long m;			/* correlation sample   	*/
	long M;			/* sample with best correlation */
	double corr;		/* correlation value		*/
	long n; 		/* frame number			*/
	long s;			/* sample number		*/
	long inshift,outshift;  /* # samples to reposition fptr */
	long framesize,bevelsize,frames,insize;
	long periodsize;	/* lowest period num samples	*/
	int  i,j;
	float indur,outdur,insk,outsk,maxperiod;
	float *bevfunc,q[9],z,val;
	float framesec,bevelsec;

	insk = p[0];
	outsk = p[1];
	indur = p[2];
	outdur = p[3];
	framesec = p[4];
	bevelsec = p[5];
	framesize = framesec * SR + 1;
	bevelsize = bevelsec * SR;
	if(p[6] < 1.) 			/* p[6] is in seconds	*/
		maxperiod = p[6];
	else if(p[6] < 15)		/* p[6] is in 8v.pc   	*/
		maxperiod = 1./cpspch(p[6]);
	else 				/* p[6] is in Hz 	*/
		maxperiod = 1./p[6];
	periodsize = maxperiod * SR;

	Ns = Ncorr = periodsize;
printf("periodsize = %ld,Ns =%ld, Ncorr=%ld\n",periodsize,Ns,Ncorr);
	
	frames = outdur/(framesec-bevelsec) + 1;
	L = (indur/frames)*SR; 	/* nominal grain increment */
	
	bevfunc = floc(1);
	evset(framesec,bevelsec,bevelsec,1,q);

	setnote(p[0],p[3],0); /* p2? */
	setnote(p[1],p[3],1);
	z = SR/5000;

  	tableset(p[3],SIZE,tabs);
     	if(!lineset) {
                for(j = 0; j < SIZE; j++)
                        array[j] = 1;
                fprintf(stderr,"Set phrase curve to all 1's\n");
                lineset = 1;
        }

	bgetin(inarr,0,framesize);  /* read in and write 1st grain */
	j = 0;
	for (s = 0; s < framesize; s++) {
		while(!j--) {
			val = evp(s,bevfunc,bevfunc,q)*tablei(s,array,tabs);
			j = z;
		}
		outarr[s] = inarr[s]*val;
	}
		
	baddout(outarr,1,framesize);
	printf("wrote first grain\n");

	inrepos(-framesize,0);
printf("inrepos done shift was %ld\n",-framesize);
	outshift = -bevelsize;
	outrepos(outshift,1);
printf("outrepos done shift was %ld\n",outshift);

				/* read in enough for frame, correlation 
				interval, L increment and search interval */
	insize = L +framesize + periodsize + 1;  
	A = framesize-bevelsize;	/* point where overlap begins */
printf("A = %ld, insize = %ld\n",A,insize);

	for (i = 1; i < frames; i++) {
		bgetin(inarr,0,insize); /* read next block */
		printf("read block %ld\n",i);

		maxCorr = 0;
		M = -1;
		for(m = -Ns/2 +1; m < Ns/2; m++) {
			corr = 0;
			for(k = -Ncorr/2+1; k < Ncorr/2; k++) {
				corr += (double)((inarr[A + k] * 
					inarr[L + m + k])*.000001);
			}
			if(corr > maxCorr) {
				maxCorr = corr;
				M = m + L;
			}
		}
		printf("**found M = %ld, maxCorr = %lf\n",M,maxCorr);
		j = 0;
		for (s = 0; s < framesize; s++) {
			while(!j--) {
				val = evp(s,bevfunc,bevfunc,q)*tablei(s+i*framesize,array,tabs);
				j = z;
			}
			outarr[s] = inarr[s+M]*val;
		}
		
		baddout(outarr,1,framesize);
		inshift = M-insize; /* was insize-M */
	printf("inshift = %ld, outshift = %ld\n",inshift,outshift);
		inrepos(inshift,0);
		outrepos(outshift,1);
	}
	endnote(1);
}
