.TH SGRAN CMIX-2
.SH NAME
sgran - granular synthesis
.SH SYNOPSIS
.sp
.B sgran -- cmix command
.br
.sp 2
subcommands:
.sp
.B sgran(p0=start, p1=dur, p2=amp, 
        p3=beg_grainrate, p4=end_grainrate, 
        p5-8=beg_start_var, p9-12=end_start_var, 
        p13-16=beg_grain_size, p17-20=end_grain_size, 
        p21-24=beg_loc, p25-28=end_loc, 
        p29-32=beg_freq_band, p33-36=end_freq_band) 
.sp
.SH DESCRIPTION  
.sp 2
.I sgran
generates events made of many grains of sound.  The parameters
grain rate, duration, location and frequency can be given beginning,
ending and variability values, so the the grains will change over the
course of the event. The values are generated by a probability
function which allows one to "randomly" output values between a 
low and high limits, and which hug a middle value by a specified
amount of tightness. 
The 
.I sgran
arguments are p0 through p36:
        0       start time of group
        1       duration of group
        2       amplitude 
        3       beginning grain rate
        4       ending grain rate
        	amount of variation in rate: 
                (percentage of grain rate, 0-1, 0=100%)
        5-8             beg: lo, average, hi, tightness 
        9-12            end: lo, average, hi, tightness
        	average duration:
        13-16           starting lo, average, hi, tightness
        17-20           ending lo, average, hi, tightness
        	location:
        21-24           starting lo, average, hi, tightness
        25-28           ending lo, average, hi, tightness
        	pitch band:
        29-32           starting lo, average, hi, tightness
        33-36           ending lo, average, hi, tightness
.sp 1
Functions 1 through 6 represent: 
                (all changes are linear)
.sp 1
        1       grain envelope
	        shape of change:
        2               grain density
        3               grain duration
        4               grain location
        5       shape of change: frequency 
        6       waveform
.sp 1
The output values move from the low to the high value according
to the shape of the function for the specific parameter during
the course of the event.
.sp 1
At this point the additive synthesis version of 
.I sgran
is implemented.  Versions synthesizing frequency modulated grains
and sampled grains with in-phase correlation are in progress.
.sp 2
.SH EXAMPLE
.sp 2
        makegen(1,7,1024,0,512,1,512,0)
        makegen(2,7,512,.01,512,1)
        makegen(3,7,512,0,512,1)
        makegen(4,5,512,.01,512,1)
        makegen(5,7,512,.01,512,1)
        makegen(6,10,1024,1)
        setline(0,0, 2,1)
        sgran(0, 2, 100, .01, 1, -1,0,1,1, -.01,0,.01,1, 
	.1,.1,.2,9, .1,.1,.2,2, 1,1,1,2, 1,1,1,2, 
	1000, 1500, 2000, 2, 800, 900, 1000, 2)
.sp 1
will create a 2-second event in which the grain rate moves from
.01 seconds per grain to 1 second per grain with variablity moving
from 100% to 1% possible, with grain durations continuously 
between .1 and .2 sec, with locations remaining in the left
channel, and frequencies moving from a 1000 to 2000 Hz range to
a 800 to 1000 Hz range.
.sp 2
.SH "SEE ALSO"
cmix
.SH BUGS
Event durations are not precisely adhered to. 
