#include "/musr/H/ugens.h"
#include "/musr/macros/macros.h"

ws(p,n_args)
float *p;
{

	float si,*xarray,*sine,*wsf,val,val2,val3,evals[6],tabs[4];
	float phs,out[4],pctlft,a0,a1,b1,c,z1,cpsp,ampi;
	float *risef,*decayf,index,amp,diff,wshape();
	float evl();
	int len1,leni,lenw,z,j,xfer,guide;
	long nsamps,i;

/* Waveshaping Instrument */

/* p2 = pitch,  p3&4 index low&hi,
   p5&6 rise and decay times,  p7 = amp, p8 = pctlft.  
   Assumes f1 is sine,f2 rise, f3 decay, f4 wshaper, f5 index */
/* index=1 max   */


	for (j=0;j<4;j++) out[j]=0.0;
	phs=0;
	pctlft=p[8];
	nsamps = setnote(p[0],p[1],0);
	diff = p[4] - p[3];

	guide = 5;
	xfer = 4;
	xarray = (float *)floc(guide);  /* function 3 is index guide */
	sine = (float *)floc(1);    /* function 1 is sine wave */
	wsf = (float *)floc(xfer);  /* function 4 is xfer fcn */
	risef = (float *)floc(2);  /*function 2 is envlp shape */
	decayf = (float *)floc(3);  /*function 2 is envlp shape */
	len1 = fsize(1);
	leni = fsize(guide);
	lenw = fsize(xfer);
	cpsp=cpspch(p[2]);

	/*initialize dc blocking filter*/
	c=PI*(float)(cpsp/2./SR);  /*cutoff frequency at pitch/2 */
	a0=1./(1.+c);
	a1= -a0;
	b1=a0*(1-c);
	z1=0;

	si = cpsp * (float)(len1/SR);
	z = 1; /*SR/cpsp; interrupt  once per cycle*/
	j = 0;

	evset(p[1],p[5],p[6],2,evals);
	tableset(p[1],leni,tabs);

	for(i = 0; i<nsamps; i++) {
	  	if(!j--) {  
			amp = evl(i,risef,decayf,evals) * p[7];
			index = diff * tablei(i,xarray,tabs) + p[3];
			ampi = amp/index;
			j=z;
	  	}  
		OSCILI(val,1.0,si,sine,len1,phs);  /*sine wave*/
		val2=(wshape(val*index,wsf,lenw)); /*waveshape*/
             /*dc blocking filter*/
		val3= a1*z1;
		z1= b1*z1+val2;
		val3 += a0*z1;

	/*	printf("%f,%f,%f\n",val2,val3,z1);*/
		val3 *= ampi;
		out[0]=pctlft*val3;
		out[1]=val3-out[0];
		ADDOUT(out,0);
	}
	endnote(0);
}

