#include "../H/ugens.h"
#include "../H/sfheader.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
//#include <architecture/byte_order.h>

extern SFHEADER sfdesc[NFILES];
extern int sfd[NFILES];
extern int bufsize[NFILES];
extern char *sndbuf[NFILES];
int (*getsample)(float ,float *,int);
extern 	setnote(float,float,int);
extern 	_backup(int);
extern void closesf(void);

getsetnote(float ,float ,int );
getisample(float ,float *,int );
getfsample(float ,float *,int);

getsetnote(float start,float dur,int filenum)
{
	int nsamples = setnote(start,dur,filenum);
	_backup(filenum);
	if(sfclass(&sfdesc[filenum]) == SF_FLOAT) getsample = getfsample;
	else          	                          getsample = getisample;
	return(nsamples);
}

getisample(float sampleno,float *c,int input)
{

	int RECSIZE = bufsize[input];
	int BPREC = RECSIZE * sizeof(short);
	int BPFRAME = sfchans(&sfdesc[input]) * sizeof(short);
	int FPREC = RECSIZE/sfchans(&sfdesc[input]);

	int sample,i,j;
	signed short *array = (short *)sndbuf[input];
	float fraction;
	static int oldsample = 0;
	static int endsample = 0;

	sample = (int)sampleno;
	fraction = sampleno - (float)sample;
	if(!((sample >= oldsample) && (sample < endsample))) {
		if(sflseek(sfd[input], sample * BPFRAME, 0) <=0) {
			fprintf(stderr,"badlseek on inputfile\n");
			closesf();
		}
		if(read(sfd[input],(char *)array,BPREC) <= 0) {
			fprintf(stderr,"reached eof on input file \n");
			return(0);
		}
		oldsample = sample;
		endsample = oldsample + FPREC - 1;
		}
	for(i=(sample-oldsample)*sfchans(&sfdesc[input]),j=0; 
					j<sfchans(&sfdesc[input]); i++,j++)  {
#ifdef i386
		tempsample = (signed short)NXSwapShort(*(array+i));
		*(c+j) = tempsample + fraction * 
			((float)((signed short)NXSwapShort(*(array+i+sfchans(&sfdesc[input]))))
			- tempsample);
		}
#else
		*(c+j) = (float)*(array+i) + fraction * 
			((float) *(array+i+sfchans(&sfdesc[input])) - 
				 (float) *(array+i));
		}
#endif
	return(1);
}

getfsample(float sampleno,float *c,int input)
{
	int RECSIZE = bufsize[input];
	int BPREC = RECSIZE * sizeof(float);
	int BPFRAME = sfchans(&sfdesc[input]) * sizeof(float);
	int FPREC = RECSIZE/(float)sfchans(&sfdesc[input]);

	int sample,i,j;
	float *array = (float *)sndbuf[input];
	float fraction;
	static int oldsample = 0;
	static int endsample = 0;
	float swapfloat();

	sample = (int)sampleno;
	fraction = sampleno - (float)sample;
	if(!((sample >= oldsample) && (sample < endsample))) {
		if(sflseek(sfd[input], sample * BPFRAME, 0) <=0) {
			fprintf(stderr,"badlseek on inputfile\n");
			closesf();
		}
		if(read(sfd[input],(char *)array,BPREC) <= 0) {
			fprintf(stderr,"reached eof on input file \n");
			return(0);
		}
		oldsample = sample;
		endsample = oldsample + FPREC - 1;
		}
	for(i = (sample-oldsample)*sfchans(&sfdesc[input]),j=0; 
					j<sfchans(&sfdesc[input]); i++,j++)  {
#ifdef i386
		tempfloat = swapfloat(*(array+i));
		*(c+j) = tempfloat + fraction * 
		   (swapfloat(*(array+i+sfchans(&sfdesc[input])))-tempfloat);
		   }
#else
		*(c+j) = *(array+i) + fraction * 
			(*(array+i+sfchans(&sfdesc[input])) - *(array+i));
		}
#endif
	return(1);
}
