#include <math.h>
#include "../H/ugens.h"

//extern abs(float);
#define NSECTS 512

void movcombset(float,float,struct mvcomb  *);
double movcomb(float,struct mvcomb *,float);

void
movcombset(float topcps,float rvt,struct mvcomb  *cm)
{
	int i;
	for(i=0; i<NSECTS; i++) cm->ff[0][i]=cm->ff[1][i]=cm->fb[i]=0.;
	for(i=0; i<MAXMEM; i++) cm->memory[i]=0;
	cm->l1 = SR/topcps;
	cm->k = cm->l = 0;
	cm->rvt = (float)pow(.001,(float)((1./topcps)/rvt));

}

double movcomb(float y,struct mvcomb *cm,float hz)
{
	float D,val,xlen;
	int j;
	
	xlen = SR/hz;				// get length of desired pch
	val = fabs(xlen - (float)cm->l1); 	// figure shift from top pitch
	cm->nsects = abs((int)xlen - cm->l1)+1; //compute difference
	D = (cm->nsects-val)/(cm->nsects+val);	// compute D
	y = y + cm->rvt * cm->memory[cm->l];	// comb
						// loop through allpasses 
	for(j=0; j<cm->nsects; j++) {
		cm->ff[cm->k][j] = y;
		y = cm->ff[(cm->k+1)%2][j] 
			+ D * (y -cm->fb[j]);
		cm->fb[j] = y;
	}
	cm->k++;				// update pointers
	cm->k = cm->k % 2;
	cm->memory[cm->l++] = y;
	cm->l = cm->l % cm->l1;

	return y;
}
