#include <f2c.h>
/* The following routines are needed to get this to compile using f2c */
double
cdabs_(z)
	doublecomplex *z;
{
	double cabs();
	return( cabs( z->r, z->i ) );
}

double
dreal_(x)
	doublecomplex *x;
{
	return x->r;
}

int
cdexp_(r, z)
	doublecomplex *r, *z;
{
	double expx;
	double d_exp(), cos(), sin();

	expx = d_exp(&z->r);
	r->r = expx * cos(z->i);
	r->i = expx * sin(z->i);
}

int
cdsqrt_(r, z)
	doublecomplex *r, *z;
{
	double mag, sqrt(), cabs();

	if( (mag = cabs(z->r, z->i)) == 0.)
		r->r = r->i = 0.;
	else if(z->r > 0) {
		r->r = sqrt(0.5 * (mag + z->r) );
		r->i = z->i / r->r / 2;
	}
	else {
		r->i = sqrt(0.5 * (mag - z->r) );
		if(z->i < 0)
			r->i = - r->i;
		r->r = z->i / r->i /2;
	}
}
