#include "/musr/H/ugens.h"
#define NRESONS 40
#define ENVSIZE 2048
float envcurve[ENVSIZE];

struct rsninfo {
	float rsnetc[9];
	float cf;
	float bw;
	float left;
	float right;
	float amp;

}  rsn[NRESONS],rsnleft[NRESONS],rsn2[NRESONS],rsnleft2[NRESONS];

int nresons;
int nreson;

double drawenv(p,n_args)
float *p;

{
	setline(p,n_args,ENVSIZE,envcurve);
}


double resonate(p,n_args)
float *p;

{        /* p0=outstart, p1=dur, p2=inskip*/

        int i,j,input,output,nsamps;
        float sigl,sigr,xin[4],out[4],ampenv,envtab[2];

	input=0; output=1;
	nsamps=setnote(p[0],p[1],output);
	setnote(p[2],p[1],input);
		
	tableset(p[1],ENVSIZE,envtab);  /* for global amp envelope*/

	for(i=0; i<nsamps; i++) {
		GETIN(xin,input);
		for(j=out[0]=out[1]=0; j<=nresons; j++) {
			ampenv = tablei(i,envcurve,envtab);
			sigl = resonz(xin[0],rsnleft[j].rsnetc);
			sigr = resonz(xin[1],rsn[j].rsnetc);			
			
			out[0] += resonz(sigl,rsnleft2[j].rsnetc) * rsnleft[j].amp * ampenv;
			out[1] += resonz(sigr,rsn2[j].rsnetc) * rsn[j].amp *ampenv;
		}
		ADDOUT(out,output);
	}
	endnote(output);
}


double rsnload(p,n_args)
float *p;
{
	int i;
		/* p0=cf,p1=bw,p2=%left,p3=amp, p4=cf2, etc */
		
	for(i=nresons=0; i<n_args; i += 4,nresons++)
	{
		rsn[nresons].cf = p[i];
		rsn[nresons].bw = p[i+1];
		rsn[nresons].left = p[i+2];
		rsn[nresons].right = 1. - rsn[nresons].left;
		rsn[nresons].amp = p[i+3];
		rsnleft[nresons].cf = p[i];
		rsnleft[nresons].bw = p[i+1];
		rsnleft[nresons].left = p[i+2];
		rsnleft[nresons].right = 1. - rsnleft[nresons].left;
		rsnleft[nresons].amp = p[i+3];
		
		rsn2[nresons].cf = p[i];
		rsn2[nresons].bw = p[i+1];
		rsn2[nresons].left = p[i+2];
		rsn2[nresons].right = 1. - rsn2[nresons].left;
		rsn2[nresons].amp = p[i+3];
		rsnleft2[nresons].cf = p[i];
		rsnleft2[nresons].bw = p[i+1];
		rsnleft2[nresons].left = p[i+2];
		rsnleft2[nresons].right = 1. - rsnleft2[nresons].left;
		rsnleft2[nresons].amp = p[i+3];    	
												rszset(rsnleft[nresons].cf,rsnleft[nresons].bw,0.,rsnleft[nresons].rsnetc);
rszset(rsn[nresons].cf,rsn[nresons].bw,0.,rsn[nresons].rsnetc);

rszset(rsnleft2[nresons].cf,rsnleft2[nresons].bw,0.,rsnleft2[nresons].rsnetc);
rszset(rsn2[nresons].cf,rsn2[nresons].bw,0.,rsn2[nresons].rsnetc);
	}
	printf("You have defined %d resons \n",nresons);
}


double srsnload(p,n_args)
float *p;
{
	int i;
	nreson = p[0]; i=1;
	/* p0=number of the reson,p1=cf,p2=bw,p3=%left,p4=amp, p5=cf2, etc */

	rsn[nreson].cf = p[i];
	rsn[nreson].bw = p[i+1];
	rsn[nreson].left = p[i+2];
	rsn[nreson].right = 1. - rsn[nreson].left;
	rsn[nreson].amp = p[i+3];
	rsnleft[nreson].cf = p[i];
	rsnleft[nreson].bw = p[i+1];
	rsnleft[nreson].left = p[i+2];
	rsnleft[nreson].right = 1. - rsnleft[nreson].left;
	rsnleft[nreson].amp = p[i+3];
		
	rsn2[nreson].cf = p[i];
	rsn2[nreson].bw = p[i+1];
	rsn2[nreson].left = p[i+2];
	rsn2[nreson].right = 1. - rsn2[nreson].left;
	rsn2[nreson].amp = p[i+3];
	rsnleft2[nreson].cf = p[i];
	rsnleft2[nreson].bw = p[i+1];
	rsnleft2[nreson].left = p[i+2];
	rsnleft2[nreson].right = 1. - rsnleft2[nreson].left;
	rsnleft2[nreson].amp = p[i+3];    	
												rszset(rsnleft[nreson].cf,rsnleft[nreson].bw,0.,rsnleft[nreson].rsnetc);
rszset(rsn[nreson].cf,rsn[nreson].bw,0.,rsn[nreson].rsnetc);

rszset(rsnleft2[nreson].cf,rsnleft2[nreson].bw,0.,rsnleft2[nreson].rsnetc);
rszset(rsn2[nreson].cf,rsn2[nreson].bw,0.,rsn2[nreson].rsnetc);

if (nreson>nresons) nresons = nreson;
printf("nresons = %d %d\n",nresons,nreson);
}


double cleanup(p,n_args)
float *p;
{	nresons = 0;
	nreson = 0; }

int NBYTES = 32768;

profile() {
	UG_INTRO("rsnload",rsnload);
	UG_INTRO("srsnload",srsnload);
	UG_INTRO("resonate",resonate);
	UG_INTRO("cleanup",cleanup);
	UG_INTRO("drawenv",drawenv);
}