/*
Date Last Modified - Sat Nov 17 13:29:26 GMT-0400 1990

	rns2
*/
#include "/musr/H/ugens.h"
#include "/musr/H/NeXTsfheader.h"
#include <stdio.h>

#define SIZE 512
float array[SIZE],tabs[2];
extern int lineset;

extern	SFHEADER	sfdesc[NFILES];  /* to access header information */

rsninst(p,n_args)
float *p;
{
/* p0=outstart, p1=dur, p2=inskip, p3=amp, {bw - cf} */ 
/* bw and cf's are in hz */

	int j,k,i,r,input,output,nsamps,nchans, nresons, control;
	float *f1, *rsnetn, xin[4], out[4], temp[4], flsize, xinit=0, bw;
	float dur, evals[9], enval,rise,decay;
	double increment, amp;
	
	nchans = sfchans(&sfdesc[0]);  /* see sfheader.h for macros desc. */
	fprintf(stderr,"nchans %d\n",nchans);
	fprintf(stderr,"n_args %d\n",n_args);
	input=0; output=1;
	dur = p[1];
	nsamps=setnote(p[0],p[1],output);
	getsetnote(p[2],dur,input);

	if(!lineset) {
		for(j = 0; j < SIZE; j++) array[j] = 1;
		fprintf(stderr,"Set phrase curve to all 1's\n");
		lineset = 1;
	}
   	tableset(dur, SIZE, tabs);	// set up table for amp

	// get reson count
	nresons = (n_args - 4)/2;

	// calloc up the required data
	rsnetn = (float *)calloc(nresons,sizeof(flsize*9));
	
	// set up the rsnetn's	
	for (j=i=k=0; j<nresons; j++,i+=2, k+=9){
		rszset(p[5+i],p[4+i],xinit,(rsnetn+k));
		fprintf(stderr,"nresons %d - cf %f bw %f\n",nresons, p[5+i],p[4+i]);
	}

	// xinit = 0 then 1 thereafter if used again within the program.
	xinit = 1;

	control = SR/200;
	r = 0;
	for(i=0; i<nsamps; i++) {
		if(!GETSAMPLE((double)i,xin,input))  break;
			if(!r--){
				amp = tablei(i,array,tabs);
//				fprintf(stderr,"amp %f\n",amp);
				r = control;
			}
		temp[0] = 0; temp[1] =0;
		for (out[0]=out[1]=j=k=0; j<nresons; j++, k+=9){
			if(j>0) {
				temp[0] += resonz(xin[0],rsnetn+k);
				temp[1] += resonz(xin[1],rsnetn+k);
			}
			else {
				temp[0] += resonz(xin[0],rsnetn+k);
				temp[1] += resonz(xin[1],rsnetn+k);
			}
			out[0] = temp[0]*amp;
			out[1] = temp[1]*amp;
		} 

	ADDOUT(out,output);
	}
	endnote(output);
}
