
/*
Date Last Modified - Thu Oct 18 08:56:10 GMT-0400 1990
*/
#include "/musr/H/ugens.h"
#include "/musr/H/sfheader.h"
#include <stdio.h>

#define ArraySize 1024
extern	SFHEADER	sfdesc[NFILES];  /* to access header information */

float cf_array[ArraySize];
float bw_array[ArraySize];

rsn3(p,n_args)
float *p;
{
/* p0=outstart, p1=dur, p2=inskip, p3=rise,p4= decay,p5=bandwidth (p6 to nresons)=cf's */ 
/* bw and cf's are in hz */

	float t1,t2,mincf,maxcf,minbw,maxbw,tab1[2],tab2[2],array[9];
	int j,k,i,r,input,output,nsamps,nchans, nresons, control;
	float *f1, *rsnetn, xin[4], out[4], flsize, xinit=0, bw;
	float dur, evals[9], enval,rise,decay;
	
	nchans = sfchans(&sfdesc[0]);  /* see sfheader.h for macros desc. */
	fprintf(stderr,"nchans %d\n",nchans);
	fprintf(stderr,"n_args %d\n",n_args);
	input=0; output=1;
	nsamps=setnote(p[0],p[1],output);
	dur = p[1];
	rise = p[3];
	decay = p[4];
	setnote(p[2],p[1],input);
	bw = p[5];
	f1 = floc(1);
	evset(dur,rise,decay,1,evals);
	tableset(p[1],ArraySize,tab1);
	tableset(p[1],ArraySize,tab2);
	
	// get reson count
	nresons = n_args - 6;

	// malloc up the required data
	rsnetn = (float *)calloc(nresons,sizeof(flsize*9));
	
	// set up the rsnetn's
	for (i=k=0;i<nresons;i++, k+=9){
		rszset(p[5+i],bw,xinit,(rsnetn+k));
		fprintf(stderr,"\trsnetn[%d] @ %d %f %f\n", i, (rsnetn+k),p[5+i], *(rsnetn+k+1));
	}
	// xinit = 0 then 1 thereafter if used again within the program.
	xinit = 1;
	control = SR/200;
	for(i=0; i<nsamps; i++) {
		if(!GETIN(xin,input)) break;
			if(!r--){
				t1 = table(i,cf_array,tab1);
				t2 = table(i,bw_array,tab2);
				fprintf(stderr,"t1 %f, t2 %f\n",t1,t2);
				enval = evp(i,f1,f1,evals);
				r = control;
			}
			for (j=k=0;j<nresons;j++, k+=9){
				if (j%2) out[0] += (resonz(xin[0],(rsnetn+k)) * enval);
				else out[1] += (resonz(xin[1],(rsnetn+k)) * enval);
			}
		WIPEOUT(out,output);
	}
	endnote(output);
}

double sl1(p,n_args)
float *p;
{
	int i;
	setline(p,n_args,ArraySize,cf_array);
}

double sl2(p,n_args)
float *p;
{
	int i;
	setline(p,n_args,ArraySize,bw_array);
}
