/*
Date Last Modified - Fri Nov 16 13:11:33 GMT-0400 1990
*/
#include "/musr/H/ugens.h"
#include "/musr/H/NeXTsfheader.h"
#include "/musr/macros/macros.h"
#include <stdio.h>

#define SIZE 512
float array[SIZE],tabs[2];
extern int lineset;

extern	SFHEADER	sfdesc[NFILES];  /* to access header information */

rsninst(p,n_args)
float *p;
{
/* p0=outstart, p1=dur, p2=inskip, p3=amp, p4=relamppluck, p5=brightness p6=seed, {p7=bw - p8=cf} */ 
/* bw and cf's are in hz
pluck part - p[0]=start,p1=dur, p2=pitch, p3=inskip [4] = relamppluck,  */

	int j,k,i,r,input,output,nsamps,nchans, nresons, control,len;
	float *q, *f1, *rsnetn, xin[4], out[4], temp[4], flsize, xinit=0, bw;
	float dur, evals[9], enval,rise,decay,loopt, brightness;
	float realpluck,amp2,realpluckdur, seed, relamppluck; 
	double increment, amp;
	
	nchans = sfchans(&sfdesc[0]);  /* see sfheader.h for macros desc. */
	fprintf(stderr,"nchans %d\n",nchans);
	fprintf(stderr,"n_args %d\n",n_args);
	input=0; output=1;
	dur = p[1];
	amp2 = p[3];
	relamppluck = p[4];
	loopt = 1./p[8];
	brightness=p[5];
	seed=p[6];
	
	nsamps=setnote(p[0],p[1],output);
	getsetnote(p[2],dur,input);

	if(!lineset) {
		for(j = 0; j < SIZE; j++) array[j] = 1;
		fprintf(stderr,"Set phrase curve to all 1's\n");
		lineset = 1;
	}
   	tableset(dur, SIZE, tabs);	// set up table for amp

	// get reson count
	nresons = (n_args - 7)/2;

	// calloc up the required data
	rsnetn = (float *)calloc(nresons,sizeof(flsize*9));
	
	// set up the rsnetn's	
	for (j=i=k=0; j<nresons; j++,i+=2, k+=9){
		rszset(p[8+i],p[7+i],xinit,(rsnetn+k));
		fprintf(stderr,"nresons %d - cf %f bw %f\n",nresons, p[8+i],p[7+i]);
	}

	// xinit = 0 then 1 thereafter if used again within the program.
	xinit = 1;

	len = loopt * SR + 25;
	fprintf(stderr,"len %d\n",len);
	if((q= (float *) calloc(len,sizeof(flsize))) == 0) {
		fprintf(stderr, "can't calloc memory for delayline\n");
		exit(-1);
	}

	if ((dur/10) < 0.10) realpluckdur = 0.1;
	else if ((dur/10) > 1) realpluckdur = 1;
	else realpluckdur = dur/10;
	fprintf(stderr,"realpluckdur %f\n",realpluckdur);
	
	f1 = floc(1);
	hplset(loopt,realpluckdur,amp2,relamppluck,seed,SR,1,q);
	
	if ((dur/10) < 0.10) rise = 0.1;
	else if ((dur/10) > 1) rise = 1;
	else rise = dur/10;
	fprintf(stderr,"rise %f\n",rise);
	
	if ((dur/5) < 0.10) decay = 0.1;
	else if ((dur/5) > 1) decay = 1;
	else decay = dur/5;
	fprintf(stderr,"decay %f\n",decay);

	evset(dur,rise,decay,1,evals);

	control = SR/200;
	r = 0;
	for(i=0; i<nsamps; i++) {
		if(!GETSAMPLE((double)i,xin,input))  break;
			if(!r--){
				amp = tablei(i,array,tabs);
				enval = evp(i,f1,f1,evals);
				r = control;
			}
		temp[0] = 0; temp[1] = 0;
		HPLUCK(temp[0],xin[0],q);
		HPLUCK(temp[1],xin[1],q);
		temp[0] *= enval;
		temp[1] *= enval;
		for (out[0]=out[1]=j=k=0; j<nresons; j++, k+=9){
			if(j>0) {
//				temp[0] += ((resonz(temp[0],rsnetn+k)) * (p[3]/3));
//				temp[1] += ((resonz(temp[1],rsnetn+k)) * (p[3]/3));
				temp[0] += resonz(xin[0],rsnetn+k);
				temp[1] += resonz(xin[1],rsnetn+k);
			}
			else {
//				temp[0] += (resonz(temp[0],rsnetn+k) * p[3]);
//				temp[1] += (resonz(temp[1],rsnetn+k) * p[3]);
				temp[0] += resonz(xin[0],rsnetn+k)*amp;
				temp[1] += resonz(xin[1],rsnetn+k)*amp;
			}
		} 
		out[0] = temp[0];
		out[1] = temp[1];
				
	ADDOUT(out,output);
	}
	endnote(output);
}
