/* rsnflt.c   16 Oct 90   Chris Rowland   
a simple Cmix instrument to demonstrate i/o protocols.  Will alternate 
two input files to one outputfile at a requested rate */

#include "/musr/H/ugens.h"
#include "/musr/H/sfheader.h"
#include <stdio.h>

#define ArraySize 1024
#define input1       0		 /* internal Cmix file numbers */
#define output       1		 /* match numbers on input() and  output() commands */

extern	SFHEADER	sfdesc[NFILES];  /* to access header information */

float cf_array[ArraySize];
float bw_array[ArraySize];

double cfsl(p,n_args)   /*center frequency*/
float *p;
{
	int i;
	setline(p,n_args,ArraySize,cf_array);
}

double bwsl(p,n_args)   /*center frequency*/
float *p;
{
	int i;
	setline(p,n_args,ArraySize,bw_array);
}


double rsnflt(p,n_args)
float *p;
{
	int i,j,nsamps,nchans,cl,countdown;
	float t1,t2,cf,bw,mincf,maxcf,minbw,maxbw,tab1[2],tab2[2],xin1[4],out[4],array[9],resonz();

	/* p0=starting time on output file, p1= duration, p2=starting time
	   on inputfile1, p3=center frequency p4=band width (Hz)  */
	
	nsamps=setnote(p[0],p[1],output);  /* position outputfile*/
	setnote(p[2],p[1],input1);	   /* position inputfile1*/

	nchans = sfchans(&sfdesc[input1]);  /* see sfheader.h for macros desc. */
	mincf = p[3];
	maxcf = p[4];
	minbw = p[5];
	maxbw = p[6];
	tableset(p[1],ArraySize,tab1);
	tableset(p[1],ArraySize,tab2);
	cl = SR/2000;
	countdown = 0;
	rszset(mincf,minbw,0.,array);
	
	for(i=0; i<nsamps; i++) {
		if(!GETIN(xin1,input1))  break; 
		if(!countdown--){
			t1 = table(i,cf_array,tab1);
			cf = (maxcf - mincf) * t1 + mincf;
			t2 = table(i,bw_array,tab2);
			bw = (maxbw - minbw) * t2 + minbw;
			rszset(cf,bw,1.,array);
			countdown = cl;
			}
		for(j=0; j<nchans; j++){
			out[j] = resonz(xin1[0],array);
			}
		ADDOUT(out,output);  /* add output to disk*/
	}
	endnote(output);
	return(nsamps);
}

int NBYTES = 32768;
 
profile()
{
	UG_INTRO("rsnflt",rsnflt);
	UG_INTRO("cfsl",cfsl);
	UG_INTRO("bwsl",bwsl);
}
