
 /* have pitch of plucked note follow curve.
    companion to start.c (see).

    bend(start t, dur, pitch0, pitch1, glissfcn, tf0, tNy, slow?)

    pitch0 pitch when function is at zero
    pitch1 pitch when function is a one
    glissfcn function number to follow pitch curve of
    slow? should normally be set to zero

    Normally updates pitch once per cycle
    On upwards glisses of notes that have very little harmonic content,
    this may result in buzzing.
    If this is not desired, a value of slow? = 1 will update pitch one/cycle,
    making it run slowly, but smoothly.     */

#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "../macros/macros.h"
#include "strums.h"

strumq strumq1;

double bend(float *,int , double *);
extern setnote (float, float, int); 
extern void sset(float ,float ,float,strumq *);
extern tableset(float,int,float *);
extern fsize(int);
extern endnote(int);
extern float strum(float,strumq *);

double bend(float *p,int n_args, double *pp)
  {
  float freq,freq0,freq1,out[4];
  float diff,*glissf,tags[4];
  int gliss,leng,j,z;
  long i,nsamps;
  extern strumq strumq1;

  out[0]=out[1]=out[2]=out[3]=0.0;

  nsamps=setnote(pp[0],pp[1],0);

  freq0=cpspch(pp[2]);
  freq1=cpspch(pp[3]);
  diff = freq1 - freq0;

  sset(freq0,pp[5],pp[6],&strumq1);

        gliss = pp[4];

        glissf = (float *)floc(gliss);  /*function pp[4] is gliss shape */
        leng = fsize(gliss);

        j = 1; /*now just initing j, later interrupt  once per cycle*/
        z = 1;/*normally interrupt once/cycle*/
        if(pp[7] == 1.) z = 0;  

        tableset(pp[1],leng,tags);

        for(i = 0; i<nsamps; i++) {
                if(!j--) { 
                        freq = diff*table(i,glissf,tags) + freq0;
                        sset(freq,pp[5],pp[6],&strumq1);
                        j = ((float)SR/freq+.5) * z;
                }  

        out[0]=strum(0.,&strumq1);
        ADDOUT(out,0);
        }
  
  endnote(0);
	return 0.0;
}
