#define maxdl 14000
#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "../macros/macros.h"
#include "strums.h"
  strumq strumq1;
  strumq strumq2;
  strumq strumq3;
  strumq strumq4;
typedef struct {
        int p,del;
        float d[maxdl],c1,c2;
        } delayq;
  delayq dq;

double bend4(float *,int , double *);
extern setnote (float, float, int); 
extern sset(float ,float ,float,strumq *);
extern tableset(float,int,float *);
extern fsize(int);
extern   endnote(int);
extern delayset(float,delayq *);
extern strum(int,strumq *);
extern  dist(float);
extern delay(int,delayq *);

double bend4(float *p,int n_args, double *pp)

/* 4-string guitar with delay and distortion
   Part of a set of 4 programs--see start4.c for more info.
   bend4(star, dur, pitch0,pitch1,p0,p1,p0,p1,p0,p1,glissfcn
   decay time, Ny freq decayt, dist gain,loop gain, loop pitch
   premonitor, postmonitor)    */

  {
  float out[4],tabe,tags[2];
  float freq1a,freq2a,freq3a,freq4a,a,b,d,dgain,fbgain;
  float freq1b,freq2b,freq3b,freq4b,diff1,diff2,diff3,diff4;
  float *glissf,freq;
  int gliss,leng,j;
  long i,nsamps;
  extern strumq strumq1;
  extern strumq strumq2;
  extern strumq strumq3;
  extern strumq strumq4;
  extern delayq dq;

  out[0]=out[1]=out[2]=out[3]=0.0;
  d = 0;

  nsamps=setnote(pp[0],pp[1],0);

  freq1a=cpspch(pp[2]);
  freq2a=cpspch(pp[4]);
  freq3a=cpspch(pp[6]);
  freq4a=cpspch(pp[8]);
   
  freq1b=cpspch(pp[3]);
  freq2b=cpspch(pp[5]);
  freq3b=cpspch(pp[7]);
  freq4b=cpspch(pp[9]);

  diff1 = freq1b - freq1a;
  diff2 = freq2b - freq2a;
  diff3 = freq3b - freq3a;
  diff4 = freq4b - freq4a;

  dgain = pp[13];
  fbgain = pp[14]/dgain;
  sset(freq1a,pp[11],pp[12],&strumq1);
  sset(freq2a,pp[11],pp[12],&strumq2);
  sset(freq3a,pp[11],pp[12],&strumq3);
  sset(freq4a,pp[11],pp[12],&strumq4);
  delayset(cpspch(pp[15]),&dq);

  gliss = pp[10];
  glissf = (float *)floc(gliss);
  leng = fsize (gliss);
  tableset(pp[1],leng,tags);
  leng = fsize (gliss);

  j= (float)SR/freq1a;

  printf("set completed\n");
         i = 0;

  for (i=0;i<nsamps;i++) {

    if(!--j) {
          tabe = table(i,glissf,tags);
          freq = diff1*tabe+freq1a;
          j = (float)SR/freq;
          sset(freq,pp[11],pp[12],&strumq1);

          freq = diff2*tabe+freq2a;
          sset(freq,pp[11],pp[12],&strumq2);
          freq = diff3*tabe+freq3a;
          sset(freq,pp[11],pp[12],&strumq3);
          freq = diff4*tabe+freq4a;
          sset(freq,pp[11],pp[12],&strumq4);
          }

           
      a = strum(d,&strumq1);
      a += strum(d,&strumq2);
      a += strum(d,&strumq3);
      a += strum(d,&strumq4);

      b = dist(dgain*a);
      d = fbgain*delay(b,&dq);
      out[0] = pp[16]*a + pp[17]*b;
      ADDOUT(out,0);
      }
      printf("loopcompleted\n");
  
  endnote(0);
  return 0.0;
}
