/* 6-string guitar with delay and distortion
   like start4.c, see that source for more info.
   start6(star, dur, pitch, pitch, pitch, p,p,p, decay time,
   Ny freq decayt, dist gain,loop gain, loop pitch,
   premonitor, postmonitor, plamp,squish)   */

#define maxdl 14000
#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "../macros/macros.h"
#include "strums.h"

strumq strumq1;
strumq strumq2;
strumq strumq3;
strumq strumq4;
strumq strumq5;
strumq strumq6;

typedef struct {
        int p,del;
        float d[maxdl],c1,c2;
        } delayq;

delayq dq;

float fstart, fdur;

double start6(float *p,int n_args, double *pp);
extern setnote (float, float, int); 
extern void sset(float ,float ,float,strumq *);
extern endnote(int);
extern void randfill(float ,int,strumq *);
extern void delayset(float freq,delayq *q);
extern  void delayclean(delayq *q);
extern float strum(float,strumq *);
extern  float dist(float);
extern float delay(float,delayq *);

double start6(float *p,int n_args, double *pp)
{
  float out[4];
  float freq1,freq2,freq3,freq4,freq5,freq6,a,b,d,dgain,fbgain;
  int squish;
  long i,nsamps;

  out[0]=out[1]=out[2]=out[3]=0.0;
  d = 0;
	fstart=(float)pp[0];
	fdur=(float)pp[1];
printf("before setnote. %f %f\n", fstart, fdur);
  nsamps=setnote(fstart,fdur,0);

  freq1=cpspch(pp[2]);
  freq2=cpspch(pp[3]);
  freq3=cpspch(pp[4]);
  freq4=cpspch(pp[5]);
  freq5=cpspch(pp[6]);
  freq6=cpspch(pp[7]);
   
  dgain = pp[10];
  fbgain = pp[11]/dgain;
  sset(freq1,pp[8],pp[9],&strumq1);
  sset(freq2,pp[8],pp[9],&strumq2);
  sset(freq3,pp[8],pp[9],&strumq3);
  sset(freq4,pp[8],pp[9],&strumq4);
  sset(freq5,pp[8],pp[9],&strumq5);
  sset(freq6,pp[8],pp[9],&strumq6);

  squish = pp[16];
  randfill(pp[15],squish,&strumq1);
  randfill(pp[15],squish,&strumq2);
  randfill(pp[15],squish,&strumq3);
  randfill(pp[15],squish,&strumq4);
  randfill(pp[15],squish,&strumq5);
  randfill(pp[15],squish,&strumq6);
  delayset(cpspch(pp[12]),&dq);
  delayclean(&dq);
  printf("set completed\n");


  for (i=0;i<nsamps;i++) {
      a = strum(d,&strumq1);
      a += strum(d,&strumq2);
      a += strum(d,&strumq3);
      a += strum(d,&strumq4);
      a += strum(d,&strumq5);
      a += strum(d,&strumq6);

      b = dist(dgain*a);
      d = fbgain*delay(b,&dq);
      out[0] = pp[13]*a + pp[14]*b;
      ADDOUT(out,0);
      }
      printf("loopcompleted\n");
  
  endnote(0);
  return 0.0;
}
