#define maxdl 14000
#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "../macros/macros.h"
#include "strums.h"

strumq strumq1;
typedef struct {
        int p,del;
        float d[maxdl],c1,c2;
        } delayq;
  delayq dq;

double vbend1(float *p,int n_args, double *pp);
extern setnote (float, float, int); 
extern sset(float ,float ,float,strumq *);
extern endnote(int);
extern randfill(float ,int,strumq *);
extern delayset(float,delayq *);
extern  delayclean(delayq *);
extern strum(int,strumq *);
extern  dist(float);
extern delay(int,delayq *);
extern fsize(int);
extern tableset(float,int,float *);
extern srrand(float);

double vbend1(float *p,int n_args, double *pp)

/* 1 string bent pluck w/ vibrato
 vbend1(star, dur, pitch0, pitch1, glissfn,decay time,Ny freq decayt,dist gain,
 loop gain, loop pitch, premonitor, postmonitor, vfreqlo, vfreqhi, vdepth, seed)
 assumes makegen 1 is the vibrato function and makegen 2 is vib amp env */

  {
  float out[4],tabe,tags[2];
  float freqa,a,b,d,dgain,fbgain;
  float freqb,diff;
  float *glissf;
  int gliss,leng;
  long i,nsamps;
  extern strumq strumq1;
  extern delayq dq;

  float *vloc,*eloc,vsi,vsibot,vsitop,vsidiff,vphase;
  float freqch,tab[2],vamp;
  int vlen,elen,j,k;

  out[0]=out[1]=out[2]=out[3]=0.0;
  d = 0;

  nsamps=setnote(pp[0],pp[1],0);

  freqa=cpspch(pp[2]);
  freqb=cpspch(pp[3]);
  diff = freqb - freqa;
   
  dgain = pp[7];
  fbgain = pp[8]/dgain;
  sset(freqa,pp[5],pp[6],&strumq1);
  delayset(cpspch(pp[9]),&dq);

  gliss = pp[4];
  glissf = (float *)floc(gliss);
  leng = fsize (gliss);
  tableset(pp[1],leng,tags);

  vlen = fsize(1);
  vloc = (float *)floc(1);
  vsibot = pp[12] * (float)vlen/(float)SR;
  vsitop = pp[13] * (float)vlen/(float)SR;
  vsidiff = vsibot - vsitop;
  srrand(pp[15]);
  vsi = ((rrand()+1.0)/2.0) * vsidiff;
  vsi += vsibot;
  vphase = 0;

  elen = fsize(2);
  eloc = (float *)floc(2);
  tableset(pp[1], elen, tab);

  j = (float)SR/freqa;
  k = (float)vlen/vsi;

  printf("set completed\n");

  for (i=0;i<nsamps;i++) {
	while(!--k) {
		vsi = (( (rrand()+1.0)/2.0) * vsidiff) + vsibot;
		k =(float)vlen/vsi;
		}
	while(!--j) {
		vamp = tablei(i, eloc, tab) * pp[14];
		freqch = oscili(vamp,vsi,vloc,vlen,&vphase);
		tabe = table(i, glissf, tags);
		freqch += diff*tabe;
		sset(freqa+freqch,pp[5],pp[6],&strumq1);
		j = (float)SR/(freqa+freqch);
		vphase += (float)j * vsi;
		}

      a = strum(d,&strumq1);

      b = dist(dgain*a);
      d = fbgain*delay(b,&dq);
      out[0] = pp[10]*a + pp[11]*b;
      ADDOUT(out,0);
      }
      printf("loopcompleted\n");
  
  endnote(0);
return 0.0;
}
