/* 1-string guitar with delay and distortion, plus vibrato
 analogous to start4.c, which has an explaination of how to use it and how 
 it works.
 start1(star, dur, pitch, decay time, Ny freq decayt, dist gain,
 loop gain, loop pitch, premonitor, postmonitor, plamp,squish,
 vfreqlo, vfreqhi, vdepth, seed)
 assumes makegen 1 is the vibrato function and makegen 2 is vib amp env */

#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "../macros/macros.h"
#include "strums.h"

#define maxdl 14000

strumq strumq1;

typedef struct {
        int p,del;
        float d[maxdl],c1,c2;
        } delayq;
delayq dq;

double vstart1(float *p,int n_args, double *pp);
extern setnote (float, float, int); 
extern void sset(float ,float ,float,strumq *);
extern endnote(int);
extern void randfill(float ,int,strumq *);
extern void delayset(float freq,delayq *q);
extern  void delayclean(delayq *q);
extern float strum(float,strumq *);
extern void delayset(float freq,delayq *q);
extern float strum(float,strumq *);
extern  float dist(float);
extern float delay(float,delayq *);
extern fsize(int);
extern srrand(float);
extern tableset(float,int,float *);
double vstart1(float *p,int n_args, double *pp)

  {
  float out[4];
  float freq1,a,b,d,dgain,fbgain;
  long i,nsamps;
  int squish;

  float *vloc,*eloc,vsi,vsibot,vsitop,vsidiff,vphase;
  float freqch,tab[2],vamp;
  int vlen,elen,j,k;

  out[0]=out[1]=out[2]=out[3]=0.0;
  d = 0;

  nsamps=setnote(pp[0],pp[1],0);

  freq1=cpspch(pp[2]);
  squish = pp[11];
   
  dgain = pp[5];
  fbgain = pp[6]/dgain;
  sset(freq1,pp[3],pp[4],&strumq1);
  randfill(pp[10],squish,&strumq1);
  delayset(cpspch(pp[7]),&dq);
  delayclean(&dq);

  vlen = fsize(1);
  vloc = (float *)floc(1);
  vsibot = pp[12] * (float)vlen/(float)SR;
  vsitop = pp[13] * (float)vlen/(float)SR;
  vsidiff = vsibot - vsitop;
  srrand(pp[15]);
  vsi = ((rrand()+1.0)/2.0) * vsidiff;
  vsi += vsibot;
  vphase = 0;

  elen = fsize(2);
  eloc = (float *)floc(2);
  tableset(pp[1], elen, tab);

  j = (float)SR/freq1;
  k = (float)vlen/vsi;

  printf("set completed\n");

  for (i=0;i<nsamps;i++) {
	while(!--k) {
		vsi = (( (rrand()+1.0)/2.0) * vsidiff) + vsibot;
		k =(float)vlen/vsi;
		}
	while(!--j) {
		vamp = tablei(i, eloc, tab) * pp[14];
		freqch = oscili(vamp,vsi,vloc,vlen,&vphase);
		sset(freq1+freqch,pp[3],pp[4],&strumq1);
		j = (float)SR/(freq1+freqch);
		vphase += (float)j * vsi;
		}

      a = strum(d,&strumq1);

      b = dist(dgain*a);
      d = fbgain*delay(b,&dq);
      out[0] = pp[8]*a + pp[9]*b;
      ADDOUT(out,0);
      }
      printf("loopcompleted\n");
  
  endnote(0);
  return 0.0;
}
