#include "../H/ugens.h"
#include "../H/sfheader.h"
#include <stdio.h>
#include <stdlib.h>
//#include <sys/file.h>
//#include <sys/types.h>
#include <math.h>

#define ARRAY_SIZE 256
#define NUM_ARRAYS  32
double minc_array[NUM_ARRAYS][ARRAY_SIZE],minc_array_size[NUM_ARRAYS];

extern 	int lseek(int, int, int);
extern 	int read(int, char *, int);
extern 	int close(int);

extern double boost(double);
extern double cpspch(double);
extern double pchoct(double);
extern double pchcps(double);
extern double octpch(double);
extern double cpsoct(double);
extern double octcps(double);
extern srrand(double);
extern beat_time(double);
extern time_beat(double);
extern double ampdb(double);
extern double rrand();
extern void closesf(void);

double m_boost(float *p,int n_args, double *pp);
double m_cpspch(float *p,int n_args, double *pp);
double m_pchoct(float *p,int n_args, double *pp);
double m_octpch(float *p,int n_args, double *pp);
double m_pchcps(float *p,int n_args, double *pp);
double m_cpsoct(float *p,int n_args, double *pp);
double m_octcps(float *p,int n_args, double *pp);
double m_rand(float *p,int n_args, double *pp);
double m_random(float *p,int n_args, double *pp);
double m_srand(float *p,int n_args, double *pp);
double m_time_beat(float *p,int n_args, double *pp);
double m_beat_time(float *p,int n_args, double *pp);
double m_trunc(float *p,int n_args, double *pp);
double m_ampdb(float *p,int n_args, double *pp);
double m_stringify(float *p,int n_args, double *pp);
double m_pow(float *p,int n_args, double *pp);
double m_round(float *p,int n_args, double *pp);
double m_wrap(float *p,int n_args, double *pp);
double m_print(float *p,int n_args, double *pp);
double m_abs(float *p,int n_args, double *pp);
double m_mod(float *p,int n_args, double *pp);
double m_max(float *p,int n_args, double *pp);
double m_exit(float *p,int n_args, double *pp);
double m_get_array(float *p,int n_args, double *pp);
double m_load_array(float *p,int n_args, double *pp);
double m_put_array(float *p,int n_args, double *pp);
double m_get_sum(float *p,int n_args, double *pp);
double m_get_size(float *p,int n_args, double *pp);
double m_getpch(float *p,int n_args, double *pp);
double m_getamp(float *p,int n_args, double *pp);


double m_boost(float *p,int n_args, double *pp)
{
	p=p;p=p;n_args=n_args;
return(boost(pp[0])); }

double m_cpspch(float *p,int n_args, double *pp)
{ 	 p=p;n_args=n_args;
return(cpspch(pp[0])); }

double m_pchoct(float *p,int n_args, double *pp)
{ 	 p=p;n_args=n_args;
return(pchoct(pp[0])); }

double m_octpch(float *p,int n_args, double *pp)
{  	 p=p;n_args=n_args;
return(octpch(pp[0])); }

double m_pchcps(float *p,int n_args, double *pp)
{  	 p=p;n_args=n_args;
 return(pchcps(pp[0])); }

double m_cpsoct(float *p,int n_args, double *pp)
{  	 p=p;n_args=n_args;
  return(cpsoct(pp[0])); }

double m_octcps(float *p,int n_args, double *pp)
{  	 p=p;n_args=n_args;
 return(octcps(pp[0])); }

double m_rand(float *p,int n_args, double *pp)
{ 	 p=p;p=p;n_args=n_args;pp=pp;
 return(rrand()); }

double m_random(float *p,int n_args, double *pp)
{ 	 p=p;p=p;n_args=n_args;pp=pp;
  return(rrand()*.5+.5);    return 0.0; }

double m_srand(float *p,int n_args, double *pp)
{	 p=p;n_args=n_args;
 srrand(pp[0]);  return 0.0;}

double m_time_beat(float *p,int n_args, double *pp)
{ 	 p=p;n_args=n_args;
return(time_beat(pp[0]));}

double m_beat_time(float *p,int n_args, double *pp)
{ 	 p=p;n_args=n_args;
return(beat_time(pp[0])); }

double m_trunc(float *p,int n_args, double *pp)
{  	 p=p;n_args=n_args;
return((double)(int)(pp[0])); }

double m_ampdb(float *p,int n_args, double *pp)
{  	 p=p;n_args=n_args;
return(ampdb(pp[0])); }

/* double m_dbamp(float *p,int n_args, double *pp)

{  return(dbamp(pp[0])); } */

double m_stringify(float *p,int n_args, double *pp)
{
	/* coerces a string passed in from Minc in quotes in pp[0]
	   to a 'floating point' pointer suitable for use in
	   further cmix calls */
	 p=p;n_args=n_args;
	return(pp[0]);
}

double m_pow(float *p,int n_args, double *pp)
{
	double val;
	 p=p;n_args=n_args;

	val = pow((double)pp[0], (double)pp[1]);
	return(val);
}

double m_round(float *p,int n_args, double *pp)
{
	double val;
	 p=p;n_args=n_args;
	val = pp[0] + .5;
	return val;
}

double m_wrap(float *p,int n_args, double *pp)
{
	double val,range;
	/* keeps value between 0 and pp[1] */
	 p=p;n_args=n_args;
	val = pp[0];
	range = pp[1];
	if(pp[1] >= 1.0) {
		while(val > range) val -= range;
		while(val < 0) val += range;
	}
	else if(pp[1] <= -1.0) {
		while(val < range) val -= range;
		while(val > 0) val += range;
	}
	else val = 0.0;
	return val;
}

double m_print(float *p,int n_args, double *pp)
{
	 p=p;n_args=n_args;
	printf("Value = %10.8f\n", pp[0]);
	return 0.0;
}

double m_abs(float *p,int n_args, double *pp)
{
	 p=p;n_args=n_args;
	return((pp[0] >= 0.0)?pp[0]:-(pp[0]));
}

double m_mod(float *p,int n_args, double *pp)
{
	int i;
	 p=p;n_args=n_args;
	i = (int)pp[0] % (int)pp[1];
	return((double)i);
}

double m_max(float *p,int n_args, double *pp)
{
	int i;
	double max = -1e+22;
	 p=p;n_args=n_args;
	for(i=0; i<n_args; i++)
		if(pp[i] > max) max=pp[i];
	return(max);
}

double m_exit(float *p,int n_args, double *pp)
{
	p=p;p=p;n_args=n_args;pp=pp;
	closesf();
	return 0.0;
}

double m_load_array(float *p,int n_args, double *pp)
{
	int i,j;
	 p=p;n_args=n_args;
	if(n_args > ARRAY_SIZE) n_args = ARRAY_SIZE+1;
	j = pp[0];
	for(i=1; i<n_args; i++) minc_array[j][i-1] = pp[i];
	minc_array_size[j] = n_args;
	   return(n_args-1);
}

double m_get_array(float *p,int n_args, double *pp)
{
	int i;
	 p=p;n_args=n_args;
	i = pp[0];
	if(pp[1] >= minc_array_size[i]) return(0);
	else return(minc_array[i][(int)pp[1]]);
}

double m_put_array(float *p,int n_args, double *pp)

{ /* to load a single value from minc */
	int i,j;
	 p=p;n_args=n_args;
	i=pp[0];
	j=pp[1];
	minc_array[i][j] = pp[2];
	minc_array_size[i]=minc_array_size[i] > j+1 ? minc_array_size[i] : j+1;
	if(j < ARRAY_SIZE)  return(j);
	else return(-1);
}

double m_get_sum(float *p,int n_args, double *pp)

{
	int i,j,k;
	double sum;
	 p=p;n_args=n_args;
	i = pp[0];
	if((j=pp[1]) >= minc_array_size[i])    return(0);
	for(k=0,sum=0; k<=j; k++) sum += minc_array[i][k];
	return(sum);
}

double m_get_size(float *p,int n_args, double *pp)
{
	/*    returns same value as load_array would */
	 	 p=p;n_args=n_args;
 return((double)minc_array_size[(int)pp[0]]-1);
}

double m_getpch(float *p,int n_args, double *pp)
{
	int pchfd;
	int frameno,nbframe,iname;
	long skipbytes;
	double vals[200]; /* enough for 46 poles + 4 data values */
	char  *input;

/*	p0=name of pchanal file; p1=framenumber to get */
	 p=p;n_args=n_args;
	iname = (int)pp[0];
	input = (char *)iname;

	if((pchfd = open(input,0)) < 0) {
		fprintf(stderr," Can't open pitch analysis file\n");
		exit(-1);
		}

	nbframe = 2*FLOAT; 
	frameno = (int)pp[1];

	skipbytes = frameno * nbframe;
	if(lseek(pchfd, skipbytes, 0) < 0) {
		printf("error on pchanal lseek\n");
		exit(-1);
		}

	if(read(pchfd, (char *)vals, nbframe) != nbframe) {
			printf("bad read on pchanal file\n");
			exit(-1);
			}
	
	close(pchfd);

	return vals[0];
}


double m_getamp(float *p,int n_args, double *pp)
{
  int pchfd;
	int frameno,nbframe,iname;
	long skipbytes;
	double vals[200]; /* enough for 46 poles + 4 data values */
	char  *input;

/*	p0=name of pchanal file; p1=framenumber to get */

	p=p;n_args=n_args;
	iname = (int)pp[0];
	input = (char *)iname;

	if((pchfd = open(input,0)) < 0) {
		fprintf(stderr," Can't open pitch analysis file\n");
		exit(-1);
		}

	nbframe = 2*FLOAT; 
	frameno = (int)pp[1];

	skipbytes = frameno * nbframe;
	if(lseek(pchfd, skipbytes, 0) < 0) {
		printf("error on pchanal lseek\n");
		exit(-1);
		}

	if(read(pchfd, (char *)vals, nbframe) != nbframe) {
			printf("bad read on pchanal file\n");
			exit(-1);
			}
	
	close(pchfd);

	 return(vals[1]);
}
