#include "../H/ugens.h"
#include "../H/sfheader.h"
#include <stdio.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>


extern SFHEADER      sfdesc[NFILES];
extern SFMAXAMP      sfm[NFILES];
extern struct stat   sfst[NFILES];
extern int headersize[NFILES];
extern char *getsfcode(SFHEADER *,int);
extern 	sfstats(int);

double m_dur(float *,int, double *);
double m_sr(float *p,int n_args, double *pp);
double m_chans(float *p,int n_args, double *pp);
double m_class(float *p,int n_args, double *pp);
double m_peak(float *p,int n_args, double *pp);
double m_left(float *p,int n_args, double *pp);
double m_right(float *p,int n_args, double *pp);
double m_info(float *p,int n_args, double *pp);


static SFCODE ampcode = {
	SF_MAXAMP,
	sizeof(SFMAXAMP) + sizeof(SFCODE)
};

double m_sr(float *p,int n_args, double *pp)
{
	p=p; n_args=n_args;
	return(sfsrate(&sfdesc[(int)pp[0]]));
}

double m_chans(float *p,int n_args, double *pp)
{
	p=p; n_args=n_args;
	return(sfchans(&sfdesc[(int)pp[0]]));
}

double m_class(float *p,int n_args, double *pp)
{
	p=p; n_args=n_args;
	return(sfclass(&sfdesc[(int)pp[0]]));
}

double m_dur(float *p,int n_args, double *pp)
{
	char *cp;
	int i;
	double dur;
	p=p; n_args=n_args;
	i = pp[0];
	cp = getsfcode(&sfdesc[i],SF_MAXAMP);
	bcopy(cp + sizeof(SFCODE), (char *) &sfm[i], sizeof(SFMAXAMP));
//	memmove((char *) &sfm[i], cp + sizeof(SFCODE), sizeof(SFMAXAMP));
	dur = (double)(sfst[i].st_size - headersize[i])
		 /(double)sfclass(&sfdesc[i])/(double)sfchans(&sfdesc[i])
		 /sfsrate(&sfdesc[i]);
	return(dur);
}

double m_peak(float *p,int n_args, double *pp)
{
	char *cp;
	int i,j;
	double peak;
	p=p; n_args=n_args;
	j = pp[0];
	cp = getsfcode(&sfdesc[j],SF_MAXAMP);
	bcopy(cp + sizeof(SFCODE), (char *) &sfm[j], sizeof(SFMAXAMP));
//	memmove((char *) &sfm[j], cp + sizeof(SFCODE), sizeof(SFMAXAMP));
	if(cp != NULL) {
		for(i=0,peak=0; i<sfchans(&sfdesc[j]); i++)
			if(sfmaxamp(&sfm[j],i) > peak) peak=sfmaxamp(&sfm[j],i);
		return((double) peak);
		}
	return(0.);
}

double m_left(float *p,int n_args, double *pp)
{
	char *cp;
	int j;
	p=p; n_args=n_args;
	j = pp[0];
	cp = getsfcode(&sfdesc[j],SF_MAXAMP);
	bcopy(cp + sizeof(SFCODE), (char *) &sfm[j], sizeof(SFMAXAMP));
//	memmove((char *) &sfm[j], cp + sizeof(SFCODE), sizeof(SFMAXAMP));
	if(cp != NULL) 
		return(double) sfmaxamp(&sfm[j],0);
	return(0.);
}

double m_right(float *p,int n_args, double *pp)
{
	char *cp;
	int j;
	p=p; n_args=n_args;
	j = pp[0];
	if(sfchans(&sfdesc[j]) == 1) return(0);
	cp = getsfcode(&sfdesc[j],SF_MAXAMP);
	bcopy(cp + sizeof(SFCODE), (char *) &sfm[j], sizeof(SFMAXAMP));
//	memmove((char *) &sfm[j], cp + sizeof(SFCODE), sizeof(SFMAXAMP));
	if(cp != NULL) 
		return(sfmaxamp(&sfm[j],1));
	return(0.);
}

extern int sfd[NFILES];

double
m_info(float *p,int n_args, double *pp)
{
	p=p; n_args=n_args;
	sfstats(sfd[(int) pp[0]]);
    return 0;
}
