#include "../H/ugens.h"
#include "../H/sfheader.h"
#include <stdio.h>
#include <unistd.h>

extern SFMAXAMP      sfm[NFILES];
extern SFHEADER	     sfdesc[NFILES];
extern long filepointer[NFILES];
extern int sfd[NFILES];
extern int isopen[NFILES];
extern 	putsfcode(SFHEADER *,void *,SFCODE *);
extern void closesf(void);
extern writeHeader(int ,SFHEADER  *);

double resetamp(float *p,int n_args, double *pp);

static SFCODE ampcode = {
	SF_MAXAMP,
	sizeof(SFMAXAMP) + sizeof(SFCODE)
};

double
resetamp(float *p,int n_args, double *pp)
{
	int i;	
	int fno;
	n_args=n_args;p=p;
	fno = pp[0];
	if(!isopen[fno]) {
		printf("File number %d has not been opened\n",fno);
		return 0;
	}
	for(i = 0; i<sfchans(&sfdesc[fno]); i++) {
		sfmaxamp(&sfm[fno],i) = 0;
		sfmaxamploc(&sfm[fno],i) = 0;
	}
	if((filepointer[fno] = lseek(sfd[fno],0L,0)) < 0) {
		fprintf(stderr,"Bad lseek to beginning of file\n");
		perror("lseek");
		closesf();
	}

	putsfcode(&sfdesc[fno],(char *)&sfm[fno],&ampcode);

	if(wheader(sfd[fno],&sfdesc[fno])) {
		fprintf(stderr,"Bad header write\n");
		perror("write");
		closesf();
	}
	printf("reset header amplitudes to 0 in file %d\n",fno);
	return 0;
}

