/*   sound i/o routines 
*/
/* this version uses pointers to differentiate between different flavours
   of i/o, FLOAT and INT */
/* version that just writes/reads to standard UNIXFILES, with sfheader.*/
/* TODO: keep one file from being opened twice for writing.
	 implement mag tape reads and wipeouts 
	?BUG after using layout, should not call flushbuf
	?in zap and alter routines, (when else..?

	 to add tape read/write need additional arg in open to indicate
	 file number, and this show that it is tape.
	 also need label checking.  first record on each tape file will be
	 header.  
	 only other change for tape is to use read instead of lseek, and 
	 only allow getin and wipeout routines.  also have to add librarian
	 to keep track of what file we are on, and watch out for close, and 
	 thus screw up in eof marks.  (need to know whether we have been 
	 reading or writing.

*/

#define SOUND
#include "../H/ugens.h"
#include "../H/sfheader.h"
#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/times.h>       /* obsolete on VAX replace with new proc */
#include <sys/time.h>       /* obsolete on VAX replace with new proc */
#include <bsd_mem.h>


static int nbytes = 16384;
//static int nbytes = 32767;
extern char * getsfcode(SFHEADER *,int);
extern getheadersize(SFHEADER *);
extern 	_readit(int);   /* read in first buffer */
extern 	_backup(int);
extern  _chkpeak(int);   /* size of buffer to allocate.  this is no longer user-configurable  */
extern float SR;
extern char *getin(int);
int _writeit(int);
//extern writeHeader(int,SFHEADER  *);	/* writes out whatever type of header was read in */
extern putsfcode(SFHEADER *,void *,SFCODE *);
extern putlength(char *,int,SFHEADER *);
void m_zapout(int ,char *,int,int *);

int  sfd[NFILES];            /* soundfile descriptors */
int  pointer[NFILES];	     /* to be used as pointer within sound buffer */
int  bufsize[NFILES];        /* word length of buffer */

char *sndbuf[NFILES];        /* address of buffer */
char *peak[NFILES];          /* array to store peak amplitude for nchannels */
char *peakloc[NFILES];       /* overall peak amplitude */
			   
char wipe_is_off[NFILES];    /* this is for wipeout */
char peakoff[NFILES];        /* this will set peak test on or off*/
double punch[NFILES];	     /* punch alteration flags */
char istape[NFILES];         /* flag to see if it is a tape unit */
double starttime[NFILES];    /* to save starting time of note */
long  originalsize[NFILES];  /* to save byte length of file */
long  filepointer[NFILES];   /* to save current pointer in file */
int status[NFILES];	     /* save read/write flage as well */
int isopen[NFILES];	     /* open status */
int headersize[NFILES];      /* to accomodate bsd and next headers */


SFHEADER      sfdesc[NFILES];
SFMAXAMP      sfm[NFILES];
struct stat   sfst[NFILES];

static SFCODE ampcode = {
	SF_MAXAMP,
	sizeof(SFMAXAMP) + sizeof(SFCODE)
};

struct tms    clockin[NFILES];

int _iaddout(float *,int),_faddout(float *,int),_baddout(float *,int,int);
int _iwipeout(float *,int),_fwipeout(float *,int),_bwipeout(float *,int,int);
int _ilayout(float *,int *,int),_flayout(float *,int *,int),_blayout(float *,int *,int,int);
int _igetin(float *,int), _fgetin(float *,int),_bgetin(float *,int,int);
int _cbaddout(float *out,int fno,int size,int chanwrite);
void _flushbuf(int fno);

char date[26];

int (*addoutpointer[NFILES])(float *,int);
int (*baddoutpointer[NFILES])(float *,int,int);
int (*layoutpointer[NFILES])(float *,int *,int);
int (*blayoutpointer[NFILES])(float *,int *,int,int);
int (*wipeoutpointer[NFILES])(float *,int);
int (*bwipeoutpointer[NFILES])(float *,int,int);
int (*getinpointer[NFILES])(float *,int);
int (*bgetinpointer[NFILES])(float *,int,int);
int (*cbgetinpointer[NFILES])(float *,int,int,int);

void m_open(float *p,int n_args, double *pp);
int setnote(double start,double dur,int fno);
void peak_off(float *p,int n_args, double *pp);
void punch_on(float *p,int n_args, double *pp);
void endnote(int xno);
double m_clean(float *p,int n_args, double *pp); /* a fast clean of file, after header */
void closesf(void);

int _forward(int fno);     /* utility routine to forwardspace one 'record' */
int _backup(int fno);     /* utility routine to backspace one 'record' */

float SR;   /* now declared here rather than in the profile */
char *sfname[NFILES];

void m_open(float *p,int n_args, double *pp) 
{
	char  *name,*cp;
	int   fno,i,newflag;
	float *opk;

	p=p;
	i = (int) pp[0];
	name = (char *) i;
	fno = pp[1];
	sfname[fno] = name;
	status[fno] = (n_args == 3) ? (int)pp[2] : 2;

	if((fno >=  NFILES) || (fno < 0)) {
		fprintf(stderr," Only %d files allowed\n", NFILES);
		closesf();
		}
	newflag = 0;
	if(isopen[fno])  close(sfd[fno]);
	else newflag = 1;
	isopen[fno] = 1;

	istape[fno] = (n_args == 4) ? 1 : 0;
			/* in the case of a tape, there will be a 
			   4th argument listing the file number */

	rwopensf(name,sfd[fno],sfdesc[fno],sfst[fno],"CMIX",i,status[fno]);
	headersize[fno] = getheadersize(&sfdesc[fno]);
	if(i<0) closesf();
	printf("name: %s   sr: %f   nchans: %d  class: %d sfd[fno] %d \n",name,
		sfsrate(&sfdesc[fno]),sfchans(&sfdesc[fno]),
		sfclass(&sfdesc[fno]),sfd[fno]);
#if defined(NeXT) || defined(NEXT)
	if(headersize[fno] == SIZEOF_BSD_HEADER) {
		if(nsfmagic(&sfdesc[fno]) == SND_MAGIC)
			printf("This is a hybrid BSD/NeXT soundfile.\n");
		else printf("This is an IRCAM soundfile.\n");
	}
	else printf("This is a native NeXT soundfile.\n");
#endif /* NeXT || NEXT */
	printf("Duration of file is %f seconds.\n",(double)(sfst[fno].st_size - headersize[fno])/(double)sfclass(&sfdesc[fno])/(double)sfchans(&sfdesc[fno])/sfsrate(&sfdesc[fno]));

	originalsize[fno] = istape[fno] ? 999999999 : sfst[fno].st_size;
	/*
	sfstats(sfd[fno]);
	*/
	if(newflag) {
		if((sndbuf[fno] = (char *)malloc((unsigned)nbytes)) == NULL) {
			fprintf(stderr," CMIX: malloc sound buffer error\n");
			closesf();
			}
		if((peakloc[fno] = (char *)malloc((unsigned)(sfchans(&sfdesc[fno]) * LONG))) == NULL) {
			fprintf(stderr,"CMIX: malloc ovpeak buffer error\n");
			closesf();
		}
		if((peak[fno] = 
			(char *)malloc((unsigned)(sfchans(&sfdesc[fno])* FLOAT))) 
			== NULL) {
			fprintf(stderr,"CMIX: malloc peak buffer error!\n");
			closesf();
		}
		peakoff[fno] = 0; /* default to peakcheckon when opening file*/
		punch[fno] = 0; /* default to no punch when opening file*/
	}
	if(sfclass(&sfdesc[fno]) == SHORT) {
			addoutpointer[fno] = _iaddout;
			layoutpointer[fno] = _ilayout;
			wipeoutpointer[fno] = _iwipeout;
			getinpointer[fno] = _igetin;
			bgetinpointer[fno] = _bgetin;
//			cbgetinpointer[fno] = _cbgetin;
			baddoutpointer[fno] = _baddout;
			blayoutpointer[fno] = _blayout;
			bwipeoutpointer[fno] = _bwipeout;
	}
	else {   
			addoutpointer[fno] = _faddout;
			baddoutpointer[fno] = _baddout;
			layoutpointer[fno] = _flayout;
			blayoutpointer[fno] = _blayout;
			wipeoutpointer[fno] = _fwipeout;
			bwipeoutpointer[fno] = _bwipeout;
			getinpointer[fno] = _fgetin;
			bgetinpointer[fno] = _bgetin;
//			cbgetinpointer[fno] = _cbgetin;
	}

	if(!SR) SR = sfsrate(&sfdesc[fno]);	

	if(sfsrate(&sfdesc[fno])!= SR)
		fprintf(stderr,"Note--> SR reset to %f\n",SR);

	/* read in former peak amplitudes, make sure zero'ed out to start.*/

	cp = getsfcode(&sfdesc[fno],SF_MAXAMP);
	if(cp == NULL) {
		fprintf(stderr, "Unable to read peak amp from header: code = NULL\n");
		closesf();
		}

	bcopy(cp + sizeof(SFCODE), (char *) &sfm[fno], sizeof(SFMAXAMP));
//	memmove((char *) &sfm[fno],cp + sizeof(SFCODE),  sizeof(SFMAXAMP));
	
	for(opk = (float *)peak[fno], i = 0; i<sfchans(&sfdesc[fno]); i++) 
		*(opk+i) = sfmaxamp(&sfm[fno],i);
	bufsize[fno] = nbytes / sfclass(&sfdesc[fno]);/* set size in words */

}

setnote(double start,double dur,int fno)
{
int nsamps,offset;
int i;

//fprintf(stderr,"in setnote fno %d start %f dur %f\n",fno,start,dur);
if(!isopen[fno]) {
	fprintf(stderr,"You haven't opened file %d yet!\n",fno);
	closesf();
	}

	if(start > 0.) /* if start < 0 it indicates number of samples to skip*/
	        offset = (int) (start * SR + .5) * sfchans(&sfdesc[fno])
	    		* sfclass(&sfdesc[fno]);
	else    offset = -start * sfchans(&sfdesc[fno]) * sfclass(&sfdesc[fno]);

/* make sure it falls on channel/block boundary */

	offset -= offset % (sfchans(&sfdesc[fno]) * sfclass(&sfdesc[fno]));
	offset = (offset < 0) ? 0 : offset;
//fprintf(stderr,"offset %d\n",offset);

	nsamps = (dur > 0.) ? (int)((start+dur) * (int)SR -
	(offset/(sfchans(&sfdesc[fno])*sfclass(&sfdesc[fno])))+ .5) : (int)-dur;
//fprintf(stderr,"setnote nsamps %d offset %d headersize[fno] %d\n",nsamps,offset,headersize[fno]);

	if(!istape[fno]) {
		if((filepointer[fno] = 
		   lseek(sfd[fno],offset+headersize[fno],0)) == -1) {
			fprintf(stderr,"CMIX: bad lseek in setnote\n");
			closesf();
		}
	}
	pointer[fno] = 0;

	_readit(fno);   /* read in first buffer */

	for(i=0; i<(sfchans(&sfdesc[fno]) * FLOAT); i++)
		*(peak[fno] + i) = 0;

	wipe_is_off[fno] = 1;          /* for wipeout */

	starttime[fno] = (start<0) ? -start/SR : start;

	times(&clockin[fno]);       /* read in starting time */
	return(nsamps);
}

_iaddout(float *out,int fno)
{
	 int i;
	 int ipoint = pointer[fno];
	 int incr = sfchans(&sfdesc[fno]);
	 short *ibuf;

	for(i=0,ibuf = (short *)sndbuf[fno] + ipoint; i<incr; i++)  
	          *(ibuf + i) +=  (short)*(out+i); 

	if((pointer[fno] += i) >= bufsize[fno] ) {
		_backup(fno);
		if(!peakoff[fno]) _chkpeak(fno);
		_writeit(fno);
		_readit(fno);
		pointer[fno] = 0;
	}
	return 0;
}

_faddout(float *out,int fno)
{
	 int i;
	 int ipoint = pointer[fno];
	 int incr = sfchans(&sfdesc[fno]);
	 float *fbuf;

	for(i=0,fbuf = (float *)sndbuf[fno] + ipoint; i<incr; i++)
		*(fbuf + i) +=  (float)*(out+i);

	if((pointer[fno] += i) >= bufsize[fno] ) {
		_backup(fno);
		if(!peakoff[fno]) _chkpeak(fno);
		_writeit(fno);
//printf("\nbefore readit in faddout. %d pointer[fno] %d\n",i,pointer[fno]);
		_readit(fno);
		pointer[fno] = 0;
	}
	return 0;
}

_igetin(float *in,int fno)
{
	 int i;
	 int ipoint = pointer[fno];
	 int incr = sfchans(&sfdesc[fno]);
	 short *ibuf;

	for(i=0,ibuf = (short *)sndbuf[fno] + ipoint; i<incr; i++)  
		*(in+i) = (float)*(ibuf + i);

	if((pointer[fno] += i) >= bufsize[fno] ) {
		pointer[fno] = 0;
		return(_readit(fno));
	}
	return(nbytes);
}

_fgetin(float *in,int fno)
{
	 int i;
	 int ipoint = pointer[fno];
	 int incr = sfchans(&sfdesc[fno]);
	 float *fbuf;

	for(i=0,fbuf = (float *)sndbuf[fno] + ipoint; i<incr; i++)  
		*(in+i) =  (float)*(fbuf + i);

	if((pointer[fno] += i) >= bufsize[fno] ) {
		pointer[fno] = 0;
		return(_readit(fno));
	}
	return(nbytes);
}

_ilayout(float *out,int *chlist,int fno)
{
	 int i;
	 int ipoint = pointer[fno];
	 int incr = sfchans(&sfdesc[fno]);
	 short *ibuf;

	for(i=0,ibuf = (short *)sndbuf[fno] + ipoint; i<incr; i++)  
           if(chlist[i])  
	   	*(ibuf + i) = (short)*(out+i); 

	if((pointer[fno] += i) >= bufsize[fno] ) {
		_backup(fno);
		if(!peakoff[fno]) _chkpeak(fno);
		_writeit(fno);
		_readit(fno);
		pointer[fno] = 0;
	}
	return(0);
}

_flayout(float *out,int *chlist,int fno)
{
	 int i;
	 int ipoint = pointer[fno];
	 int incr = sfchans(&sfdesc[fno]);
	 float *fbuf;

	for(i=0,fbuf = (float *)sndbuf[fno] + ipoint; i<incr; i++)  
		if(chlist[i]) 	
			*(fbuf + i) =  (float)*(out+i);
	
	if((pointer[fno] += i) >= bufsize[fno] ) {
		_backup(fno);
		if(!peakoff[fno]) _chkpeak(fno);
		_writeit(fno);
		_readit(fno);
		pointer[fno] = 0;
	}
	return(0);
}

_iwipeout(float *out,int fno) /* to force destructive writes */ 
{
		int i;
	 int ipoint = pointer[fno];
	 int incr = sfchans(&sfdesc[fno]);
	 short *ibuf;

	for(i=0,ibuf = (short *)sndbuf[fno] + ipoint; i<incr; i++)  
	   	*(ibuf + i) = (short)*(out+i); 
	
	if((pointer[fno] += i) >= bufsize[fno] ) {
		if(wipe_is_off[fno]) {   /*setnot positions after first read*/
			_backup(fno);
			wipe_is_off[fno] = 0;
			}
		if(!peakoff[fno])
			_chkpeak(fno);
		_writeit(fno);
		pointer[fno] = 0;
	}
	return(0);
}

_fwipeout(float *out,int fno) /* to force destructive writes */ 
{
	 int i;
	 int ipoint = pointer[fno];
	 int incr = sfchans(&sfdesc[fno]);
	 float *fbuf;

	for(i=0,fbuf = (float *)sndbuf[fno] + ipoint; i<incr; i++)  
		*(fbuf + i) =  (float)*(out+i);
	
	if((pointer[fno] += i) >= bufsize[fno] ) {
		if(wipe_is_off[fno]) {   /*setnot positions after first read*/
			_backup(fno);
			wipe_is_off[fno] = 0;
			}
		if(!peakoff[fno])
			_chkpeak(fno);
		_writeit(fno);
		pointer[fno] = 0;
	}
	return(0);
}

_bgetin(float *input,int fno,int size)
{
	int i;
	short *ibuf;
	float *fbuf;
	int todo;
	int n;
	int len = bufsize[fno];

refill:	todo = ((pointer[fno] + size) > len) 
				? len - pointer[fno] : size;

	if(sfclass(&sfdesc[fno]) == SHORT){ 
		for(i=0,ibuf = (short *)sndbuf[fno] + pointer[fno];i<todo;i++) {
//fprintf(stderr,"%f %d, %d\n",*input,*ibuf,i);
			*(input++) = (float)*(ibuf++);
			}
			}
	else {
		for(i=0,fbuf = (float *)sndbuf[fno] + pointer[fno];i<todo;i++) 
			*(input++) =  *(fbuf++);
}

	pointer[fno] += todo;

	if(pointer[fno] == len) {
		n = _readit(fno);
		pointer[fno] = 0;
		if(!n) return(n);
	}
	if(size -= todo) goto refill;
	return(i);
}

/*
_cbgetin(float *input,int fno,int size,int chanread)
{
	 int i;
	 short *ibuf;
	 float *fbuf;
//	 double *temp;
	 int todo;
//	int n;
	int len = bufsize[fno];
	if(chanread>1){
		fprintf(stderr,"CMIX: wrong number of channels for getin, chans?=%d\n", chanread);
		perror("read");
	}
refill:	todo = ((pointer[fno] + size) > len) ? len - pointer[fno] : size;

	if(sfclass(&sfdesc[fno]) == SHORT)
		for(i=chanread,ibuf=(short *)sndbuf[fno]+pointer[fno]+chanread;i<todo;i++) *(input++) = (double) *(ibuf++);
	else // it's a double file
		for(i=chanread,fbuf=(float *)sndbuf[fno]+pointer[fno]+chanread;i<todo;i++) *(input++) = *(fbuf++);
	}
	else { // mono file
		if(sfclass(&sfdesc[fno]) == SHORT) 
			for(i=0,ibuf = (short *)sndbuf[fno] + pointer[fno];i<todo;i++) *(input++) = (double) *(ibuf++);
		else 
			for(i=0,fbuf = (float *)sndbuf[fno] + pointer[fno];i<todo;i++) *(input++) =  *(fbuf++);
	}
	pointer[fno] += todo;
	if(pointer[fno] == len) {
		n = _readit(fno);
		pointer[fno] = 0;
		if(!n) return(n);
	}
	if(size -= todo) goto refill;
	return(i); // still the same number of samples read
}
*/

_blayout(float *out,int *chlist,int fno,int size)
{	 int i,j;
	 short *ibuf;
	 float *fbuf;
	 int todo;
	 int nchans;
	int len = bufsize[fno]; 

	nchans = sfchans(&sfdesc[fno]);

refill:	todo = ((pointer[fno] + size) > len) 
				? len - pointer[fno] : size;
	if(sfclass(&sfdesc[fno]) == SF_SHORT) {
		for(i=0,ibuf = (short *)sndbuf[fno] + pointer[fno];i<todo;
								i += nchans)
			for(j=0; j<nchans; j++,ibuf++,out++)
				if(chlist[j]) *ibuf = (short) *out;	
	}
	
	else {
		for(i=0,fbuf = (float *)sndbuf[fno] + pointer[fno];i<todo;
								i += nchans)
			for(j=0; j<nchans; j++,fbuf++,out++)
				if(chlist[j]) *fbuf = (float)*out;
	}
	pointer[fno] += todo;

	if(pointer[fno] == len) {
		_backup(fno);
		if(!peakoff[fno])
			_chkpeak(fno);
		_writeit(fno);
		_readit(fno);
		pointer[fno] = 0;
	}

	if(size -= todo) goto refill;
	return(0);
}

_baddout(float *out,int fno,int size)
{
	 int i;
	 short *ibuf;
	 float *fbuf;
	 int todo;
	int len = bufsize[fno]; 

refill:	todo = ((pointer[fno] + size) > len) 
				? len - pointer[fno] : size;
	if(sfclass(&sfdesc[fno]) == SHORT)
		for(i=0,ibuf = (short *)sndbuf[fno] + pointer[fno];i<todo;i++){
				*(ibuf++) += (short) *(out);
				*(out++)=0.0; // zero that location after output
			}
	else 
		for(i=0,fbuf = (float *)sndbuf[fno] + pointer[fno];i<todo;i++){
				*(fbuf++) += (float)*(out);
				*(out++)=0.0; // zero that location after output
			}

	pointer[fno] += todo;

	if(pointer[fno] == len) {
		_backup(fno);
		if(!peakoff[fno])
			_chkpeak(fno);
		_writeit(fno);
		_readit(fno);
		pointer[fno] = 0;
	}
	
	if(size -= todo) goto refill;
	return(0);
}

_cbaddout(float *out,int fno,int size,int chanwrite)
{
	 int i;
	 short *ibuf;
	 float *fbuf;
	 int todo;
	int len = bufsize[fno]; 
	int chans;

	chans = sfchans(&sfdesc[fno]);
	if(chanwrite>chans){
		fprintf(stderr,"CMIX: wrong number of channels for output, chans %d chanwrite\n", chans,chanwrite);
		perror("write");
	}
refill:	todo = ((pointer[fno] + size) > len) ? len - pointer[fno] : size;
	if(sfclass(&sfdesc[fno]) == SHORT)
		for(i=0,ibuf = (short *)sndbuf[fno] + pointer[fno];i<todo;i++)
			if(chans==1){
				*(ibuf++) += (short) *(out);
				*(out++)=0.0; // zero that location after output
			}
			else{
				*(ibuf+2) += (short) *(out); // for stereo output?
				*(out+2)=0.0; // zero that location after output
			}
	else 
		for(i=0,fbuf = (float *)sndbuf[fno] + pointer[fno];i<todo;i++)
			if(chans==1){
				*(fbuf++) += (float)*(out);
				*(out++)=0.0; // zero that location after output
			}
			else{
				*(fbuf+2) += (float) *(out); // for stereo output?
				*(out+2)=0.0; // zero that location after output
			}

	pointer[fno] += todo;

	if(pointer[fno] == len) {
		_backup(fno);
		if(!peakoff[fno])
			_chkpeak(fno);
		_writeit(fno);
		_readit(fno);
		pointer[fno] = 0;
	}
	
	if(size -= todo) goto refill;
	return(0);
}

_bwipeout(float *out,int fno,int size)
{
	 int i;
	 short *ibuf;
	 float *fbuf;
	 int todo;
	int len = bufsize[fno]; 
	
refill:	todo = ((pointer[fno] + size) > len) 
				? len - pointer[fno] : size;

	if(sfclass(&sfdesc[fno]) == SHORT) 
		for(i=0,ibuf = (short *)sndbuf[fno] + pointer[fno];i<todo;i++) 
			*(ibuf++) = (short)*(out++);
	else 
		for(i=0,fbuf = (float *)sndbuf[fno] + pointer[fno];i<todo;i++) 
			*(fbuf++) = (float)*(out++);

	pointer[fno] += todo;

	if(pointer[fno] == len) {
		if(wipe_is_off[fno]) {   
			_backup(fno);
			wipe_is_off[fno] = 0;
			}
		if(!peakoff[fno])
			_chkpeak(fno);
		_writeit(fno);
		pointer[fno] = 0;
	}
	if(size -= todo) goto refill;
	return(0);
}

void endnote(int xno)
{
	struct timeval tp;	
	struct timezone tzp;	
	int i,j,final_bytes=0,fno;
	float notepeak,*pk;
	float total;
	long *pkloc;
	struct tms timbuf;

	fno = ABS(xno);  /* if fno is negative it means don't write
				final buffer,just pretend to */
	if(wipe_is_off[fno]) _backup(fno); 
		/* else _flushbuf(fno); */
	if(!peakoff[fno]) _chkpeak(fno);

	/* write out only fractional part of last record, god bless unix!*/
	i=0;
	if(pointer[fno]) {
		final_bytes =  pointer[fno]  * sfclass(&sfdesc[fno]);
		if(xno >= 0) {
			if((i = write(sfd[fno],sndbuf[fno],final_bytes)) 
							!= final_bytes) {
				fprintf(stderr,"CMIX: Bad UNIX write, file %d, nbytes = %ld\n",
									fno,i);
			perror("write");
			closesf();
			}
		}
		else i = final_bytes;
	}

	if((filepointer[fno] += final_bytes) > originalsize[fno]) 
		if(xno >0)  originalsize[fno] = filepointer[fno];

	pk = (float *)peak[fno];
	pkloc = (long *)peakloc[fno];
	total = ((float)filepointer[fno]-headersize[fno])
		/((float)sfclass(&sfdesc[fno]))
		/(float)sfchans(&sfdesc[fno])/SR;

	/* _writeit(fno);  /*  write out final record */

	for(i = 0,notepeak=0; i<sfchans(&sfdesc[fno]); i++) { 
		if(*(pk+i) > sfmaxamp(&sfm[fno],i)) {
			sfmaxamp(&sfm[fno],i) = *(pk+i);
			sfmaxamploc(&sfm[fno],i) = *(pkloc+i);
		}
		if(*(pk+i) > notepeak) notepeak = *(pk+i);
	}

	gettimeofday(&tp,&tzp);
	sfmaxamptime(&sfm[fno]) = tp.tv_sec;
//	strcpy(date,ctime((const ulong *)&sfmaxamptime(&sfm[fno])));
//	fprintf(stderr,"endnote:date=%s\n",date);

	if((filepointer[fno] = lseek(sfd[fno],0L,0)) < 0) {
		fprintf(stderr,"Bad lseek to beginning of file\n");
		perror("lseek");
		closesf();
	}

	putsfcode(&sfdesc[fno],(char *)&sfm[fno],&ampcode);

	if(wheader(sfd[fno],&sfdesc[fno])) {
		fprintf(stderr,"Bad header write\n");
		perror("write");
		closesf();
	}

	times(&timbuf);

        fprintf(stderr,"(%6.2f)",(float)(
		(timbuf.tms_stime-clockin[fno].tms_stime)+
		(timbuf.tms_utime-clockin[fno].tms_utime))/60.);
	fprintf(stderr," %9.4f .. %9.4f MM ",starttime[fno],total);
	
	if(!peakoff[fno]) {
		for(j=0;j<sfchans(&sfdesc[fno]);j++)
			fprintf(stderr," c%d=%e",j,*(pk+j));
		fprintf(stderr,"\n");
		if(punch[fno]) {
			fprintf(stderr,"alter(%e,%e,%e/%e",
			(float)starttime[fno],(float)(total-starttime[fno]),
							  punch[fno],notepeak);
			for(i=0; i<sfchans(&sfdesc[fno]); i++)
				fprintf(stderr,",1 ");
			fprintf(stderr,")\n");
		}
	}
}

void _flushbuf(int fno)
{
	int i;
	for(i=pointer[fno]*sfclass(&sfdesc[fno]); i<nbytes; i++)
		*(sndbuf[fno] + i) = 0;
}

_chkpeak(int fno)
{
	int i,incr;
	short *ibuf,*bufend;
	float *fbuf,*fbufend,*pk;
	short *ibufx;
	float *fbufx;
	long *pkloc,currentloc;

	pk = (float *)peak[fno];
	incr = sfchans(&sfdesc[fno]);
	pkloc = (long *)peakloc[fno];

	if(sfclass(&sfdesc[fno]) == SHORT) {
		ibufx = ibuf = (short *)sndbuf[fno];
		bufend = ibuf + pointer[fno]; /* to allow for final check */
		currentloc = (long)
			     ((filepointer[fno]-headersize[fno])/(SHORT * incr));
		while(ibuf<bufend)  {
			for(i=0; i<incr; i++)  {
				if(ABS(*(ibuf + i)) > (int)*(pk+i)) {
					*(pk+i) = ABS(*(ibuf + i)); 
					*(pkloc+i) = currentloc + 
					  (long)((ibuf - ibufx)/incr);
				}
			}
			ibuf += incr;
		}
	}
	else	{
		fbufx = fbuf = (float *)sndbuf[fno];
		fbufend = fbuf + pointer[fno];
		currentloc = (long)
			     ((filepointer[fno]-headersize[fno])/(FLOAT * incr));
		while(fbuf<fbufend) {
			for(i=0; i<incr; i++)  {
				if(ABS(*(fbuf + i)) > *(pk+i)) {
					*(pk+i) = ABS(*(fbuf + i));
					*(pkloc+i) = currentloc +
					(long)((fbuf - fbufx)/incr);
				}
			}
		fbuf += incr;	
		} 
	} 
	return(0);
} 


void peak_off(float *p,int n_args, double *pp)
{
	p=p;n_args=n_args;
	peakoff[(int)pp[0]] = (char)pp[1];
	if(pp[1]) fprintf(stderr,
		     "      peak check turned off for file %d\n",(int)pp[0]);
		else
		 fprintf(stderr,
		     "      peak check turned on for file %d\n",(int)pp[0]);
}

void punch_on(float *p,int n_args, double *pp)
{
	p=p;n_args=n_args;
	punch[(int)pp[0]] = pp[1];
	if(!pp[1]) fprintf(stderr,
		     "      punch turned off for file %d\n",(int)pp[0]);
		else
		 fprintf(stderr,
		     "      punch check turned on for file %d\n",(int)pp[0]);
}

_readit(int fno)
{
	int n,maxread;

/* check to see if we are attempting to read beyond current
 * EOF, and if so adjust amount to be read and flush rest of buffer
 */

//printf(" readit filepointer[fno] %d originalsize[fno] %d",filepointer[fno], originalsize[fno]);

	if(filepointer[fno] > originalsize[fno]) maxread = 0;
	else 
		if((filepointer[fno]+nbytes) > originalsize[fno]) 
	    maxread = originalsize[fno]-filepointer[fno];
		else
		  maxread = nbytes;

//printf(" readit maxread %d fno %d\n",maxread, fno);

	if((n = read(sfd[fno],sndbuf[fno],maxread)) != maxread) {
		/*if(istape[fno] && n) continue;*/
		perror("from readit");
		fprintf(stderr,
                	"CMIX: Bad UNIX read, nbytes = %ld\n",n);
			printf(" sfd[fno]= %d\n",sfd[fno]);
	        closesf();
		}

	/*  if we haven't read in full buffer, zero out rest of buffer,
	 *  and adjust filepointer with lseek.  Otherwise just update 
	 *  filepointer.  This will position pointer properly for any
	 *  situation.  Only a write will change physical size of file.
	 */

	if(maxread < nbytes) {
		for(n=maxread; n<nbytes; n++)
			*(sndbuf[fno] + n) = 0;
		filepointer[fno] = lseek(sfd[fno],(long)(nbytes-maxread),1);
		}               
	else
		filepointer[fno] += nbytes;
	return(maxread ? n : maxread);
}

_writeit(int fno)
{
	int n;
	if(!status[fno]) {
		fprintf(stderr,"File %d is write-protected!\n",fno);
		closesf();
	}
	if((n = write(sfd[fno],sndbuf[fno],nbytes)) != nbytes) {
		fprintf(stderr, "CMIX: Bad UNIX write, file %d, nbytes = %ld\n",fno,n);
		perror("write");
		closesf();
	}
	if((filepointer[fno] += nbytes) > originalsize[fno]) 
				originalsize[fno] = filepointer[fno];
	
	return(n);
}

_backup(int fno)     /* utility routine to backspace one 'record' */
{
	if((filepointer[fno] = lseek(sfd[fno],(long)-nbytes,1)) < 0) {
		fprintf(stderr,"CMIX: bad back space in file %d\n",fno);
		perror("lseek");
		closesf();
	}
	return(0);
}

_forward(int fno)     /* utility routine to forwardspace one 'record' */
{
	if((filepointer[fno] = lseek(sfd[fno],(long)nbytes,1)) < 0) {
		fprintf(stderr,"CMIX: bad forward space  in file %d\n",fno);
		perror("lseek");
		closesf();
	}
	return(0);
}

void
closesf(void)
{
	int i;

	for(i = 0; i<NFILES; i++) {
		if(isopen[i]) {
			if(status[i]) 
				putlength(sfname[i],sfd[i],&sfdesc[i]);  /* if NeXT header */
			close(sfd[i]);
		}
	}
	exit(0);
}

double
m_clean(float *p,int n_args, double *pp) /* a fast clean of file, after header */
{
/* if p1-> = 0, clean whole file, else skip=p1, dur=p2, ch-on? p3--> */
	int i,todo,nwrite,n;
	char *point;
	int fno,segment,chlist[4];
	int skipbytes;

	p=p; n_args=n_args;
	fno = (int) pp[0];
	skipbytes = 0;
	if(!status[fno]) {
		fprintf(stderr,"fno %d is write-protected!\n", fno);
		closesf();
	}
	todo = originalsize[fno] - sizeof(SFHEADER);

	segment = (n_args > 1) ? 1 : 0;

	if(segment) {
		skipbytes = (pp[1] > 0) ? pp[1] * sfclass(&sfdesc[fno]) *
			    SR * sfchans(&sfdesc[fno]) 
			    : -pp[1] * sfclass(&sfdesc[fno]) * 
							 sfchans(&sfdesc[fno]);
		todo =  (pp[2] > 0) ? pp[2] * sfclass(&sfdesc[fno]) * 
			SR * sfchans(&sfdesc[fno])
			: -pp[2] * sfclass(&sfdesc[fno]) * 
						sfchans(&sfdesc[fno]);
		for(i=0; i<sfchans(&sfdesc[fno]); i++) chlist[i] = pp[i+3];
	}
	point = (char *)sndbuf[fno];
	if(!segment) for(i=0; i<nbytes; i++) *(point+i) = 0;

	if((filepointer[fno] = 
	   lseek(sfd[fno],skipbytes+headersize[fno],0)) == -1) {
		fprintf(stderr,"CMIX: bad sflseek in clean\n");
		closesf();
	}
	fprintf(stderr,"Clean %d bytes\n",todo);
	while(todo) {
		nwrite = (todo > nbytes) ? nbytes : todo;
		if(segment) {
			if((n = read(sfd[fno],sndbuf[fno],nwrite)) 
					== 0) { /* allow for fractional reads*/
				fprintf(stderr,
                 		"CMIX: Apparent eof in clean\n",n);
				return 0;
			}
			if(lseek(sfd[fno],-n,1) < 0) {
				fprintf(stderr,"Bad UNIX lseek in clean\n");
				closesf();
			}
			m_zapout(fno,sndbuf[fno],n,chlist);
			nwrite = n;
		}
		if((n = write(sfd[fno],sndbuf[fno],nwrite)) == 0) {
			fprintf(stderr,
                 	"CMIX: Apparent eof in clean\n",n);
	        	closesf();
		}
		todo -= n;
	}
	if(!segment) {
		if((lseek(sfd[fno],0,0)) == -1) {
			fprintf(stderr,"CMIX: bad lseek in clean\n");
			closesf();
		}

		for(i = 0; i<sfchans(&sfdesc[fno]); i++) { 
			sfmaxamp(&sfm[fno],i) = 0;
			sfmaxamploc(&sfm[fno],i) = 0;
		}

		putsfcode(&sfdesc[fno],(char *)&sfm[fno],&ampcode);

		if(wheader(sfd[fno],&sfdesc[fno])) {
			fprintf(stderr,"Bad header write\n");
			perror("write");
			closesf();
		}
	}
	else 
		if((lseek(sfd[fno],headersize[fno],0)) == -1) {
			fprintf(stderr,"CMIX: bad lseek in clean\n");
			closesf();
		}
	filepointer[fno] = headersize[fno];
	fprintf(stderr,"Clean successfully finished.\n");
	return(0);
}

void m_zapout(int fno,char *buffer,int nwrite,int *chlist)
{
	float *fbuf;
	int i,j,nchunks,chans;
	short *ibuf;

	chans = sfchans(&sfdesc[fno]);

	if(sfclass(&sfdesc[fno]) == SF_SHORT) {
		ibuf = (short *) buffer;
		nchunks = nwrite/SF_SHORT;
		for(i=0; i<nchunks; i += chans)
			for(j=0; j<chans; j++)
				if(chlist[j]) *(ibuf+j+i) = 0;
	}
	else {
		fbuf = (float *) buffer;
		nchunks = nwrite/SF_FLOAT;
		for(i=0; i<nchunks; i += chans) 
			for(j=0; j<chans; j++)
				if(chlist[j]) *(fbuf+j+i) = 0;
	}
}
