#include <math.h>
#define TLEN 20  /* maximum number of ttime/tempo pairs */
#define TLENP 21
#define TWO  2.

double time_beat(double);
void tbase(float *,int, double *);
double beat_time(double);    /* returns beats from times */
void t(float *,int, double *);
tempo(float *,int,double *);

double ttime[TLENP],temp[TLENP],rtime[TLENP],accel[TLENP],BASIS = 60.;
short tset = 0,npts;

void tbase(float *p,int n_args, double *pp)
{
	p=p;
	n_args=n_args;
	BASIS = pp[0];
}

tempo(float *p,int n_args, double *pp)
{
	short m;
	double dur,prvbt;
	p=p;
	if(!n_args) {
		printf("n_args = %d\n",n_args);
		printf("Tempo changes cleared out\n");
		tset = 0;
		return 0;
	}

	tset = 1;
	for(m=0;m<TLEN;m++){ ttime[m]=0;temp[m]=0;rtime[m]=0;accel[m]=0;}
	for(m=0,npts=1; m<TLEN; m += 2, npts++) {
		if((m) && (m >= n_args)) break;
		ttime[npts] = pp[m];
		temp[npts] = pp[m+1]/BASIS;
		}
	rtime[npts] = ttime[npts] = .999999e+10;
	temp[npts] = temp[npts-1];
	temp[0] = temp[1];
	ttime[0] = rtime[0] = accel[0] = prvbt = 0.;
	for(m=0; m<npts; m++) {
		dur = ttime[m+1] - ttime[m];
		if(!dur) {
			accel[m] = 0;
			rtime[m+1] = rtime[m];
			}
		else 	{
			accel[m] = (double)(pow((double)temp[m+1],TWO) - 
					pow((double)temp[m],TWO))/
					(2.*dur);
			if(!accel[m]) rtime[m+1] = dur/temp[m]+prvbt;
				else rtime[m+1] = (double)
					(sqrt(pow((double)temp[m],TWO)+
					(double)(TWO* accel[m]*dur))-temp[m])/
					accel[m] + prvbt;
		}
		prvbt = rtime[m+1];
	}
	return 0;
/*
for(m=0; m<=npts; m++) printf("%d %f %f %f %f\n",m,temp[m],accel[m],rtime[m],ttime[m]);
*/
}

double time_beat(double timein)
{
	int m = 0;
	double durp = 0;

	if(!tset) return(timein);

	if(timein) for(m=0; m<=npts; m++) {
		if(timein > ttime[m] && timein <= ttime[m+1]) {
			durp = timein-ttime[m];
			break;
		}
	}
	if(!accel[m]) return(durp/temp[m] + rtime[m]);
	return(((double)sqrt(pow((double)temp[m],TWO)+ 
		(double)(TWO * accel[m] * durp)) - temp[m])/
		accel[m] + rtime[m]);
}

double beat_time(double beatin)    /* returns beats from times */
{
	int m=0;
	if(!tset) return(beatin);

	if(beatin) for(m=0; m<=npts; m++) 
		if(beatin > rtime[m] && beatin <= rtime[m+1]) break;
	if(!accel[m]) return((beatin-rtime[m])*temp[m] + ttime[m]);
	return(((double)pow((double)((beatin-rtime[m]) * accel[m]+temp[m]),TWO)-(double)pow((double)temp[m],TWO))/(TWO * accel[m]) + ttime[m]);
}

void t(float *p,int n_args, double *pp)
{
	double x,y;
	p=p;n_args=n_args;
	x = time_beat(pp[0]);
	y = beat_time(pp[0]);
	printf("%f %f %f\n",pp[0],x,y);
}
