#include "../H/sfheader.h"
#include "../H/ugens.h"
//#include <sys/file.h>
//#include <sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <bsd_mem.h>
#include <math.h>
#include <sys/stat.h>

#define IWRAP(x,y) (((x)>=(y))?(x)-(y):(((x)<0)?(x)+(y):(x)))
#define SIZE 1024

extern float SR;
extern endnote(int);
extern float octpch(float);
extern setnote(double, double, int);
extern void tableset(float,int,float *);
extern float cpsoct(float);
extern float tablei(long,float *,float *);

extern struct stat sfst[NFILES];

extern double setline(float *p,int n_args, double *pp);
double trans (float *p,int n_args,double *pp);
double interp(double, double, double, double);
double reset(float *,int , double *);
void profile(void);

extern SFHEADER	sfdesc[NFILES];
extern int headersize[NFILES];
float array[SIZE],tabs[2];	/* for lineset */
extern int lineset;
//int NBYTES = 32768;
int lineset = 0;
int RESET = 200;

double
trans (float *p,int n_args,double *pp)
{
double increment, counter = 0.0, frac, amp;
double voldsig[4], oldsig[4], newsig[4], dur, interval;
float input[4], sig[4];
int getflag = 1, incount = 1, i, j, z;
int insamps, outsamps, outcount = 0;
int nchans=0;

nchans = sfchans(&sfdesc[0]);

/*  p0 = inskp  p1 = outskp  p2 = dur (tmnd)  p3 = intrvl of trnsp. p4 = amp */

/*    SR = sfsrate(&sfdesc[0]); */
		p=p;
	if(n_args != 5){
		fprintf(stderr, "Wrong number of args for trans!\n");
		exit(0);
	}
    interval = octpch((float)pp[3]);  /* convert interval to lin octave */
    increment = cpsoct(10.0+interval)/cpsoct(10.0);  /* the samp incr. */
		printf("increment %f\n",increment);
    if (pp[2] == 0.0)
	pp[2] = ((float)(sfst[0].st_size - headersize[0])
		 /(float)sfclass(&sfdesc[0])/(float)sfchans(&sfdesc[0])
		 /sfsrate(&sfdesc[0])) - (float)pp[0];

    dur = (pp[2]<0.0)? -1.0*pp[2] : pp[2] - pp[0];       /* p2 is dur if neg. */
    insamps = setnote(pp[0], dur, 0);                 /* set input file */
    outsamps = setnote(pp[1], (dur/increment), 1);    /* set output file */
    if(!lineset) 
    {
        for(j = 0; j < SIZE; j++) array[j] = 1;
    	fprintf(stderr,"Set phrase curve to all 1's\n");
   	lineset = 1;
    }
    z = SR/(float) RESET;	      /* the control rate for amp curve */
    j = 0;
    tableset(dur/increment, SIZE, tabs);	   /* set up table for amp */
    GETIN(input,0);
    for(i=0; i < nchans; i++) oldsig[i] = input[i];
    GETIN(input,0);
    for(i=0; i < nchans; i++) newsig[i] = input[i];

    /* the processing loop for the input signal */

    while (outcount++ < outsamps)
    {
        while (getflag)
	{
        	GETIN(input,0);	                       /* get input samp */ 
		for(i=0; i < nchans; i++)
	        {
		   voldsig[i] = oldsig[i];
		   oldsig[i] = newsig[i];
	  	   newsig[i] = input[i];
		}
		incount++;  
		if ((counter - (float)incount) < 0.5) getflag = 0;
	}
	frac = counter - incount + 2.0;   /* The interp value */
	while (!j--)
	{
		amp = tablei(outcount,array,tabs) * (float)pp[4];
		j = z;
	}
	for(i=0; i < nchans; i++)
		sig[i] = interp(voldsig[i], oldsig[i], newsig[i], frac)*amp;
	ADDOUT(sig, 1);
	counter += increment;               /* keeps track of interp pointer */
	if ((counter - (float)incount) >= -0.5) getflag = 1; /* Ready for samp */
    }
    endnote(1);
	return (0.0);
}

double interp(double y0,double y1,double y2,double t)
{
    double hy2, hy0, a, b, c;
    
    a = y0;
    hy0 = y0/2.0;
    hy2 =  y2/2.0;
    b = (-3.0 * hy0) + (2.0 * y1) - hy2;
    c = hy0 - y1 + hy2;

    return(a + b*t + c*t*t);
}

double reset(float *p,int n_args, double *pp)
{
	p=p;n_args=n_args;
	if(pp[0]) RESET = pp[0];
	fprintf(stderr,"Envelope calls set to %d times per sec\n",RESET);
    return (0.0);
}

//double
//setline(float *p,int n_args, double *pp)
//{
//	double increm;
//	int i,j,k,points;
//
//	p=p;
//	if((n_args % 2) != 0) {
//		fprintf(stderr,"Something wrong with phrase, check args for mix setline\n");
//		closesf();
//	}
//
//	lineset = 1;   /* initialized array */
//	increm = (double)(pp[n_args - 2] - pp[0])/(double)SIZE;
//	for(j=0,i=0; j < (n_args-2); j += 2) {
//		points = (int)((double)(pp[j+2] - pp[j]) / increm +.5);
//		if(pp[j+2] != pp[j]) {
//			if(points <= 0) points = 1;
//			if((pp[j+2] < pp[j]) || (points > SIZE)) {
//				fprintf(stderr," confusion on phrase card\n");
//				closesf();
//				}
//			for(k=0; k < points; k++) {
//				array[i++] = ((float)k/(float)points)
//					* (pp[j+3] - pp[j+1]) + pp[j+1];
//				if(i == SIZE) return(0.0);
//			}
//		}
//	}
//	i--;
//	while(++i < SIZE) array[i] = array[i-1]; 
//	return(0.0);
//}

//int FSPACE = 512;   /* initial allocation of space for farrays, in 4byte words. 
//	       	   * better initial guess will result in better use
//		   * of memory allocations */
void
profile(void)
{
	UG_INTRO("trans", trans);
	UG_INTRO("reset",reset);
	UG_INTRO("setline",setline);
}
